        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h

*
* Rpertoire ALGB d'installation
* Ne pas oublier de modifier le checksum dans INIT
*

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )


*******************************************************************
***************   SCST
            CON(2) ((SCSTfin)-(SCSTdeb))/2
SCSTdeb   NIBASC /SCST/
SCSTfin   CON(2) ((SCSTfin)-(SCSTdeb))/2
RPL
$ "{ { \22ARIT\22  { LCM GCD1 GCD3 DIVIS SIMP2 \n { \22Q\22  EPS LOG NEG FIX  Q  \n   DOALL STD  } } TMENU  }\n {\22MATR\22  { rref TRAN TR MAD lu idn } TMENU }\n {\22FACT\22  { FCOEF FROOTS FACTO } TMENU }\n {\22CONV\22  { AXL SXL S2L L2S EXPA COLC } TMENU}\n {\22MISC\22  { EXEC HORN PTAYL DEGRE } TMENU }\n { \22JAZZ\22  { ASS DIS SDB ED EC DOB } TMENU  }\n }"
ASSEMBLE
SCST      CON(5) (SCST)-(SCSTdeb)+2
*******************  SCST
*******************************************************************

*******************************************************************
***************     GETALL
            CON(2) ((GETALLfin)-(GETALLdeb))/2
GETALLdeb   NIBASC /GETALL/
GETALLfin   CON(2) ((GETALLfin)-(GETALLdeb))/2
RPL
::
{ ID MATR ID INTG ID FUNC ID QUADR ID ARIT ID TSIMP ID fr ID us }
DUP xKGET xORDER
;
ASSEMBLE
GETALL      CON(5) (GETALL)-(GETALLdeb)+2
***************    GETALL
*******************************************************************

*******************************************************************
***************     SENDIR
            CON(2) ((SENDIRfin)-(SENDIRdeb))/2
SENDIRdeb   NIBASC /SENDIR/
SENDIRfin   CON(2) ((SENDIRfin)-(SENDIRdeb))/2
RPL
::
DOBINT ALROMID UNCOERCE "0" >TAG xRCL
' LAM algb ONE
DOBIND
' LAM algb xSEND
ABND
;
ASSEMBLE
SENDIR      CON(5) (SENDIR)-(SENDIRdeb)+2
***************    SENDIR
*******************************************************************

*******************************************************************
***************     SETFR
            CON(2) ((SETFRfin)-(SETFRdeb))/2
SETFRdeb   NIBASC /SETFR/
SETFRfin   CON(2) ((SETFRfin)-(SETFRdeb))/2
RPL
::
x\<<
{ HXS 10 0FF01040C8300003
  HXS 10 00C7000000000048
  }
xSTOF
x\>>
;
ASSEMBLE
SETFR      CON(5) (SETFR)-(SETFRdeb)+2
***************    SETFR
*******************************************************************

*******************************************************************
***************     UKEYS
            CON(2) ((UKEYSfin)-(UKEYSdeb))/2
UKEYSdeb   NIBASC /UKEYS/
UKEYSfin   CON(2) ((UKEYSfin)-(UKEYSdeb))/2
RPL
$ "{ XQ 33.2 XNUM 33.3 L2S 33.6\n FDER 41.6 FINT 42.6 SQRT 44.6 POWER 45.6 MAD 46.6\n CHS 52.6 \n FROOTS 62.6 EXPA 64.6 DIV1 65.6\n tEVAL 72.6 EXEC 73.6 COLC 74.6 MULT 75.6 \n AXL 84.6 SUBT 85.6\n  13 CF  82.6   13 SF  83.6 \n rref 94.6 add 95.6\n }"
ASSEMBLE
UKEYS      CON(5) (UKEYS)-(UKEYSdeb)+2
***************    UKEYS
*******************************************************************

*******************************************************************
***************     PURG
            CON(2) ((PURGfin)-(PURGdeb))/2
PURGdeb   NIBASC /PURG/
PURGfin   CON(2) ((PURGfin)-(PURGdeb))/2
RPL
::
xHOME ' ID ALGB xPGDIR
;
ASSEMBLE
PURG      CON(5) (PURG)-(PURGdeb)+2
***************    PURG
*******************************************************************

*********************************************************************
*************     INIT
dernier     CON(2) ((INITfin)-(INITdeb))/2
INITdeb     NIBASC /INIT/
INITfin     CON(2) ((INITfin)-(INITdeb))/2
RPL
::
' VERNUMext ROMPTR@
ITE :: VERSION% %= ;
    FALSE
NOTcase :: BlankDA12
           xMEM  % 27000 %-
           DUP %0<
           case :: %CHS DO>STR " bytes" &$
                   "Lack of " SWAP &$ FlashWarning
                   DROP ;
           DROP
           "Installing ALGB.LIB,"
           DISPROW2
           "Your HP will warmstart"
           DISPROW3
           "After the warmstart,"
           DISPROW4
           "type ALGB and INIT"
           DISPROW5
           ' ID ALGB.LIB DUPDUP xKGET
           @ DROPSWAP PURGE %0 xSTO
           CODE
               GOVLNG =Warmstart
               ENDCODE
           ;
xMEM  % 2000 %-
DUP %0<
case :: %CHS DO>STR " bytes" &$
        "Lack of " SWAP &$ FlashWarning
        DROP ;
DROP CONTEXT@ xVER DROP CONTEXT!
' ID UKEYS xRCL EVAL palparse DROP xSTOKEYS
BlankDA12
"Assigning USERKeys" DISPROW2
"Compressing..." DISPROW3
' ID UserKeys DUP RclHiddenVar DROP
* remplace les { } par des NULL{}
' :: DUPTYPELIST? NOT?SEMI
     DUPNULL{}? casedrop NULL{}
     INNERDUP
     ZERO_DO
            DUP #1+ROLL 1GETLAM EVAL
            SWAPLOOP
     {}N
     ;
DUP1LAMBIND EVAL
( UserKeys, contenu )
DUP xBYTES DROP ' ID UserKeys.CRC
StoHiddenVar SWAP StoHiddenVar
"Done." DISPROW4
"Creating CST menu" DISPROW6
"and will reboot" DISPROW7
' ID SCST xRCL EVAL palparse DROP ' ID CST ?STO_HERE
ONE SetUserFlag SETQext
( WarmStart )
CODE
    GOVLNG =Warmstart
    ENDCODE
;
* ASSEMBLE
* INIT        CON(5) (INIT)-(INITdeb)+2
*****************  INIT
*********************************************************************
