* -*- mode:Mail -*-
        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h
	
* Rpertoire INTG

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )

*******************************************************************
***************   VX
            CON(2) ((VXfin)-(VXdeb))/2
VXdeb   NIBASC /VX/
VXfin   CON(2) ((VXfin)-(VXdeb))/2
RPL
ID X
ASSEMBLE
VX      CON(5) (VX)-(VXdeb)+2
*******************  VX
*******************************************************************

*******************************************************************
***************     PRIMIT
            CON(2) ((PRIMITfin)-(PRIMITdeb))/2
PRIMITdeb   NIBASC /PRIMIT/
PRIMITfin   CON(2) ((PRIMITfin)-(PRIMITdeb))/2
RPL
SYMBOL ID X xLN ;
ASSEMBLE
PRIMIT      CON(5) (PRIMIT)-(PRIMITdeb)+2
***************    PRIMIT
*******************************************************************

*******************************************************************
***************     LIN
* Linarisation d'un polynme en cos, sin ou cosh, sinh
* P[s,c] algebrique ou liste de listes -> symb
* complexe (expc,exps) donne linarisation du monome c^expc*s^exps
            CON(2) ((LINfin)-(LINdeb))/2
LINdeb   NIBASC /LIN/
LINfin   CON(2) ((LINfin)-(LINdeb))/2
RPL
::
CK1NOLASTWD
:: CK&DISPATCH1
   list NOP
   symb :: { ID s ID c } VXXLext SWAPDROP ;
   TWO :: C%>% SWAP COERCE2 %1 %0 ROT NDUPN #1+
          {}N %0 ROT NDUPN #1+ {}N
          ;
;
( cration de liste de liste )
TRIMext
' :: NOTLISTcase ONE{}N ;
1LAMBIND LISTSECOext ABND
( affichage du menu )
"COSH" NULL$ DUP 2DUP "COS" MENUext
% 300 % .2 DOBEEP
WaitForKey DROP kcMenuKey6 #<>
SWAP
( stack= true or false, { a0,..., an} )
ZEROZERO 
* valeur nulle pour le degr du polynome en sin/cos  
* et pour le degre maximal actuel en cos 
' :: 
   ( ak[c] ->  ak )
   INNERDUP #1= casedrop ONE{}N
   ( stack= c, ca0, .., can, #n+1)
   { %1 %0 %1 }
   ( ca0, ..., can, #n+1, c )
   SWAP get1
   ( ca1, ..., can, c, #n+1, ca0)
   UNROT %1 UNROT
   ( ca1, ..., can, ca0, %1, c, #n+1)
   DUP #1+SWAP
   ( ca1, ..., can, ca0, %1, c, #n+2, #n+1 )
   ONE_DO (DO)
          ( cak,...,can, cb0, cb1, ..., cbk-1, %2^k-1, c, #n+2 )
          get1
          ( cak+1,...,can, cb0, cb1, ..., cbk-1, %2^k-1, c, #n+2, cak )
          4ROLL %2 %* DUP 5UNROLL RMULText
          ( cak+1,...,can, cb0, cb1, ..., cbk-1, %2^k, c, #n+2, cak*%2^k )
          %0 INDEX@ NDUPN #1+ {}N
          5PICK 4PICK RMULText RADDext
          4UNROLL
          LOOP
   ( cb0, cb1, ..., cbn, %2^n, c, #n+2)
   4UNROLL 2DROP
   ( cb0, ..., cbn-1, #n+2, cbn )
   OVER UNROLL #1-{}N
   ( { cbn cb0 ... cbn-1 } )
   CARCOMP
   ( cbn= liste )
   ( fin de HORNext modifie pour listes )
   ;
' NULLLAM DUPDUP THREE DOBIND
( fin de lam binding )
( dtermine le degre du polynome dans LAM3, le degre max en cos dans LAM2 )
DUPINCOMP
ZERO_DO (DO)
        LENCOMP DUPINDEX@ #+-1 3GETLAM #MAX 3PUTLAM 2GETLAM #MAX 2PUTLAM
        LOOP
( flag, { a0, ..., an } )
DUP CDRCOMP SWAP CARCOMP 2GETLAM #1- LRDMext >HCOMP
LISTSECOext
INNERDUP 3PUTLAM
get1 1PUTLAM
( a0, ..., an, #n+1 )
:: DUP#1= caseDROP
   { %1 %0 %-1 }
   ( a0, ..., an, #n+1, s )
   SWAP get1
   ( a1, ..., an, s, #n+1, a0)
   UNROT %1 UNROT
   ( a1, ..., an, a0, %1, s, #n+1)
   DUP #1+SWAP
   ( a1, ..., an, a0, %1, s, #n+2, #n+1 )
   ONE_DO (DO)
          ( ak,...,an, b0, b1, ..., bk-1, %2^k-1, s, #n+2 )
          get1
          ( ak+1,...,an, b0, b1, ..., bk-1, %2^k-1, s, #n+2, ak )
          4ROLL %2 %* DUP 5UNROLL
          ( ak+1,...,an, b0, b1, ..., bk-1, %2^k, s, #n+2, ak , %2^k )
          2GETLAM 3PICK LENCOMP TWO #/ #+ #-
          ( ajustement ncessaire pour la longueur de ak et son coef )
          ( ak+1,...,an, b0, b1, ..., bk-1, %2^k, s, #n+2, ak , %2^k, # )
          DUP4UNROLL %2 SWAP UNCOERCE %^ %* RMULText
          ( ak+1,...,an, b0, b1, ..., bk-1, %2^k, s, #n+2, #, ak*%2^k*%2^# )
          %0 ROT INDEX@ #+ NDUPN {}N &COMP
          5PICK 4PICK
          ( multiplie par -1 une fois sur 2 )
          1GETLAM IT :: ISTOP-INDEX TWO #/ DROP #0=case RNEGext ;
          RMULText RADDext
          4UNROLL
          LOOP
   ( b0, b1, ..., bn, %2^n, s, #n+2)
   4UNROLL 2DROP
   ( b0, ..., bn-1, #n+2, bn )
   OVER UNROLL #1-{}N
   ( {bn b0 ... bn-1 } )
   CARCOMP
   ;
( bn= liste symtrique des coefficients de e^[i]x en puissances dc. )
( fin de HORNext modifie pour listes )
( redimensionne la liste par ajout de %0 en dbut si ncessaire )
2GETLAM 3GETLAM #+ #2- #2* LRDMext
DUPLENCOMP #2/ ( #n ) UNCOERCE %2 SWAP x^
( { coef cos}, { coef sin }, denominateur )
2PUTLAM
( ajustement de la longueur = longueur du monome de plus haut degre )
DUPINCOMP DUP #1=case :: DROPSWAPDROP 2GETLAM RDIVext ABND ;
reversym {}N
2DUP RADDext UNROT RSUBext
( { coef des cos }, { coef des sin } )
DUPLENCOMP TWO #/ #+ DUPUNROT
( { coef cos }, #n+1, { coef sin }, #n+1 )
ONESWAP SUBCOMP INNERCOMP ' ID VX XEQRCL UNROT
( coef de sin[nx],..., x, 0, #n+1 )
ONE_DO (DO)
       ( coef de sin[nx],..., x, alg )
       INDEX@ UNCOERCE 3PICK x* 1GETLAM ITE xSIN xSINH
       4ROLL 2GETLAM RDIVext SWAP x* x+
       LOOP
SWAPDROP UNROT
( algb, { coef cos }, #n+1 )
ONESWAP SUBCOMP INNERCOMP
( algb, meta )
SWAP %2 RDIVext SWAP
get1 SWAP' ID VX XEQRCL UNROT
( coefs, x, algb, #n+1 )
ZERO_DO (DO)
       ( coef de cos[nx],..., x, alg )
       INDEX@ UNCOERCE 3PICK x* 1GETLAM ITE xCOS xCOSH
       4ROLL 2GETLAM RDIVext SWAP x* x+
       LOOP
SWAPDROP ABND
;
ASSEMBLE
LIN      CON(5) (LIN)-(LINdeb)+2
***************    LIN
*******************************************************************


*********************************************************************
*************     LDEC
* R\'esolution de syst\`emes d'\'equa diff lin\'eaires du 1er ordre
* \`a coeff constants
* ( x1', x2', ..., xn') = A (x1, ..., xn ) + b
* A matrice nxn, b vecteur de n fonctions
* B transformee de Laplace de b, c vecteur de condtions initiales
* stk2= A, stk1= B+c -> (p-A)^-1*pcar, pcar, (p-A)^-1*(B+c)
            CON(2) ((LDECfin)-(LDECdeb))/2
LDECdeb     NIBASC /LDEC/
LDECfin     CON(2) ((LDECfin)-(LDECdeb))/2
RPL
::
CK2NOLASTWD
NOTLISTcase SETTYPEERR 
CKFPOLYext SWAP DTYPENDO? NcaseTYPEERR
DUPLENCOMP 3PICK LENCOMP #= NcaseTYPEERR
:: internalflag TestUserFlag ?SEMI
   ( mettre x en tete de liste des variables )
   TWO{}N DUP
   :: LISTOPext
      LVARDext ROTDROP ' ID VX XEQRCL
      ( symb, lvar, vx )
      2DUP EQUALPOSCOMP
      ( symb, lvar, vx, # pos )
      DUP#0= casedrop >HCOMP
      ROTDUP CARCOMP
      ( symb, vx, #pos, lvar, 1st of lvar )
      UNROT PUTLIST
      ( symb, vx, lvar sans 1er lment )
      ONESWAP PUTLIST
      ;
   SWAPDROP
   VXXLext INCOMPDROP
   'REVAL 
   ( [p-A]^-1*pcar, pcar, [p-A]^-1*v )
   TWO ZERO ONE THREE{}N FROMLISText SWAP xCOLC DUPUNROT ' x/ LOPAext
   ;
:: 
MADJext 2SWAP 2DROP
( lvar, v, M[A,p], pcar )
SWAPINCOMP DUPDUP
( lvar, v, pcar, A1, ..., An, #n, #l )
' NULLLAM DUPTWO DOBIND
( lam1= nbre de lignes des matrices, lam2= nombre de matrices )
ZERO_DO (DO)
	INDEX@ 2PUTLAM
	1GETLAM ZERO_DO (DO)
		1GETLAM ZERO_DO (DO)
			( lvar, v, pcar, An, ..., A1, l1, ..., lj, a1, ..., ak )
			1GETLAM JINDEX@ #+ 2GETLAM #+PICK 2GETLAM #1+ NTHCOMPDROP
			JINDEX@ #1+ NTHCOMPDROP
			LOOP
		1GETLAM {}N
		LOOP
	1GETLAM {}N
	LOOP
1GETLAM {}N
1GETLAM DUPUNROT #2+UNROLL NDROP
( v, pcar, [p-A]^-1 )
DUP 4ROLL MVMULText
( pcar, [p-A]^-1, [p-A]^-1*v )
ROTSWAP
( [p-A]^-1*pcar, pcar, [p-A]^-1*v )
;
;
ASSEMBLE
LDEC        CON(5) (LDEC)-(LDECdeb)+2
*****************  LDEC
*********************************************************************


*********************************************************************
*************     PEVAL
            CON(2) ((PEVALfin)-(PEVALdeb))/2
PEVALdeb     NIBASC /PEVAL/
PEVALfin     CON(2) ((PEVALfin)-(PEVALdeb))/2
RPL
::
CK3NOLASTWD
( primitive, borne inf, borne sup -> algbrique )
CK&DISPATCH1
# A00 :: ' ID VX XEQRCL DUP4UNROLL
         ( primitive, vx, borne sup, borne inf, vx )
         SWAP
         5PICK UNROT MEVALext
         ( primitive, vx, borne sup, val_inf )
         4UNROLL MEVALext
         ( val_inf, val_sup )
         RSUBext
         ;
;
ASSEMBLE
PEVAL        CON(5) (PEVAL)-(PEVALdeb)+2
*****************  PEVAL
*********************************************************************

*********************************************************************
*************     RISCH
            CON(2) ((RISCHfin)-(RISCHdeb))/2
RISCHdeb     NIBASC /RISCH/
RISCHfin     CON(2) ((RISCHfin)-(RISCHdeb))/2
RPL
::
CK1NOLASTWD 
( algorithme de Risch: symb -> primitive )
* symb devrait auparavant etre passe par TSIMP
* 1ere etape: recherche des extensions successives (lvar et dlvar)
* 2eme etape: appel de la routine d'integration
* 3eme etape: appel de MEVALext s'il y a des bornes
( LAM 21: non implemente! )
' ::	" not handled" &$ EXITMSGSTO
	# 70000 ERRORSTO
	ERRJMP
	;
( LAM 20 obj -> # : #=0 sauf si obj est un entier positif )
' ::	TRIMOBJext dREALNcase DROPZERO
	DUPDUP %FLOOR %=
	ITE COERCE DROPZERO
	;					
' ::	( LAM 19 )
	( dlvar, Laurent, result, n/d, l=1, l>1, flag )
	( ->  dlvar, Laurent, result, n/d, l=1, l>1 )
	6PICK 
	DUPTYPELIST? ITE LENCOMP DROPZERO
	( dlvar, Laurent, result, n/d, l=1, l>1, flag, # )
	DUP#0=csedrp DROP
	OVER
	( dlvar, Laurent, result, n/d, l=1, l>1, flag, #, flag )
	ITE ZERO ONE
	( dlvar, Laurent, result, n/d, l=1, l>1, flag, #, #0 ou #1 )
	2DUP#= case2drop DROP
	ROT NINE UNROLL
	DO	
		( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1 )
		ISTOP-INDEX UNCOERCE 8PICK IT %CHS 
		( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1, k )
		6ROLL INNERCOMP #1-{}N 7UNROLL
		( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1, k, ak )
		::	num0case 2DROP
			18GETLAM EVAL
			( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1, bk )
			ONE{}N symcomp %1 %0 ISTOP-INDEX NDUPN #1+ {}N
			( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1, {bk}, { 1 ..0 } )
			symcomp NINE PICK ITE :: ' x/ ; 'x* EvalNoCK
			5ROLL SWAP ' x+ EvalNoCK 4UNROLL
			( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1 )
			;
		LOOP
	( flag, dlvar, Laurent, result, n/d, l=1, l>1 )
	7ROLL DROP
	;

' ::	( LAM18 dlvar, Laurent, result, n/d, l=1, l>1, k, ak )
	( -> dlvar, Laurent, result, n/d, l=1, l>1, bk )
	( teste la validite de dlvar )
	8PICK CARCOMP %1 EQUAL NOTcase :: "EXP<EXP/LN" 21GETLAM EVAL ;
	( on factorise le denominateur de ak )
	NULL{} 16GETLAM EVAL
	( n/d, l=1, l>1, k, nk/dk, lfacdk )
	( pour l'instant je ne teste pas avec la liste l=1 )
	( qui est normalement vide )
	::	DUPNULL{}? case 4ROLL 
		4ROLL DUPNULL{}? ?SEMI
		ONE SQFF2ext DROP
		;
	( n/d, l=1, k, nk/dk, lfacdk, l>1 )
	DUP 5UNROLL
	( n/d, l=1, l>1, k, nk/dk, lfacdk, l>1 )
	( on traite les facteurs tq beta<>0, alors alpha=gamma-beta )
	[BEGIN]
		( lfacdk, l>1 )
		DUPNULL{}?
	NOT_WHILE ::
		( lfacdk, l>1 )
		INNERCOMP #2- {}N 4UNROLL
		( l>1, lfacdk, f, beta=#mul_l>1 )
		ROTDUP 4ROLL
		( l>1, #mul_l>1, lfacdk, lfacdk, f )
		EQUALPOSCOMP
		( l>1, #mul_l>1, lfacdk, # )
		DUP#0=csedrp ( gamma=0 ) UNROTDROP
		2DUP #1+ NTHCOMPDROP
		( l>1, #mul_l>1, lfacdk, #pos, %mul_lfacdk )
		%ABSCOERCE 4ROLL
		( l>1, lfacdk, #pos, gamma=#mul_lfacdk, beta=#mul_l>1 )
		2DUP#< IT 2DROP00 #- SWAP#1+ ROT
		( l>1, #mul_lfacdk-#mul_l>1, #pos, lfacdk )
		PUTLIST SWAP
		( l>1, lfacdk )
		;
	[REPEAT]
	DROP
	( si beta=0, on prend gamma-1 )
	( n/d, l=1, l>1, k, nk/dk, lfacdk )
	NULL{} SWAP
	[BEGIN]
		( newlfacdk, lfacdk )
		DUPNULL{}?
	NOT_WHILE ::
		( newlfacdk, lfacdk )
		INNERCOMP #2- {}N 4UNROLL
		( lfacdk, newlfacdk,  f, m )
		DUPTYPEREAL? IT :: %CHS %1- COERCE ;
		DUP#0= case2drop SWAP
		UNROT >TCOMP SWAP >TCOMP SWAP
		;
	[REPEAT]
	DROPTRUE
	( n/d, l=1, l>1, k, nk/dk, lfacdk, TRUE )
	RESOROMP RMULText ( -> lam2 )
	' :: 2GETLAM MPext ; ( -> lam1 )
	FACTOOBJext FXNDext DROP
	( n/d, l=1, l>1, k, nk/dk, D )
	( calcul de l'equa diff polynomiale )
	( y' + k n/d y = nk/ dk devient )
	( D d dk Y' + [ k* n* dk* D - D' dk d ] Y = nk D d )
	( n/d, l=1, l>1, k, nk/dk, D )
	6PICK FXNDext
	( n/d, l=1, l>1, k, nk/dk, D, n, d )
	4ROLL FXNDext
	( dlvar, Laurent, result, n/d, l=1, l>1, k, D, n, d, nk, dk )
	5PICK THIRTEEN PICK 2GETEVAL
	( dlvar, Laurent, n/d, l=1, l>1, k, D, n, d, nk, dk, D' )
	OVER5PICK RMULText
	( n/d, l=1, l>1, k, D, n, d, nk, dk, D', dk d )
	DUP 8PICK RMULText NINE UNROLL
	( n/d, l=1, l>1, D dk d, k, D, n, d, nk, dk, D', dk d )
	RMULText SWAP
	( n/d, l=1, l>1, D dk d, k, D, n, d, nk, D' dk d, dk )
	7ROLL RMULText
	( n/d, l=1, l>1, D dk d, D, n, d, nk, D' dk d, k dk )
	6PICK RMULText 5ROLL RMULText
	( n/d, l=1, l>1, D dk d, D, d, nk, D' dk d, k dk D n )
	SWAP RSUBext 4UNROLL
	( n/d, l=1, l>1, D dk d, k n dk D -D' dk, D, d, nk )
	RMULText OVERDUP 6UNROLL RMULText RMULText
	( n/d, l=1, l>1, D, D d dk, k n dk D -D' dk d, nk d D^2 )
	THREE{}N TRLPGCDext LOPDext INNERCOMP
	( n/d, l=1, l>1, D, R, S, T, #3 )
	( avec R Y' + S Y = T )
	( calcul du degre de Y: deg[R]-1<deg[S] -> deg[T]-deg[S] )
	( si > -> deg[T]-deg[R]+1 )
	ZERO_DO (DO)
		DUPTYPELIST? ?SKIP ONE{}N UNROT
		LOOP
	( dlvar, Laurent, result, n/d, l=1, l>1, D, R, S, T )
	DUP DEGREext
	( n/d, l=1, l>1, D, R, S, T, deg[T] )
	2OVER DEGREext SWAP DEGREext
	( n/d, l=1, l>1, D, R, S, T, deg[T], deg[S], deg[R] )
	::	DUP#0=csedrp :: DUPUNROT 2DUP#< NOTcase #- 10GETLAM EVAL ;
		#1- 2DUP#=
		casedrop ::	( en cas d'egalite )
				( R, S, T, t, s )
				DUPUNROT 2DUP#< IT 2DROP00 #-
				( R, S, T, s, t-s )
				4PICK CARCOMP 6PICK CARCOMP RDIVext RNEGext
				( R, S, T, s, t-s, Ss/Rr )
				20GETLAM EVAL #MAX
				;
		#MAX DUPUNROT 2DUP#< NOTcase #- 2DROP ZERO
		;
	( n/d, l=1, l>1, D, R, S, T, s ou r-1, y=deg[Y] )
	( construction des matrices S et R )
	( taille des matrices: y+s+2 lignes, y+1 colonnes )
	#1+ DUPUNROT #+
	( ..., R, S, T, y+1, y+s+1 )
	5ROLL 5ROLL
	( ..., T, y+1, y+s+1, R, S )
	NULL{} 5PICK 
	ZERO_DO (DO)
		( y+1, y+s+1, R, S, matrice transposee )
		( creation de la ligne index@ en partant du bas )
		SWAPDUP %0 >TCOMP UNROT
		( y+1, y+s+1, R, S+0, matrice transposee, S )
		INDEX@
		::	DUP#0=csedrp NOP
			( y+1, y+s+1, R, S+0, matrice transposee, S, # )
			5ROLL DUP %0 >TCOMP
			( y+1, y+s+1, S+0, matrice transposee, S, #, R, R+0 )
			6UNROLL SWAP UNCOERCE RMULText RADDext
			( y+1, y+s+1, R, S+0, matrice transposee, S+#*R )
			;
		( y+1, y+s+1, R[+0], S+0, matrice transposee, S+#*R )
		5PICK #1- LRDMext >HCOMP
		LOOP
	( y+1, y+s+1, R, S, matrice transposee )
	UNROT2DROP
	( ..., T, y+1, y+s+1, R+S transpose )
	SWAP 4ROLLSWAP #1- LRDMext >TCOMP TRANext
	( n/d, l=1, l>1, D, y+1, matrice )
	( rref de R Y' + S Y = T )
	rrefext SWAPDROP
	( n/d, l=1, l>1, D, y+1, matrice reduite )
	( on enleve les zeros )
	INNERCOMP reversym {}N TRIMext
	( il doit rester y+1 lignes non nulles )
	( n/d, l=1, l>1, D, y+1, matrice reduite )
	( test de compatibilite et calcul de Y )
	INNERCOMP reversym get1 2DUP #<>case :: 10GETLAM EVAL ;
	( n/d, l=1, l>1, D, ligne1, ..., ligney+1, #y+1, #y+1 )
	#1-SWAP
	ZERO_DO (DO)
		::	( ligne1, ..., ligney+1, #y )
			get1 NOTLISTcase :: 10GETLAM EVAL ;
			( ligne2, ..., ligney+1, #y, ligne1 )
			INNERCOMP DUP#1= case :: 10GETLAM EVAL ;
			( ligne2, ..., ligney+1, #y, c1, ..., cn, #n )
			#2- DUPUNROT #2+UNROLL NDROP
			( ligne2, ..., ligney+1, #y, c1, cn )
			SWAP RDIVext SWAP
			( ligne2, ..., ligney+1, -cn/c1, #y )
			;
		LOOP
	#1+ {}N
	( n/d, l=1, l>1, D, Y )
	SWAP RDIVext
	( n/d, l=1, l>1, bk=Y/D )
	;
' ::	( LAM17 )
	( pk, n, d' -> pk, n/d'[pk] ) 
	3PICK HORNext UNROT2DROP
	( pk, n, d'[pk] )
	SWAP3PICK HORNext UNROT2DROP
	( pk, d'[pk], n[pk] )
	SWAP RDIVext ONE{}N 
	( pk, n/d'[pk] )
	;
' ::	( LAM16 )
	( symb, lvar -> n/d, lfac )
	THREE RFACT2ext
	( [lvar], n/d, lfac )
	( on elimine les facteurs du numerateur )
	DUPNULL{}?
	?SKIP
	::	INNERDUP #1-SWAP #2/
		ZERO_DO (DO)
			( f1, m1, ..., fk, mk, #2k-1 )
			get1 SWAP get1 DUP %0<
			( f2, ..., fk, mk, f1, #2k-1, m1, ?m1<0 )
			ITE 	SWAP
			    ::	DROPSWAPDROP #2- 
				;
			LOOP
		#1+ {}N
		;
	ROTDROP
	;
' ::	( LAM 15: )
	( log, lvar, dlvar, result, ak, bk+1, #k -> log, lvar, dlvar, bk, result )
	6UNROLL TWO{}N
	( log, #k, lvar, dlvar, result, { ak, bk+1 } )
	ONESWAP 5PICK CDRCOMP
	( log, #k, lvar, dlvar, result, #0, { ak bk+1}, lvar' )
	VALOBJext 
	( log, #k, lvar, dlvar, result, { ak, bk+1 } )
	4PICK CDRCOMP VXXLext INCOMPDROP
	( log, #k, lvar, dlvar, result, lvar', ak, bk+1 )
	5PICK CARCOMP 14GETLAM EVAL RMULText
	( log, #k, lvar, dlvar, result, lvar', ak, bk+1*theta' )
	7PICK #1+ UNCOERCE RMULText RSUBext
	( log, #k, lvar, dlvar, result, lvar', ak-[k+1]*bk+1*theta' )
	SWAP 4PICK CDRCOMP 8PICK 4UNROLL FALSE
	( log, #k, lvar, dlvar, result, log, ak, lvar', dlvar', FALSE )
	3GETLAM EVAL
	( log, #k, lvar, dlvar, result, [k+1]*Bk+1, bk | ERREUR )
	SWAP 6PICK #1+ UNCOERCE RDIVext OVER
	( log, #k, lvar, dlvar, result, bk, Bk+1, bk | ERREUR )
	%0 8ROLL NDUPN #2+ {}N TRIMOBJext symcomp
	( log, lvar, dlvar, result, bk, [bk+Bk+1*x]*x^k  )
	ROTSWAP ' x+ EvalNoCK
	( log, lvar, dlvar, bk, result  )
	7GETLAM EVAL
	;

( LAM 14: obj -> obj descendu d'1 en profondeur )
' ::	FXNDext DUPTYPELIST? IT CARCOMP 
	SWAP DUPTYPELIST? IT CARCOMP 
	SWAP NDXFext
	;
( LAM 13: obj -> TRUE|FALSE : teste un coef cst profondeur 1 )
' ::	NOTLISTcase DROPTRUE LENCOMP #1=
	;
( LAM 12: somme des ck )
%0
( LAM 11: contenu de r^# )
%0
( LAM 10 )
' ::	"No closed form." EXITMSGSTO
	# 70000 ERRORSTO
	ERRJMP
	;
( LAM 9 )
ZERO
' ::	( LAM8 obj, # -> obj ou ERREUR )
	( teste si un objet est constant jusqu'a la profondeur # )
	DUP#0=csDROP
	OVER FXNDext
	( obj, #, num, deno )
	DUPTYPELIST?
	::	NOTcaseDROP 
		( #, num, deno )
		INNERCOMP 
		#1=case ::	( #, num, deno )
				3PICK #1- 8GETLAM EVAL
				DROP
				( #, num )
				;
		10GETLAM EVAL
		;
	( obj, #, num )
	DUPTYPELIST?
	NOTcase2DROP
	( obj, #, num )
	INNERCOMP #1=case :: SWAP#1- 8GETLAM EVAL DROP ;
	10GETLAM EVAL
	;
' ::	( LAM 7 )
	( symb -> symb )
	DUPTYPESYMB? NOT?SEMI
	INNERCOMP DUP#1= case SYMBN
	OVER EQ: x+
	( s1, ..., sk, #k, ?sk=+ )
	4PICK %0 EQUAL AND
	NOTcase SYMBN
	UNROT2DROP #2- SYMBN
	( si symb se termine par 0+ on l'enleve )
	;

( LAM 6 )
RESOROMP RMULText 

' ::	( LAM5 partie logarithmique )
	( result, lfac, q2, d2', log -> result, coeflog )
	( on teste si q2/d2' est constant, ce cas est facile! )
	4PICK DUPNULL{}? case 5DROP
	DROP 
	( result, lfac, q2, d2', log  )
	( tous les log sont-ils autorises ? )
	DUPNULL{}?
	NOTcase ::	( result, lfac, q2, d2', autorise )
			4ROLL PIext
			EQUALNOTcase :: 10GETLAM EVAL ;
			( result, q2, d2' )
			%0 UNROT 17GETLAM EVAL 
			9GETLAM 8GETLAM EVAL SWAPDROP
			( result, coeflog=q2/d2'[0] )
			;
	( result, lfac, q2, d2', null{}  )
	DROP RDIVext 
	( result, lfac, q2/d2'  )
	FXNDext DUP 13GETLAM EVAL 3PICK 13GETLAM EVAL 
	( result, lfac, q2, d2', constant/var principale? )
	ANDcase ::	NDXFext 9GETLAM 8GETLAM EVAL
		( result, lfac, q2/d2' )
		2DUPSWAP LENCOMP 
		( result, lfac, q2/d2', q2/d2', #racines )
		UNCOERCE RMULText 12GETLAM RADDext 12PUTLAM
		( result, lfac, q2/d2' )
		symcomp SWAP PIext symcomp 
		' xLN EvalNoCK 'x* EvalNoCK ' x+ EvalNoCK %0
		( result, coeflog )
		;
	( result, lfac, q2, d2' )
	THREE 4ROLL 
	( result, q2, d2', #3, lfac )
	( maintenant on factorise lfac -> lrac )
	INNERCOMP NULL{} SWAP
	ZERO_DO (DO)
		SWAP EVIDENText SOLVext &COMP &COMP
		LOOP
	( result, q2, d2', #3, lrac )
	INNERCOMP
	( result, q2, d2', #3, r1, ..., rk, #k )
	psh DROP
	( r1, ..., rk, #k, result, q2, d2' )
	4ROLL
	ZERO_DO (DO)
		( r1, ..., rk, result, q2, d2' )
		2DUP 6ROLL UNROT 
		( r1, ..., rk-1, result, q2, d2', rk, q2, d2' )
		17GETLAM EVAL 9GETLAM 8GETLAM EVAL
		( r1, ..., rk-1, result, q2, d2', rk, q2/d2'[rk] )
		12GETLAM OVER RADDext 12PUTLAM symcomp
		( r1, ..., rk-1, result, q2, d2', rk, q2/d2'[rk] )
		%1 ROT RNEGext TWO{}N symcomp ' xLN EvalNoCK
		( r1, ..., rk-1, result, q2, d2', q2/d2'[rk], ln[x-rk] )
		'x* EvalNoCK
		( r1, ..., rk-1, result, q2, d2', ln[x-rk]*d2'[rk]/q2[rk] )
		4ROLLSWAP ' x+ EvalNoCK UNROT
		LOOP
	( result, q2, d2' )
	2DROP %0
	( result, coeflog )
	;

' ::	( LAM4 symb -> symb, x, lvarnx, lvarx )
	( ici on ne peut pas utiliser LVAR simplement )
	( car il faut tenir compte des racines carrees )
	LISTOPext LVARDext ROTDROPSWAP 
	( lvar, symb )
	' ID VX XEQRCL ROT
	( symb, x, lvar )
	DUPNULL{}?
	case DUP
	INNERCOMP
	( symb, v1, ..., vn, #n )
	get1 NULL{} DUP 4ROLL
	ZERO_DO (DO)
		( symb, v1, ..., vk, x, lvarnx, lvarx )
		3PICK 5ROLL
		( symb, v1, ..., vk-1, x, lvarnx, lvarx, x, vk )
		DUPUNROT DUPTYPESYMB?
		ITE :: SWAP EQUALPOSCOMP #0<> ;
			EQUAL
		( lastop, symb, v1, ..., vk-1, x, lvarnx, lvarx, vk, ?xinvk )
		ITE >HCOMP :: ROTSWAP >HCOMP SWAP ;
		LOOP
	( symb, x, lvarnx, lvarx )
	;



* Routine d'integration
' ::	( LAM3 )
( log autorise, symb , lvar, dlvar, flag -> coef du log  )
* flag est TRUE si symb est externe et FALSE si symb est interne
* 1ere etape: calcul de la partie rationnelle
* 2eme etape: partie logarithmique
* 3eme etape: calcul de la partie polynomiale generalisee
%0 6UNROLL %0 12PUTLAM
( coeflog, log, symb, lvar, dlvar, flag )
4PICK num0case :: 6DROP %0 ;
DROPOVER LENCOMP 9PUTLAM
4ROLLSWAP
( coeflog, log, lvar, dlvar, symb, flag )
ITE 3PICK NULL{}
16GETLAM EVAL
( coeflog, log, lvar, dlvar, n/d, lfac )
* on dtermine le type d'integration
4PICK CARCOMP DUPTYPESYMB?
IT :: DUPLENCOMP NTHCOMPDROP ;
( coeflog, log, lvar, dlvar, n/d, lfac, x ou exp ou ln )
* on spare la partie rationnelle propre

ROT FXNDext
( coeflog, log, lvar, dlvar, lfac, type, n, d )
DUPUNROT DIVext TRIMext
( coeflog, log, lvar, dlvar, lfac, type, d, p=n div d, q=n mod d )
* on teste si l'argument est purement polynomial i.e. d constant/var principale
3PICK DUPTYPELIST? ITE LENCOMP DROPONE
::	( partie polynomiale uniquement )
	#1=case ::	( coeflog, log, lvar, dlvar, lfac, type, d, p, q )
			DROP SWAPDROP
			( coeflog, log, lvar, dlvar, lfac, type, p )
			ROTDROP %0 DUP
			( coeflog, log, lvar, dlvar, type, p, Laurent, result )
			;

( partie rationnelle non vide )
( coeflog, log, lvar, dlvar, lfac, type, d, p=n div d, q=n mod d )
* pour le type EXP, il faut enlever la serie de Laurent en 0
4PICK EQ: xEXP
ITE	::	( lfac, type, d, p, q )
		5ROLL 
		( on enleve les zeros de la liste de facteurs )
		TRIMOBJext INNERDUP #1-SWAP #2/
		ZERO_DO 
			( f1, m1, ..., fk, mk, #2k-1 )
			get1 
			( m1, ..., fk, mk, #2k-1, f1 )
			DUPTYPELIST?
			IT ::	INNERCOMP
				BEGIN
					OVER %0 EQUAL
				WHILE
					SWAPDROP #1-
				REPEAT
				{}N
				;
			SWAP get1
			SWAPLOOP
		#1+ {}N
		5UNROLL
		( q/d=q/[d1*x^k]=q1/d1+s1/x^k )
		( s1=div en puissance croissante de q par d1 )
		( q1=reste de la div )
		( on determine d1 )
		ROT DUPLENCOMP
		( p, q, d, #d )
		SWAPINCOMP reversym {}N TRIMext
		( p, q, #d, d1 a l'envers )
		DUPLENCOMP ROTSWAP #-
		( p, q, d1 a l'envers, #k )
		DUP#0=csedrp :: INNERCOMP reversym {}N UNROT %0 ;
		( 0 est racine du denominateur )
		( p, q, d1 a l'envers, #k )
		UNROTSWAP INNERCOMP reversym {}N
		( p, #k, d1 a l'envers, q a l'envers )
		%0 3PICK LENCOMP 3PICK LENCOMP #- 
		5ROLL #+-1 NDUPN {}N
		( p, d1 a l'envers, q a l'envers, { %0 ... } )
		&COMP OVER DIVext
		( p, d1 a l'envers, s1 a l'envers, q1 a l'envers )
		INNERCOMP reversym {}N ROT
		( p, s1 a l'envers, q1, d1 a l'envers  )
		INNERCOMP reversym {}N 
		( p, s1 a l'envers, q1, d1 )
		4UNROLL SWAP
		( d1, p, q1, s1 a l'envers )
		;
	%0
( coeflog, log, lvar, dlvar, lfac, type, d1, p, q1, Laurent )
SWAP 6ROLL 
( coeflog, log, lvar, dlvar, type, d1, p, q1, Laurent, lfac )
( on ne garde que les facteurs polynomiaux )
TRIMOBJext INNERDUP #1-SWAP #2/
ZERO_DO (DO)
	( f1, m1, ..., fk, mk, #2k-1 )
	get1 SWAP get1 3PICK 13GETLAM EVAL
	( f2, ..., fk, mk, f1, #2k-1, m1, ?non-polynome )
	ITE ::	DROPSWAPDROP #2- 
		;
		SWAP
	LOOP
#1+ {}N
( coeflog, log, lvar, dlvar, type, d1, p, q1, Laurent, lfac )

%0

* Partie rationnelle et logarithmique
BEGIN
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac, resultat )
	( on cherche l'exposant max, est-il < a -1?)
	( lfac -> %-1 ou le min )
	%-1 3PICK INNERCOMP
	( lfac, result, %-1, f1, m1, ..., fk, mk, #2k )
	::	DUP#0=csDROP
		get1 SWAP #2/ 
		ZERO_DO	(DO)
			( f1, m1, ..., %-1 )
			%MIN SWAPDROP
			LOOP
		;
	DUP %-1 %<>
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac, result, %min, flag )
WHILE
	( on extrait les facteurs de multiplicite max )
	( lfac, result, %min -> lfac1, result, lfac2, # )
	( lfac1, result, %min )
	ROT INNERCOMP get1
	( result, f1, m1, ..., fk, mk, #2k, %min )
	NULL{} ROT #1+DUP #2/
	( result, f1, m1, ..., fk, mk, %min, lfac2, #2k+1, #k )
	ZERO_DO (DO)
		( result, f1, m1, ..., fk, mk, %min, lfac2, #2k+1 )
		get1
		( result, m1, f2, ..., fk, mk, %min, lfac2, #2k+1, f1 )
		4UNROLL
		( result, m1, f2, ..., fk, mk, f1, %min, lfac2, #2k+1 )
		get1
		( result, f2, ..., fk, mk, f1, %min, lfac2, #2k+1, m1 )
		DUP 5PICK EQUAL
		( result, f2, ..., fk, mk, f1, %min, lfac2, #2k+1, m1, ?m1=%min )
		ITE ::	DROP#1- #1-SWAP
			( result, f2, ..., fk, mk, f1, %min, #2k-1, lfac2 )
			4ROLL >TCOMP SWAP
			( result, f2, ..., fk, mk,  %min, lfac2, #2k-1 )
			;
			4UNROLL
		LOOP
	( result, f1, m1, ..., fk, mk, %min, lfac2, #2k+1 )
	#1-UNROT TWO psh {}N
	( result, %min, lfac2, #2, lfac1 )
	5UNROLL DROPSWAP %ABSCOERCE
	( lfac1, result, lfac2, # )
	( on separe tous ces facteurs )
	( lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, #)
	OVER PIext
	( d1, p, Laurent, q1, lfac1, result, lfac2, #, r2 )
	( q1/d1=Q1/D1+q2/r2^# avec d1=D1*r2^# )
	2DUPSWAP 6GETLAM MPext
	( d1, p, Laurent, q1, lfac1, result, lfac2, #, r2, r2^# )
	DUP 11PUTLAM
	TEN ROLL
	( p, Laurent, q1, lfac1, result, lfac2, #, r2, r2^#, d1 )
	OVER QUOText
	( p, Laurent, q1, lfac1, result, lfac2, #, r2, r2^#, D1 )
	DUP ELEVEN UNROLL
	( D1, p, Laurent, q1, lfac1, result, lfac2, #, r2, r2^#, D1 )
	EGCDext
	( D1, p, Laurent, q1, lfac1, result, lfac2, #, r2, g, r, D avec g=r*r2^#+D*D1 donc Q1=q1/g*r et q2=q1/g*D )	
	NINE ROLL
	( D1, p, Laurent, lfac1, result, lfac2, #, r2, g, r, D, q1 )
	4ROLL RDIVext
	( D1, p, Laurent, lfac1, result, lfac2, #, r2, r, D, q1/g )
	DUPUNROT RMULText UNROT RMULText
	( D1, p, Laurent, lfac1, result, lfac2, #, r2, q2, Q1 )
	TEN PICK DIVext SWAPDROP 
	7UNROLL
	( D1, p, Laurent, Q1, lfac1, result, lfac2, #, r2, q2 )
	( partie rationnelle de q2/r2^# )
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, #, r2, q2 )
	( Bezout pour r2 et r2' )
	SWAPDUP
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, #, q2, r2, r2 )
	THIRTEEN PICK 2GETEVAL
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, #, q2, r2, r2' )
	2DUP EGCDext
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, #, q2, r2, r2', g, a, b )
	( avec g=b*r2'+a*r )
	7ROLL
	ONE_DO (DO)
		( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, q2, r2, r2', g, a, b )
		( nouveau q2= [q2/g]*a+ [ [q2/g]*b/[i-1] ]' )
		( a rajouter a result: -[q2/g]*b/[i-1]/r2^i-1 )
		6ROLL 4PICK RDIVext DUP
		( lfac2, r2, r2', g, a, b, q2/g, q2/g )
		4PICK RMULText SWAP
		( lfac2, r2, r2', g, a, b, q2/g*a, q2/g )
		3PICK RMULText ISTOP-INDEX UNCOERCE RDIVext
		( lfac2, r2, r2', g, a, b, q2/g*a, q2/g*b/i-1 )
		DUP SEVENTEEN PICK 2GETEVAL
		( lfac2, r2, r2', g, b, a, q2/g*a, q2/g*b/i-1, derivee )
		ROT RADDext
		( lfac2, r2, r2', g, b, a, q2/g*b/i-1, nouveau q2 )
		7UNROLL
		( lfac2, nouveau q2, r2, r2',g, b, a, q2/g*b/i-1 )
		( ici, on divise par r2#i-1 )
		11GETLAM 7PICK RDIVext DUP 11PUTLAM DIVext SWAPDROP
		( lfac2, nouveau q2, r2, r2',g, b, a, q2/g*b/i-1 )
		symcomp 6PICK symcomp ISTOP-INDEX UNCOERCE 
		' x^ EvalNoCK ' x/ EvalNoCK
		( res, lfac2, nouveau q2, r2, r2',g, b, a, rajouter a res )
		NINE ROLL SWAP' x- EvalNoCK 8UNROLL
		( res, lfac2, nouveau q2, r2, r2', g, b, a )
		LOOP
		( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, q2, r2, r2', g, b, a )
	3DROP SWAPDROP
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, lfac2, q2, r2' )
	( partie logarithmique )
	THIRTEEN PICK 5GETLAM EVAL
	( oldcoeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result, coeflog )
	TWELVE ROLL DROP ELEVEN UNROLL
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac1, result )
REPEAT
( coeflog, log, lvar, dlvar, type, d1, p, Laurent, q1, lfac, result, %min )
DROP UNROT 
( coeflog, log, lvar, dlvar, type, d1, p, Laurent, result, q1, lfac )
( on supprime les -1 )
DUPNULL{}?
::	case2drop 4ROLLDROP ( coeflog, log, lvar, dlvar, type, p, Laurent, result )

	INNERDUP #2/
	ZERO_DO (DO)
		( o1, ..., ok, #k )
		#1- get1 SWAP get1 DROP
		LOOP
	{}N
	SWAP
	( coeflog, log, lvar, dlvar, type, d1, p, Laurent, result, lfac, q1 )
	6ROLL
	( coeflog, log, lvar, dlvar, type, p, Laurent, result, lfac, q1, d1 )
	8PICK 2GETEVAL
	( coeflog, log, lvar, dlvar, type, p, Laurent, result, lfac, q1, d1' )
	( partie logarithmique residuelle )
	TEN PICK 5GETLAM EVAL
	( coeflog, log, lvar, dlvar, type, p, Laurent, result, coeflog )
	NINE ROLL DROP 8UNROLL
	( coeflog, log, lvar, dlvar, type, p, Laurent, result )
	;

;

( coeflog, log, lvar, dlvar, type, p, Laurent, result )
7ROLL DROP
( coeflog, lvar, dlvar, type, p, Laurent, result )
* Partie polynomiale
4ROLL
idntlamcase ::	( coeflog, lvar, dlvar, p, Laurent, result, x )
		DROP 5UNROLL
		( coeflog, result, lvar, dlvar, p, Laurent )
		DROP UNROT2DROP
		( coeflog, result, p )
		FXNDext SWAP
		( coeflog, result, p-d, p-n )
		DUPTYPELIST? ITE INTEGRext :: %0 TWO{}N ;
		SWAP NDXFext
		TRIMOBJext symcomp ' x+ EvalNoCK
		( coeflog, result )
		7GETLAM EVAL
		( coeflog, result )
		;
EQ: xLN
case ::	( coeflog, lvar, dlvar, p, Laurent, result )
	SWAPDROP
	( coeflog, lvar, dlvar, p, result )
	4PICK INNERCOMP #1-{}N
	( coeflog, lvar, dlvar, p, result, var, lvar' )
	SWAPONE OVER LENCOMP #1- SUBCOMP
	( coeflog, lvar, dlvar, p, result, lvar', var sans le LN )
	SWAP VXXLext SWAPDROP
	( coeflog, lvar, dlvar, p, result, argument du log autorise )
	( seul log[x] est autorise )
	5UNROLL
	%0 UNROT
	SWAPDUP DUPTYPELIST? ITE LENCOMP DROPONE
	( coeflog, log, lvar, dlvar, bk+1, result, p, #d+1 )
	:: 
	DUP#1= caseDROP
	ONE_DO	(DO)
		( coeflog, log, lvar, dlvar, bk+1, result, p )
		INNERCOMP #1-{}N
		( coeflog, log, lvar, dlvar, bk+1, result, ak, p )
		7UNROLL
		( coeflog, p, log, lvar, dlvar, bk+1, result, ak )
		ROT ISTOP-INDEX 
		( coeflog, p, log, lvar, dlvar, result, ak, bk+1 )
		15GETLAM EVAL
		( coeflog, p, log, lvar, dlvar, bk, result )
		6ROLL
		LOOP
	;
	( coeflog, log, lvar, dlvar, b1, result, p )
	6ROLL DROP NULL{} 6UNROLL
	( tous les log sont autorises )
	( coeflog, log, lvar, dlvar, b1, result, p )
	14GETLAM EVAL
	( coeflog, log, lvar, dlvar, b1, result, p )
	ROT ZERO 15GETLAM EVAL
	( coeflog, log, lvar, dlvar, b0, result )
	5UNROLL 4DROP
	( coeflog, result )
	;
( EXP )
( coeflog, lvar, dlvar, p, Laurent, result )
12GETLAM :: num0case NOP symcomp ;
6PICK CARCOMP 
( coeflog, lvar, dlvar, p, Laurent, result, sigma[ck], exp[eta] )
ONE OVER LENCOMP #1- SUBCOMP
( coeflog, lvar, dlvar, p, Laurent, result, sigma[ck], eta )
7PICK CDRCOMP VXXLext SWAPDROP DUP4UNROLL ONE{}N
( coeflog, lvar, dlvar, p, Laurent, eta, result, sigma[ck], eta )
symcomp 'x* EvalNoCK ' x- EvalNoCK
( coeflog, lvar, dlvar, p, Laurent, eta, result )
* calcul de la partie poly generalisee
* etape 1: factorisation de eta', calcul des coef beta
SWAP 5PICK CDRCOMP 2GETEVAL
( coeflog, lvar, dlvar, p, Laurent, result, eta' )
NULL{} 16GETLAM EVAL
( coeflog, lvar, dlvar, p, Laurent, result, n/d, lfac )
* lfac contient les polynomes suivis des coefs beta,
* on regarde pour les racines de p telles que beta=1 
* si n/d' est un entier positif
OVER FXNDext
( coeflog, lvar, dlvar, p, Laurent, result, n/d, lfac, n, d )
8PICK CDRCOMP 2GETEVAL NDXFext
( coeflog, lvar, dlvar, p, Laurent, result, n/d, lfac, n/d' )
SWAPINCOMP get1 NULL{} DUP 
( coeflog, lvar, dlvar, p, Laurent, result, n/d, p1, ..., betak, #2k, n/d', l=1, l>1 )
4ROLL #2/
:: DUP#0=csedrp ROTDROP
ZERO_DO (DO)
	( ...n/d, p1, beta1, ..., pk, betak, n/d', lfac=1, lfac>1 )
	4ROLL %ABSCOERCE 
	( p1, beta1, ..., pk, n/d', lfac=1, lfac>1, #betak )
	::	DUP#0=csedrp 4ROLLDROP
		DUP#1= 
		casedrop ::	( pk, n/d', lfac=1, lfac>1 )
				SWAP4ROLL
				( n/d', l>1, l=1, pk )
				EVIDENText SOLVext &COMP
				( n/d', l>1, l=1, racines de pk )
				DUPLENCOMP
				::	DUP#0=csedrp DROP
					ZERO_DO 
						( l>1, l=1 , lrac )
						INNERCOMP #1-{}N
						( n/d', l>1, l=1, r, lrac )
						UNROT 5PICK FXNDext
						( n/d', l>1, lrac, l=1, r, n, d' )
						17GETLAM EVAL
						( n/d', l>1, lrac, l=1, r, n/d'[pk] )
						20GETLAM EVAL
						( l>1, lrac, l=1, r, # )
						TWO{}N &COMP
						( l>1, lrac, l=1 )
						SWAPLOOP
					( l>1, l=1, lrac )
					DROP
					;
				( n/d',l>1, l=1 )
				SWAP
				;
		>HCOMP 4ROLL >HCOMP 
		;
	( p1, beta1, ..., n/d', lfac=1, lfac>1 )
	LOOP
( n/d, n/d', lfac=1, lfac>1 )
ROTDROP
;
( coeflog, lvar, dlvar, p, Laurent, result, n/d, l=1, l>1 )
* on entame la boucle pour p et Laurent
* resolution de bk'+k*n/d*bk=ak
* ou ak est le coef de p ou de Laurent
7ROLL CDRCOMP 6UNROLL
( coeflog, lvar, p, dlvar', Laurent, result, n/d, l=1, l>1 )
TRUE 19GETLAM EVAL
( coeflog, lvar, p, dlvar', Laurent, result, n/d, l=1, l>1 )
5ROLLDROP
6ROLL 5UNROLL
( coeflog, lvar, dlvar', p, result, n/d, l=1, l>1 )
FALSE 19GETLAM EVAL
( coeflog, lvar, dlvar', p, result, n/d, l=1, l>1 )
3DROP
( coeflog, lvar, dlvar', p, result )

* reste le coef constant de p
NULL{} ROT 14GETLAM EVAL 
( coeflog, lvar, dlvar', result, log autorise, a0 )
num0case :: 2DROP UNROT2DROP ;
5ROLL CDRCOMP 5ROLL TRUE 3GETLAM EVAL
( coeflog, result, coef, symb )
SWAPDROP ONE{}N symcomp ' x+  EvalNoCK
( coeflog, result )
;


* derivee multivariables dependant de x 
' :: ( LAM2 )
INCLUDE mder.s
( fin de la multiderivation )
;

( programme principal )
' ::	( LAM1: obj -> obj )
CK&DISPATCH1
symb ::	DUPDUP LENCOMP NTHCOMPDROP ' x\.S_ALGEBRAIC
	( symb, dernier objet )
	( teste la presence du signe \int dans l'objet )
	EQUALcasedro
	::	' xOBJ\-> EvalNoCK 2DROP
		' ID VX xSTO 
		( place la variable d'integration dans VX)
		( inf, sup, expr )
		1GETLAM EVAL DUP4UNROLL
		( expr, inf, sup, expr )
		' ID VX XEQRCL ROTOVER 5UNROLL
		( expr, VX, inf, expr, VX, sup )
		MEVALext
		4UNROLL
		MEVALext
		RSUBext
                ;
	( symb, dernier objet )
	{ x+ x- }
	matchob?
	case ::	INNERCOMP #1-SWAP OVER#2+UNROL
		( oper, meta )
		pZpargSWAPUn
		( oper, meta1, meta2 )
		SYMBN 1GETLAM EVAL OVER#2+UNROL
		SYMBN 1GETLAM EVAL SWAPROT EvalNoCK
		;
	' xNEG
	EQUALcasedro ::	INNERCOMP #1-SWAP DROP
			SYMBN 1GETLAM EVAL ' xNEG EvalNoCK
			;
	DROP
	( ici debute l'etape 1 de l'algo )
	( symb )
	4GETLAM EVAL
	( symb, x, lvarnx, lvarx )
	DUPNULL{}? case2drop x*
	( on arrange lvarx pour ne pas manquer un intermediaire )
	( lvarnx, lvarx -> newlvarnx, newlvarx )
	NULL{} SWAP
	( newlvarnx, newlvar, lvarx )
	[BEGIN]
		DUPNULL{}?
	NOT_WHILE ::
		( newlvarnx, newlvar, lvarx )
		DUP CDRCOMP SWAP CARCOMP
		( newlvarnx, newlvar, lvarx, var )
		ROTOVER >TCOMP
		( newlvarnx, lvar, var, newlvar )
		UNROT
		( newlvarnx, newlvar, lvarx, var )
		DUPTYPESYMB?
		( si ce n'est pas un symb, on doit etre en fin de lvarx )
		NOTcasedrop :: DUPNULL{}? NcaseSIZEERR ;
		DUPDUP LENCOMP NTHCOMPDROP
		(  newlvarnx, newlvar, lvarx, var, op )
		{ xEXP xLN }
		OVER' EQ POSCOMP
		( newlvarnx, newlvar, lvarx, var, op, #pos )
		#0=case :: DO>STR 21GETLAM EVAL ;
		( newlvarnx, newlvar, lvarx, var )
		DROP INNERCOMP SWAPDROP #1- SYMBN
		( newlvarnx, newlvar, lvarx, [var] )
		4GETLAM EVAL
		( newlvarnx, newlvar, lvarx, [symb], x, [lvarnx], [lvarx] )
		7ROLL ROT &COMP COMPRIMext
		( newlvar, lvarx, [symb], x, [lvarx], newlvarnx )
		6UNROLL
		( newlvarnx, newlvar, lvarx, [symb], x, [lvarx] )
		UNROT2DROP
		( newlvarnx, newlvar, lvarx, [lvarx] )
		&COMP LVARext SWAPDROP
	;
	[REPEAT]
	DROP
	( symb, x, newlvarnx, newlvarx )
	SWAP &COMP
	( symb, x, lvar )
	( on calcule maintenant dlvar )
	NULL{} OVER
	[BEGIN]
		( symb, x, lvar, dlvar, reste )
		INNERCOMP #1-{}N
		( symb, x, lvar, dlvar, var, reste )
		OVER 6PICK EQUAL
		( symb, x, lvar, dlvar, var, reste, ?var=x )
	NOT_WHILE ::
		( symb, x, lvar, dlvar, var, reste )
		SWAPDUP 6PICK x\.d
		( symb, x, lvar, dlvar, reste, var, var' )
		UNROT 2DUP >HCOMP
		( symb, x, lvar, dlvar, var', reste, var, reste&var )
		4ROLLSWAP VXXLext
		( symb, x, lvar, dlvar, reste, var, reste&var, var' )
		UNROT2DROP
		( symb, x, lvar, dlvar, reste, var' )
		ROTSWAP >TCOMP SWAP
	;
	[REPEAT]
	( symb, x, lvar, dlvar, var, reste )
	2DROP %1 >TCOMP
	( symb, x, lvar, dlvar )
	ROTDROP
	( symb, lvar, dlvar )
	TWO{}N 1LAMBIND CK1NOLASTWD 1GETABND INCOMPDROP
	( necessaire car ' x\.d EvalNoCK ne fonctionne pas! )
	OVER 4UNROLL NULL{} 4UNROLL
	( lvar, log, symb, lvar, dlvar )
	TRUE
	3GETLAM EVAL
	( lvar, coeflog, symb )
	SWAPDROP ZEROSWAP ROT VALOBJext
	internalflag ClrUserFlag
	;
sym ::	ID VX 2DUP 'x* EvalNoCK UNROT EQUAL ITE %2 %1 ' x/ EvalNoCK
	;
any ::	ID VX 'x* EvalNoCK
	;
;

' NULLLAM TWENTYONE NDUPN DOBIND 
1GETLAM EVAL ABND
( fin de Risch )
;
ASSEMBLE
RISCH        CON(5) (RISCH)-(RISCHdeb)+2
*****************  RISCH
*********************************************************************


*********************************************************************
*************     INT
dernier     CON(2) ((INTfin)-(INTdeb))/2
INTdeb     NIBASC /INT/
INTfin     CON(2) ((INTfin)-(INTdeb))/2
RPL
DEFINE laplaceflag      SIXTEEN
DEFINE sincosflag       EIGHTEEN
DEFINE intgflag         NINETEEN
::
CK1NOLASTWD
'
:: DUP' ID PRIMIT xSTO
   TWENTY SIXTEEN 
   DO
      INDEX@ ClrUserFlag
   LOOP
   ;
'
:: ( LAM9 symb, x, lvar -> symb, x, lvarnx, lvarx )
   DUPNULL{}?
   case DUP
   INNERCOMP
   ( symb, v1, ..., vn, #n )
   get1 NULL{} DUP 4ROLL
   ZERO_DO (DO)
           ( symb, v1, ..., vk, x, lvarnx, lvarx )
           3PICK 5ROLL
           ( symb, v1, ..., vk-1, x, lvarnx, lvarx, x, vk )
           DUPUNROT DUPTYPESYMB?
           ITE :: SWAP EQUALPOSCOMP #0<> ;
               EQUAL
           ( lastop, symb, v1, ..., vk-1, x, lvarnx, lvarx, vk, ?xinvk )
           ITE >HCOMP :: ROTSWAP >HCOMP SWAP ;
           LOOP
   ( symb, x, lvarnx, lvarx )
   ;
'
:: ( LAM8: racines carres )
   ( lastop, symb, x, lvarnx, varx, op )
   EQ: x\v/ NOTcase 2GETEVAL
   ( lastop, symb, x, lvarnx, varx )
   DTYPELIST? IT CARCOMP
   DUPINCOMP #1- SWAPDROP SYMBN
   ( lastop, symb, x, lvarnx, sqrt, ax^2+bx+c )
   LVARext
   ( lastop, symb, x, lvarnx, sqrt, ax^2+bx+c, rlvar )
   5PICK SWAP 9GETLAM EVAL
   ( lastop, symb, x, lvarnx, sqrt, ax^2+bx+c, x, rlvarnx, rlvarx )
   DUPLENCOMP #1= NOTcase2drop 2GETEVAL
   ( lastop, symb, x, lvarnx, sqrt, ax^2+bx+c, x, rlvarnx, rlvarx )
   CARCOMP 3PICK EQUALNOTcase 2GETEVAL
   SWAP >HCOMP VXXLext
   ( lastop, symb, x, lvarnx, sqrt, rlvar, l-'ax^2+bx+c'/d )
   FXNDext DUP DUPTYPELIST? ITE DEGREext DROPZERO
   ( lastop, symb, x, lvarnx, sqrt, rlvar, ax^2+bx+c, d, # )
   #0= NOTcase 2GETEVAL
   ( lastop, symb, x, lvarnx, sqrt, rlvar, ax^2+bx+c, d )
   SWAPDUP DEGREext
   ( lastop, symb, x, lvarnx, sqrt, rlvar, d, ax^2+bx+c, # )
   #>2case 2GETEVAL
   ( lastop, symb, x, lvarnx, sqrt, rlvar, d, ax^2+bx+c )
   INNERCOMP %0 THREE
   ( lastop, symb, x, lvarnx, sqrt, rlvar, d, a,b,c, #, %0, #3 )
   ROT #= ITE_DROP UNROT
   ( lastop, symb, x, lvarnx, sqrt, rlvar, d, a, b, c )
   2SWAP 2DUPSWAP
   ( lastop, symb, x, lvarnx, sqrt, rlvar, b, c, d, a, a, d )
   NDXFext 5UNROLL
   ( lastop, symb, x, lvarnx, sqrt, rlvar, a/d, b, c, d, a )
   OVER RMULText XSQRext %2 RMULText 4UNROLL
   ( lastop, symb, x, lvarnx, sqrt, rlvar, a/d, 2*sqrt[ad], b, c, d )
   RNEGext %0 ROT THREE{}N UNROT RNEGext TWO{}N NDXFext
   ( lastop, symb, x, lvarnx, sqrt, rlvar, a/d, { -d 0 c }/{ 2*sqrt[ad] -b } )
   DUP xFDER
   ZEROSWAP 5PICK VAL2ext ZERO ROT 5PICK VAL2ext
   ( lastop, symb, x, lvarnx, sqrt, rlvar, a/d, dx/dm, x[m] )
   2SWAP
   ( lastop, symb, x, lvarnx, sqrt, dx/dm, x[m], rlvar, liste-a/d )
   XSQRext ZEROSWAP ROT CDRCOMP VAL2ext 
   ( lastop, symb, x, lvarnx, sqrt, dx/dm, x[m], sqrt[a/d] )
   LISTOPext LVARDext ROTDROP
   ( lastop, symb, x, lvarnx, sqrt, dx/dm, x[m], sqrt[a/d], newvar )
   6ROLL &COMP 5UNROLL
   ( lastop, symb, x, lvarnx, sqrt, dx/dm, x[m], sqrt[a/d] )
   6PICK x*
   ( lastop, symb, x, lvarnx, sqrt, dx/dm, x[m], a/d*x )
   4ROLL 2DUPSWAP x-
   ( lastop, symb, x, lvarnx, dx/dm, x[m], a/d*x, sqrt, m[x] )
   8UNROLL SWAP
   ( lastop, m[x], symb, x, lvarnx, dx/dm, x[m], sqrt, a/d*x )
   ID Bidon x+ TWO{}N
   ( lastop, m[x], symb, x, lvarnx, dx/dm, x[m], { sqrt m } )
   6ROLL SWAP x^MATCH DROP
   ( lastop, m[x], x, lvarnx, dx/dm, x[m], symb )
   5PICK ROT TWO{}N x^MATCH DROP x*
   ( lastop, m[x], x, lvarnx, symb )
   ID Bidon 4PICK TWO{}N x^MATCH DROP
   ( lastop, m[x], x, lvarnx, symb )
   SWAP3PICK >HCOMP
   ( lastop, m[x], x, symb, lvar )
   intgflag SetUserFlag
   4GETLAM EVAL
   ( lastop, m[x], x, lvar, symb )
   SWAP CDRCOMP 4ROLL >HCOMP
   ( lastop, symb, lvar )
   ZERO UNROT VAL2ext
   UNROT2DROP
   10GETLAM EVAL
   ;
'
:: ( LAM7: fr[sinx,cosx]-> )
   intgflag SetUserFlag
   ( lastop, symb, x, lvarnx -> )
   4ROLLDROP SWAPROT
   ( lvarnx, x, symb )
   OVERDUP xSINH SWAPDUP xINV x- %2 x/
   ( lvarnx, x, symb, sin, [x-1/x]/2i )
   TWO{}N x^MATCH DROP
   ( lvarnx, x, symb )
   OVERDUP xCOSH SWAPDUP xINV x+ %2 x/
   ( lvarnx, x, symb, sin, [x+1/x]/2 )
   TWO{}N x^MATCH DROP
   ( lvarnx, x, symb )
   OVER x/
   ( lvarnx, x, symb )
   ROT 3PICK >HCOMP
   ( x, symb, lvar )
   4GETLAM EVAL
   ( 'X', lvar, expr )
   SWAP CDRCOMP
   ( 'X', expr, lvar )
   SYMBOL xe ; 4ROLL x^
   ( expr, lvar, 'e^X' )
   >HCOMP ZERO UNROT
   ( #0, expr, lvar )
   VAL2ext
   10GETLAM EVAL
   ;    ( End of LAM7 )

'
:: ( LAM6=LALGB : liste pole/coef, partie entiere -> algebrique, [coef] )
   ( si le flag 18 est arme, coef est renvoye )
   ( flag 19 set -> integration, sinon flag 16 set -> ILAP, clear: PF )
   intgflag TestUserFlag 
   ITE INTEGRext 
       :: laplaceflag TestUserFlag NOT?SEMI
          ( ILAP: [lvar], liste pole/coef, partie entiere )
	  num0case NOP SETTYPEERR
	  ;
   TRIMOBJext
   DUPTYPELIST? IT :: ONE SYMBN ;
   SWAP DUPNULL{}?
   casedrop :: sincosflag TestUserFlag IT %0 ;

   ( LAM binding )
   ' :: ( LAM9 obj -> le meme objet mais symbolique )
        ONE{}N TRIMOBJext DUPTYPELIST? IT :: ONE SYMBN ;
        ;
   ' :: ( LAM8 alg, coef, obj, n -> alg+coef*obj^n )
        %1 :: EQUALcasedro :: ONE SYMBN ;
              ' x^ THREE SYMBN
              ;
        laplaceflag UserITE 'x* :: ' x/ ; 7GETLAM EVAL
        ;
   ' :: ( LAM7 'alg', coef, obj, oper -> 'alg + coef oper obj' )
        ROT 9GETLAM EVAL
        UNROT EVAL x+
        ;
   RESOROMP RNEGext ( LAM 6 )
   RESOROMP RIMext ( LAM 5 )
   RESOROMP RREext ( LAM 4 )
   RESOROMP RMULText ( LAM 3 )
   RESOROMP RADDext ( LAM 2 )
   %0 ( LAM1 )
   ' NULLLAM NINE NDUPN DOBIND

   ( partie entire, liste pole/coef )
   INNERCOMP #2/ %0 DUP 2DUP NULL{} %0 7ROLL
   ZERO_DO (DO)
           :: ( pour les instructions case, fin de structure LOOP )
              ( stk= pole, coef, ..., pole, coef, x^2-2ax+|z|^2,mult, re[z], im[z], prec, algeb )
              ( egalite avec pole precedent? )
              4UNROLL 8ROLL DUPUNROT
              ( stk= ..., coef, x^2-2ax+|z|^2, mult, algb, re[z], im[z], z, prec, z )
              EQUAL
              ( stk= ..., coef, x^2-2ax+|z|^2, mult, algb, re[z], im[z], z, prec=pole?)
              ITE :: 5ROLL %1+ 5UNROLL ;
                  :: 5ROLLDROP intgflag UserITE %0 %1 5UNROLL
                     ( stk= ..., coef, x^2-2ax+|z|^2, mult, algb, re[z], im[z], z )
                     complexflag TestUserFlag ?SEMI
                     UNROT2DROP 4ROLLDROP
                     ( ..., coef, mult, algb, z )
                     DUPDUP 4GETLAM EVAL SWAP 5GETLAM EVAL ROT
                     ( ..., coef, mult, algb, re[z], im[z], z )
                     %1
                     ( ..., coef, mult, algb, re[z], im[z], z, x^2)
                     4PICK %-2 3GETLAM EVAL
                     ( ..., coef, mult, algb, re[z], im[z], z, x^2, -2ax )
                     NUMEVALext
                     :: 5PICK DUP 3GETLAM EVAL
                        5PICK DUP 3GETLAM EVAL
                        ;
                     2GETEVAL
                     THREE{}N
                     ( ..., coef, mult, algb, re[z], im[z], z, x^2-2ax+|z|^2 )
                     6UNROLL
                     ;
              ( ..., coef, x^2-2ax+|z|^2, mult, algb, re[z], im[z], z )
              { TWENTY 6PICK DO>STR &$ CHR_> >T$ DISPROW6
                DUP DO>STR DISPROW7
                }
              User1IT
              ( ..., coef, x^2-2ax+|z|^2, mult, algb, re[z], im[z], z )
	      laplaceflag UserITE
	      :: ( ILAP ) 
                 3PICK  :: num0case %1
                           DUP %0 TWO{}N ' xEXP TWO SYMBN 
                           ;
                 SWAPDROP
                 ( ..., coef, x^2, mult, algb, re, im, z, exp[re*x] )
                 8ROLL 7PICK %1- x! RDIVext 
                 ( ..., x^2, mult, algb, re, im, z, exp[re*x], coef )
                 4PICK TRIMOBJext %0 EQUAL
                 ITE :: ( ..., x^2, mult, algb, re[z], im[z], z, exp[r], coef )
                        9GETLAM EVAL SWAP x*
                        ( ..., x^2, mult, algb, re[z], im[z], z, coef*exp[zx]/[mult-1]! )
                        ;
                     :: %2 3GETLAM EVAL DUP 4GETLAM EVAL 9GETLAM EVAL 
                        SWAP 5GETLAM EVAL 6GETLAM EVAL 9GETLAM EVAL
                        ( ..., x^2, mult, algb, re[z], im[z], z, exp[r], re[coef], im[coef] )
                        5PICK %0 TWO{}N DUP' xSIN TWO SYMBN
                        SWAP' xCOS TWO SYMBN
                        ( ..., x^2, mult, algb, re[z], im[z], z, exp[r], re[coef], im[coef], sin, cos )
                        4ROLLSWAP x* UNROT x* x+ SWAP x*
                        ;
                 %1 %0 TWO{}N ONE SYMBN
                 ( ..., x^2-2ax+|z|^2, mult, algb, re[z], im[z], z , coef*exp[zx]/[mult-1]!, x )
                 6ROLL UNROT 7PICK %1- 
                 ( ..., x^2, mult, re[z], im[z], z, alg, exp, x-z, mult-1 )
                 DUP%0= case2drop x+
                 DUP %1 %= ITE_DROP x^ SWAP x* x+
                 ( ..., x^2, mult, re[z], im[z], z, algeb )
                 ;
              :: ( PF et INTG )
                 7ROLL intgflag TestUserFlag
                 ( ..., x^2-2ax+|z|^2, mult, algb, re[z], im[z], z, coef, flag19 )
                 7PICK %0<> AND
                 ( ..., x^2-2ax+|z|^2, mult, algb, re[z], im[z], z, coef, flag )
                 ( divise coef par mult si elements simples ou si mult>1 )
                 IT :: 6PICK %CHS RDIVext ;
                 ( ..., x^2-2ax+|z|^2, mult, algb, re[z], im[z], z, coef )
                 5ROLL SWAP4PICK TRIMOBJext %0 EQUAL
                 ( ..., x^2-2ax+|z|^2, mult, re[z], im[z], z, algb, coef, im[z]=0? )
                 complexflag TestUserFlag
                 ORcase :: ( ..., x^2-2ax+|z|^2, mult, re[z], im[z], z, algb, coef )
                           %1 4PICK 6GETLAM EVAL TWO{}N
                           ( ..., pole, coef, x^2, mult, re[z], im[z], z, algb, coef, x-z )
                           7PICK DUP%0=
                           casedrop :: ' xLN TWO SYMBN 'x* 7GETLAM EVAL
                                       ;
                           ( exposant = 1 ? )
                           8GETLAM EVAL
                           ;
                 ( ..., x^2-2ax+|z|^2, mult, re[z], im[z], z, algb, coef )
                 DUP 4GETLAM EVAL UNROT %2 3GETLAM NUMEVALext EVAL 5GETLAM EVAL
                 ( ..., pole, coef, x^2, mult, re[z], im[z], z, recoef, algeb, 2*imcoef )
                 7PICK
                 j%0=case :: sincosflag TestUserFlag
                             IT :: ( rajoute pi*im*INT[x/2pi-.5] pour PSIN )
                                   ( ..., 2*imcoef)
                                   1GETLAM OVER RADDext 1PUTLAM
                                   ;
                             ( ..., x^2, mult, re[z], im[z], z, recoef, algeb, 2*imcoef)
                             5PICK %-1 OVER RDIVext
                             ( ..., x^2, mult, re[z], im[z], z, recoef, algeb, 2*imcoef, im[z], -1/im[z] )
                             8PICK ROT RDIVext TWO{}N
                             ( x^2, mult, re[z], im[z], z, recoef, algeb, 2*imcoef, x-re[z]/im[z] )
                             ' xATAN TWO SYMBN 'x* 7GETLAM EVAL
                             ( x^2, mult, re[z], im(z], z, recoef, algeb )
                             SWAP
                             ( x^2, mult, re[z], im[z], z, algeb, recoef )
                             7PICK ' xLN TWO SYMBN 'x* 7GETLAM EVAL
                             ;
                 ( calcul du numrateur )
                 ( ..., x^2, mult, re[z], im[z], z, recoef, algeb, 2*imcoef )
                 6GETLAM EVAL ONE{}N
                 %1 5PICK NUMEVALext RCONJext 6GETLAM EVAL TWO{}N 8PICK
                 ( ..., recoef, algeb, -2*imcoef, x-conj[pole], mult)
                 3GETLAM MPext 5GETLAM EVAL
                 3GETLAM EVAL
                 ( ...,x^2, mult, re[z], im[z], z, recoef, algb, -2*imcoef*im[x-conj[z]]^mult )
                 %1 5PICK 6GETLAM EVAL TWO{}N
                 8PICK 3GETLAM MPext 4GETLAM EVAL
                 ( ...,x^2, mult, re[z], im[z], z, recoef, algb, -2*imcoef*[x-conj[z]]^mult, re[x-z]^mult )
                 4ROLL %2 3GETLAM EVAL ONE{}N 3GETLAM EVAL 2GETEVAL
                 ( calcul du dnominateur )
                 ( ..., x^2, mult, re[z], im[z], z, algb, num )
                 DUPTYPELIST? IT :: ONE SYMBN ;
                 7PICK 7PICK
                 %1 :: EQUALcasedro :: ONE SYMBN ;
                       ' x^ THREE SYMBN
                       ;
                 x/ x+
                 ;
              ;
           LOOP
   ( partie entiere, x^2, mult, re[z], im[z], z, algeb )
   6UNROLL 5DROP
   ( partie entiere, list-algeb )
   x+
   ( list-algeb )
   sincosflag TestUserFlag IT 1GETLAM
   ABND
   ( list-algeb, [ coefficient ] )
   ;  ( End of LAM6 )

'
:: ( LAM5=ESL : num-liste, deno-liste, liste rac )
   ( -> liste pole,coef , partie entiere liste )

*   ( programme de simplification )
*   ( num-liste, deno-liste, liste racines )
*   NULL{} SWAP
*   BEGIN
*        ( lvar, numl, denol, rootl, oldrootl )
*        DUPNULL{}? NOT
*   WHILE
*        NEXTPext DUPLENCOMP
*        ( numl, denol, newl, oldl, liste rac, mult )
*        6PICK ROT CARCOMP
*        ( numl, denol, newl, oldl, mult, numl, rac )
*        BEGIN
*             :: 3PICK #0=case :: SWAPDROP FALSE ;
*                HORNext num0=case DROPTRUE
*                DROPSWAPDROP FALSE
*                ;
*        WHILE
*             ( numl, denol, newl, oldl, mult, newnuml, rac )
*             7ROLL DROPOVER 7UNROLL
*             6ROLL SWAP HORNext DROPSWAP 6UNROLL
*             ROT #1-UNROT
*        REPEAT
*        ( numl, denol, newl, oldl, mult, rac )
*        SWAP NDUPN {}N ROTSWAP &COMP SWAP
*   REPEAT
*   DROP
*   ( fin du programme de simplification numerateur/denominateur )
* devenu inutile avec les nouvelles routines de factorisation

   ( numl, denol, rootl )
   DUPNULL{}?
   case SWAPDROPSWAP
   SWAP
   ( num-liste, liste rac, deno-liste )
   ZERO 1LAMBIND
   { BlankDA12 FIFTEEN TWO &$ DISPROW1 OVER EDITDECOMP$
     :: TWO FIVE ; Disp5x7 TWO DISPROW6 }
   User1IT
   DUP DERext 4ROLLROT
   DIVext TRIMext SWAP
   NULL{} 5UNROLL 4UNROLL SWAPROT
   BEGIN
        DUPNULL{}? NOT
   WHILE
        ( liste es smp, P div Q, P mod Q, Q' , { rac } )
	INNERCOMP #2- {}N
	( r, m, liste )
	::	complexflag TestUserFlag
		?SEMI
		DUP 4PICK RCONJext
		( r, m, l, l, rbar )
		EQUALPOSCOMP DUP#0=csDROP
		( r, m, l, # )
		SWAPINCOMP
		( r, m, #, r1, m1, ..., rk, mk, #2k  )
		get1 
		( r, m, r1, m1, ..., rk, mk, #2k, #l )
		OVERSWAP #- 
		( r, m, r1, m1, ..., rk, mk, #2k, #2k-2l+1 )
		get1 DROP get1 2DROP
		#2- {}N
		;
	( r, m, liste )
        UNROT %ABSCOERCE
        ( liste es smp, P div Q, P mod Q, Q' , { rac }, r, #m )
        { OVER DO>STR APPEND_SPACE OVER DO>STR &$ DISPROW7 } 
	User1IT
        ( liste es smp, P div Q, P mod Q, Q' , reste rac, r, #m )
        ONE #=casedrop
        :: 4PICKOVER HORNext UNROT2DROP 4PICK 3PICK
           HORNext UNROT2DROP RDIVext
           ( liste essmp, P div Q, P mod Q, Q', reste rac, rac, P[rac]/Q'[rac] )
           7ROLL ROT >TCOMP
           SWAP >TCOMP 5UNROLL
           ;
        1PUTLAM
        ( liste essmp, P div Q, P mod Q, Q', reste rac, rac )
        4PICKOVER 1GETLAM
        ZERO_DO (DO)
                ( calcul du dvp Taylor ordre m-1 de P mod Q )
                HORNext UNROT
                LOOP
        2DROP
        ( complement de 0 pour la division en puissances croissantes )
        %0 1GETLAM #1- NDUPN DROP 1GETLAM #2* #1-{}N
        ( liste essmp, P div Q, P mod Q, Q', reste rac, rac, Taylor P[rac] )
        4PICK 3PICK
        1GETLAM
        ONE_DO
              HORNext  ( calcul de Q[m] )
              DROPLOOP
        1GETLAM DUPDUP #+SWAP
        DO
          ( calcul du dvp Taylor ordre 2m-1 de Q )
          HORNext INDEX@ UNCOERCE RDIVext UNROT
          LOOP
        2DROP 1GETLAM {}N { %0 } UNROT DIV2LISText DROP
        ( liste essmp, P div Q, P mod Q, Q', reste rac, rac , Taylor P/Q )
        7ROLL 1GETLAM
        #1+_ONE_DO (DO)
                   ( ..., rac, Taylor, liste )
                   3PICK >TCOMP OVERINDEX@ NTHCOMPDROP >TCOMP
                   LOOP
        7UNROLL 2DROP
   REPEAT
   3DROP ABND
   ( liste ple/coef , partie entire liste )
   ;
( Fin de LAM5 )
'
::	( LAM4= XPFR : symb, lvar -> primitive ou es simples )
*	DUPNULL{}? IT :: ' ID VX XEQRCL >TCOMP ;
	( symb, lvar )
	complexflag TestUserFlag
	complexflag SetUserFlag
	( symb, lvar, flag )
	UNROT TWO RFACT2ext
	( flag, lvar, num/deno, { rac } )
	complexflag 5ROLL ITE_DROP ClrUserFlag
	( lvar, num/deno, { rac } )
	SWAP FXNDext ROT
	( lvar, num-liste, deno-liste, root-list )
	5GETLAM EVAL
	( lvar, liste pole/coef , partie entiere liste )
	6GETLAM EVAL
	( lvar, algeb-liste [ coef ] )
	;     ( End of LAM4 )
'
:: ( LAM3: fr[sinx,cosx]-> )
   sincosflag SetUserFlag intgflag SetUserFlag
   ( lastop, symb, x, lvarnx -> )
   4ROLLDROP SWAPROT
   ( lvarnx, x, symb )
   OVERDUP xSIN SWAPDUP %2 x* %1 ROT xSQ x+ x/
   ( lvarnx, x, symb, sin, 2x/[1+x^2] )
   TWO{}N x^MATCH DROP
   ( lvarnx, x, symb )
   OVERDUP xCOS SWAP xSQ %1 OVER x- %1 ROT x+ x/
   ( lvarnx, x, symb, sin, [1-x^2]/[1+x^2] )
   TWO{}N x^MATCH DROP
   ( lvarnx, x, symb )
   %2 3PICK xSQ %1 x+ x/ x*
   ( lvarnx, x, symb )
   ROT 3PICK >HCOMP
   ( x, symb, lvar )
   4GETLAM EVAL
   ( 'X' lvar expr im*pi*E )
   ZEROSWAP 4PICK CDRCOMP VAL2ext
   4UNROLL
   ( im*pi*E, 'X', lvar, expr )
   SWAP CDRCOMP 3PICK
   ( im*pi*E, 'X', expr, lvar, 'X' )
   %2 x/ xTAN
   ( im*pi*E, 'X', expr, lvar, 'TAN[X/2]' )
   >HCOMP ZERO UNROT
   ( im*pi*E, 'X', #0, expr, lvar )
   VAL2ext UNROTSWAP
   ( expr 'X' pi*E )
   x\pi x* SWAP x\pi x/ %1 x- %2 x/ xFLOOR x* x+
   10GETLAM EVAL
   ;    ( End of LAM3 )
'
:: ( LAM2 -> erreur )
   ( prevoir integration par parties )
   ( lastop, symb, x, lvarnx, objet indefini -> )
   3DROP SWAPDROP "Non calculable" DO$EXIT
   ;
'
:: ( LAM1: programme principal )
   CK&DISPATCH1
   symb :: DUPDUP LENCOMP NTHCOMPDROP ' x\.S_ALGEBRAIC
           ( symb, dernier objet )
           ( teste la prsence du signe \int dans l'objet )
           EQUALcasedro
             :: intgflag SetUserFlag
                ' xOBJ\-> EvalNoCK 2DROP
                ' ID VX xSTO ( place la variable d'intgration dans VX)
                ( inf, sup, expr )
                1GETLAM EVAL DUP4UNROLL
                ( expr, inf, sup, expr )
                ' ID VX XEQRCL ROTOVER 5UNROLL
                ( expr, VX, inf, expr, VX, sup )
                MEVALext
                4UNROLL
                MEVALext
                RSUBext
                ;
           ( symb, dernier objet )
           { x+ x- }
           matchob?
           case :: INNERCOMP #1-SWAP OVER#2+UNROL
                   ( oper, meta )
                   pZpargSWAPUn
                   ( oper, meta1, meta2 )
                   SYMBN 1GETLAM EVAL OVER#2+UNROL
                   SYMBN 1GETLAM EVAL SWAPROT EVAL
                   ;
           ' xNEG
           EQUALcasedro :: INNERCOMP #1-SWAP DROP
                           SYMBN 1GETLAM EVAL xNEG
                           ;
           SWAP
           ( dernier op, symb )
	   ( ici on ne peut pas utiliser LVAR simplement )
	   ( il faut tenir compte des racines carrees )
           LISTOPext
	   LVARDext ROTDROPSWAP 
           ( lastop, lvar, symb )
           ' ID VX XEQRCL ROT
           ( lastop, symb, x, lvar )
           9GETLAM EVAL
           ( lastop, symb, x, lvarnx, lvarx )
           DUPNULL{}? case2drop :: x* SWAPDROP ;
           DUPLENCOMP DUP#1=
           casedrop
           :: ( 1 seule variable contenant x )
              CARCOMP
              ( lastop, symb, x, lvarnx, varx )
              3PICK EQUALcasedro
              :: ( fraction rationnelle )
                 ( lastop, symb, x, lvarnx )
                 4ROLLDROP
                 SWAP >HCOMP
                 ( symb, lvar )
                 intgflag TestUserFlag
                 laplaceflag TestUserFlag OR
                 ?SKIP :: BlankDA12
                          # 31416 JstGETTHEMSG
                          DISPROW4
                          "PF" "ILAP" NULL$ DUPDUP ""
                          MENUext
                          % 300 % .2 DOBEEP
                          WaitForKey DROP
                          intgflag SWAP
                          ( 19, key, key )
			  kcMenuKey1 #=casedrop SetUserFlag
                          laplaceflag kcMenuKey6 ROT
                          #=ITE ClrUserFlag 
                                :: SetUserFlag complexflag ClrUserFlag ;
                          ClrUserFlag
                          ;
                 ( symb, lvar )
                 4GETLAM EVAL
                 ZEROSWAP ROT VAL2ext
                 10GETLAM EVAL
                 ;
              ( lastop, symb, x, lvarnx, varx de type symbolique )
              DUPLENCOMP
              DUP #2= case
              :: OVERSWAP NTHCOMPDROP
                 ( lastop, symb, x, lvarnx, varx, operateur )
                 { xSIN 3GETLAM xCOS 3GETLAM xSINH 7GETLAM xCOSH 7GETLAM  }
                 EQLookup
                 ITE SWAPDROP 8GETLAM
                 EVAL EVAL
                 ;
              ( lastop, symb, x, lvarnx, varx de type symbolique, len[varx] )
              ( tester si racine carree )
              OVERSWAP NTHCOMPDROP
              ( lastop, symb, x, lvarnx, varx de type symbolique, op )
              8GETLAM EVAL
              ;
           #2= case
           :: ( 2 variables contenant x )
              INCOMPDROP
              ( lastop, symb, x, lvarnx, var1x, var2x )
              4PICK
              EQUALcasedro :: ( lastop, symb, x, lvarnx, var1x )
                              DUPDUP LENCOMP NTHCOMPDROP 8GETLAM EVAL
                              ;
              ( lastop, symb, x, lvarnx, var1x, var2x )
              DUPLENCOMP #2=
              NOTcasedrop 2GETEVAL
              SWAPDUP LENCOMP #2=
              NOTcasedrop 2GETEVAL
              ( lastop, symb, x, lvarnx, var2x, var1x )
              TWO NTHCOMPDROP SWAP TWO NTHCOMPDROP TWO{}N
              { xSIN xCOS }
              EQUALcasedro :: ( lastop, symb, x, lvarnx ) 3GETLAM EVAL ;
              { xSINH xCOSH }
              EQUALcasedro ( lastop, symb, x, lvarnx -> )
                           :: 7GETLAM EVAL ;
              ( lastop, symb, x, lvarnx, lvarx )
              2GETEVAL
              ;
           ( lastop, symb, x, lvarnx, lvarx )
           2GETEVAL
           ; ( end of symb case )
   2LIST :: ( entre liste pour programmes )
            ( num-liste, dno-liste, liste des racines )
            5GETLAM EVAL
            ;
   ;    ( End of LAM1 )
' NULLLAM TEN NDUPN DOBIND

DUPTYPELIST? 
ITE CK3NOLASTWD
    :: DUPTYPESYMB? ?SEMI %1 'x* THREE SYMBN
       ;
1GETLAM EVAL ABND
;
*ASSEMBLE
*INT        CON(5) (INT)-(INTdeb)+2
****************  INT
*********************************************************************

