* -*- mode:Mail -*-
	STITLE GNU ALGB Library Main Module
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************
NULLNAME VERNUMext
VERSION%
*****************************************
NULLNAME TRIMOBJext ( obj -> obj )
* comme TRIM mais sans rendre forcement une liste
::
' ::	( LAM5 complex -> complex / real )
	DUP C%>% %0= NOTcaseDROP SWAPDROP
	;
' :: ( LAM4 irrquad -> irrquad )
     QXNDext THREE ZERO_DO (DO) 1GETLAM EVAL EVAL UNROT LOOP NDXQext
     ;
' ::	( LAM3 fraction -> obj )
	FXNDext num1=case DROP 
	1GETLAM EVAL EVAL SWAP 1GETLAM EVAL EVAL SWAP SIMPNDXFext
	;
' :: ( LAM2 list -> obj': obj'=obj si non liste, sinon supprime les 0 en-tete )
     DTYPELIST? NOT?SEMI
     DUPNULL{}? ?SEMI
     INNERCOMP FALSE SWAPDUP
     ( an, ..., a1, false, #n, #n )
     ZERO_DO (DO)
             ( ak-1,...,an, ..., ak, flag, #n )
             get1 1GETLAM EVAL EVAL
             ( ak-2,...,an,..., ak, flag, #n, ak-1' )
             3PICK
             :: case UNROT
                ( ak-2,...,an,..., ak, false, #n, ak-1'  )
                num0=case DROP#1-
                ROTDROPSWAP TRUE SWAP
                ( ak-2,...,an,..., ak, ak-1', TRUE, #n )
                ;
             LOOP
     SWAP NOTcasedrop %0
     DUP#1= NOTcase {}N
     DROP
     CK&DISPATCH1
     real NOP
     TWO NOP
     any ONE{}N
     ;
' :: ( LAM1 )
     CK&DISPATCH1
     real 'NOP
     TWO 5GETLAM
     list 2GETLAM
     symb 3GETLAM
     seco 4GETLAM
     any 'NOP
     ;
' NULLLAM FIVE NDUPN DOBIND
1GETLAM EVAL EVAL ABND
;
*********************************
NULLNAME LXAext ( liste -> meta-array )
* Explose un vecteur ou une matrice formelle comme ARRY\->
::
DTYPELIST? NOT?SEMI DUPNULL{}? ?SEMI
QOBJext CRUNCH
DUP CARCOMP
dLISTcase :: LENCOMP UNCOERCE SWAP DUPLENCOMP UNCOERCE
             ROT TWO{}N SWAPINCOMP reversym
             #1+_ONE_DO (DO)
                        INNERCOMP INDEX@ #* #1+ROLL
                        LOOP
             ;
DROP INNERCOMP UNCOERCE
;
*****************************************************************
NULLNAME  AXLext ( array -> liste )
* Transforme un tableau en liste
::
DUPTYPEARRY? NOT?SEMI
' xARRY\-> EvalNoCK INNER#1=
SWAP COERCESWAP
case {}N
SWAP COERCE NULL{} SWAP
ZERO_DO (DO)
        OVER#2+UNROL {}N DUPLENCOMP
        UNROT >HCOMP
        LOOP
SWAPDROP
;
**************
NULLNAME EGCDext ( a, b -> d, u, v t.q. d=pgcd[a,b], au+bv=d )
* identit de Bezout pour des polynomes
::
num0case :: DROP %1 %0 ;
DUPTYPELIST? ITE DUPLENCOMP ONE
#1=case :: SWAPDROP %0 %1 ;
SWAP 
num0case :: DROP %0 %1 ;
DUPTYPELIST? ITE DUPLENCOMP ONE
#1=case :: SWAPDROP %1 %0 ;
( on determine le ppcm des denominateurs de b et de a -> travail en entiers)
( b, a )
DUP DENOLCMext
( b, a, ppcmb )
DUPROT LOPMext
( b, ppcma, a*ppcma )
ROTDUP DENOLCMext
( ppcma, a*ppcma, b, ppcmb )
DUP4UNROLL SWAP LOPMext
( ppcma, ppcmb, a*ppcma, b*ppcmb )

( a, b avec a polynome de degre >=1 )
RESOROMP RMULText
' ::	( LAM1 : a, b  -> d, u, v )
	( avec d=au+bv )
	( a, b )
	num0case :: DROP %1 %0 ;
	DUPTYPELIST? ITE DUPLENCOMP ONE
	#1=case :: SWAPDROP %0 %1 ;
	( a, b )
	LPGCDext
	( a, b, beta=lpgcd[b] )
	DUP4UNROLL LOPDext
	( beta, a, B=b/lpgcd[b] )
	( alpha= B.1^#a-#B+1 )
	DUPLENCOMP OVER CARCOMP
	( beta, a, B, #B, B.1 )
	4PICK LENCOMP ROT
	( beta, a, B, B.1, #a, #B )
	2DUP#< ITE	:: 3DROP %1 ;
			:: #-+1 2GETLAM MPext ; 
	( beta,  a, B, alpha )
	DUP 4ROLL LOPMext
	( beta,  B, alpha, A=alpha*a )
	ROT DUPUNROT DIVext
	( beta, alpha, B, A div B, A mod B )
	ROTSWAP
	( beta, alpha, A div B, B, A mod B )
	1GETLAM EVAL 
	( beta, alpha, A div B, d, u1, v1 )
	( avec : d= B*u1+[A mod B]*v1 )
	( [A mod B]=a*alpha-[A div B]*B )
	( donc: d= a*[alpha*v1]+ B*[u1-[A div B]*v1] )
	( beta, alpha, A div B, d, u1, v1 )
	5ROLL OVER 2GETEVAL
	( beta, A div B, d, u1, v1, alpha*v1 )
	UNROT 5ROLL 2GETEVAL
	( beta, d, alpha*v1, u1, v1*A div B )
	RSUBext 4ROLL SIMPext
	( d, alpha*v1, u1-v1*A div B, beta )
	2SWAP 3PICK 2GETEVAL
	( u1-v1*A div B, beta, d, alpha*v1*beta )
	4UNROLL 2GETEVAL UNROT
	( d*beta, v1*alpha*beta, u1- [A div B]* v1 )
	;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL ABND
( ppcma, ppcmb, d, u, v )
( d=a*ppcma*u+b*ppcmb*v )
4ROLL RMULText SWAP4ROLL RMULText
( d, v*ppcmb, u*ppcma )
SWAP THREE{}N LPGCDext LOPDext INCOMPDROP
( d, u, v )
( d, u, v )
;
**********************
NULLNAME MONOEVALext 
( o, # depth, [operande du runstream] -> operande[o] )
* # est la profondeur de operande[o] 
::
internalflag TestUserFlag caseDROP
SWAP LVARext VXXLext 'REVAL SWAP 
VALOBJext internalflag ClrUserFlag
;
**************
NULLNAME ELMGext ( obj -> obj )
* Remplace par 0 les reels inferieurs a epsilon
::
ID EPS dREALNcase SETNONEXTERR
' :: CK&DISPATCH1
     real :: DUP %ABS 2GETLAM %< casedrop %0
             ;
     TWO :: C%>% ( re, im ) SWAPDUP ( im, re, re ) %ABS 2GETLAM %<
            ( im , re, re<eps? )
            ITE %0 DUP
            SWAPDROPSWAP
            ( re ou %0, im )
            DUP %ABS 2GETLAM %< caseDROP %>C%
            ;
     list LISTSECOext
     symb LISTSECOext
     arry :: DUP xABS 2GETLAM %< NOT?SEMI
             %0 xCON
             ;
     ZERO NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL ABND
;
**************
NULLNAME DIVISext ( objet -> liste des diviseurs )
* objet peut etre algebrique ou entier
* dans le premier cas, DIVISext renvoie une liste de facteurs premiers
* dans le second cas, la liste des diviseurs si l'entier est < a #FFFFFh
::
FACTOext UNROT2DROP
( { facteurs, multiplicite } )
' ::	( LAM2 metadiv, d, lfact -> metadiv )
	DUPNULL{}? case2DROP
	INNERCOMP #2- {}N
	( d1, ..., dk, #k, d, f, m, lfact )
	3PICK num1=case :: DROP UNROT2DROP 2GETEVAL ;
	DROPSWAP COERCE #1+
	ZERO_DO (DO)
		( d1, ..., dk, #k, d, f, lfact )
		ROTSWAP 1GETLAM EVAL 
		( d1, ..., dk, #k, f, d, lfact )
		SWAP3PICK RMULText 
		( d1, ..., dk, #k, f, lfact, d*f )
		UNROT
		LOOP
	( d1, ..., dk, #k, d, f, lfact )
	3DROP
	;
' ::	( LAM1 )
	( metadiv, facteur, d, lfact -> metadiv, facteur, d,lfact )
	DUPNULL{}? casedrop :: ROT#1+UNROT DUP4UNROLL NULL{} ;
	( d1, ..., dk, #k, facteur, d, lfact )
	THREE psh
	( facteur, d, lfact, #3, d1, ..., dk, #k )
	DUP #4+PICK
	( facteur, d, lfact, #3, d1, ..., dk, #k, d )
	OVER #4+PICK
	( save_meta, d1, ..., dk, #k, d, lfact )
	2GETEVAL
	( save_meta, metadiv )
	psh 
	( metadiv, save_meta )
	DROP 
	( metadiv, facteur, d, lfact )
	;
' NULLLAM DUPTWO DOBIND
ZERO %1 ROT 2GETEVAL {}N
ABND
DUPNULL{}? casedrop { %1 }
;
**************
NULLNAME RACPOLext ( liste de racines ou de facteurs -> objet )
* Inverse de FACTO.
* Selon le flag 10 il s'agit de facteurs ou de racines.
::
TEN TestUserFlag  ( -> lam3 )
RESOROMP RMULText ( -> lam2 )
' :: 2GETLAM MPext ; ( -> lam1 )
FACTOOBJext
;
**************
NULLNAME FACT1ext
( polynome -> lvar, poly-liste, {liste des racines/multiplicite} )
::
( obj )
ZERO RFACText
;
**************
NULLNAME FACTOext
* entier -> liste des facteurs premiers
* objet -> lvar, poly-liste, liste des facteurs
::
FOUR RFACText
( lvar, poly-l, liste facteurs / multiplicite )
;
**************
NULLNAME SOLVext ( polynome-liste -> liste des racines )
::

* Routine de factorisation pour S/SX
INCLUDE alsolv.s
* Fin de routine de factorisation pour S/SX

* Routine de factorisation pour G/GX
* INCLUDE alsolv.g
* Fin de routine de factorisation pour S/SX

( reconstruction des racines sous forme formelle si possible )
complexflag TestUserFlag real_intflag TestUserFlag AND
NOTcase SWAPDROP
# 31415 JstGETTHEMSG DISPROW7
NULL{} UNROT
( froot-l, deno, nroot-l )
:: INNERDUP FOUR #<case :: {}N SWAPDROP ;
   get1 OVERDUP
   ( formal-root-list, allroots, #n, deno, #n, #n )
   ONE_DO (DO)
          ( formal-root-list, allroots, #racines, deno, #racines_a_tester )
          4ROLLOVER
          ( formal-root-list, roots, #n, deno, #t, rk, #t )
          ONE_DO (DO)
          :: ( formal-root-list, roots, #n, deno, #t, rk )
             5ROLL 2DUP 2DUP x+ xNEG
             ( formal-root-list, roots, #n, deno, #t, rk, rl, rk, rl, -rk-rl )
             7PICK x* UNROT x*
             ( formal-root-list, roots, #n, deno, #t, rk, rl, -rk-rl, rk*rl )
             6PICK x* 6PICK UNROT
             ( froot-list, roots, #n, deno, #t, rk, rl, deno, -rk-rl, rk*rl )
             THREE{}N
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list )
             DUP QOBJext :: %0 xRND ;
             SWAPOVER RSUBext ELMGext TRIMOBJext %0 EQUAL
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list, flag )
             NOTcasedrop :: 3PICK #3+ UNROLL ;
             UNROT2DROP DEG2ext
             ( froot-list, roots, #n, deno, #t, P-list )
             4ROLL DUP #3+ ROLL
             ( roots, deno, #t, P-list, #n, froot-list )
             ROT &COMP OVER#2+UNROL
             ( froot-list, roots, deno, #t, #n )
             #2- DUP#1+ JSTOPSTO ExitAtLOOP
             ( froot-list, roots, deno, #t, #n-2 )
             UNROT #1-
             ( froot-list, roots, #n-2, deno, #t-1 )
             4ROLL
             ( froot-list, roots, #n-2, deno, #t-1, rk' )
             ;
             LOOP
          ( froot-list, roots, #n, deno, #t, rk )
          4PICK #3+ UNROLL #1-
          ( froot-list, roots, #n, deno, #t-1 )
          ( en fait #n, #t -> #n-2,#t-2 si 2 racines sont trouves )
          ( ou -> #n, #t-1 si aucune racine formelle n'est trouve )
          LOOP
   ( froot-list, roots, #n, deno , #t )
   ( ou zero, froot-list, deno, #t )
   2DROP NOTLISTcase {}N SWAPDROP RDROP
   ( froot-list, {roots} )
   ;
SWAP DUPNULL{}? NOTcase &COMP
DROP real_intflag ClrUserFlag
;
**************
NULLNAME EVIDENText ( polynome-liste -> liste de racines, reste de poly )
* Recherche les racines rationnelles d'un polynome (permet aussi de
* factoriser certains polynomes a coefficients formels)
::
( polynome-liste -> liste de racines, reste de poly )
DUPNULL{}? caseSIZEERR
NULL{} SWAP
( null{}, obj )
NOTLISTcase ONE{}N
symbolicflag TestUserFlag NOT?SEMI
( null{}, list )
TRIMext
( null{}, list )
SWAPDROPDUP CARCOMP ONE{}N
( list, { 1er lment } )
SWAP
DUPLENCOMP FOUR
#<case :: DEG2ext SWAP ;
( { 1er lment }, list )
LPGCDext LOPDext
INNERCOMP get1 OVER
* Elimine les zros en queue de polynome -> liste des racines
ZERO_DO (DO)
        ( a0, ..., ak, #k+1 , {root} )
        :: ROT num0case :: >TCOMP SWAP#1-SWAP ;
           UNROT ExitAtLOOP
           ;
        LOOP
* Calcule les numrateurs et les dnominateurs
( a0, ..., ak, #k+1, {root} )
OVER#2+UNROL
2DUP #2+UNROLL
( {root}, ak, a0, ..., ak , #k+1 )
{}N DUP CARCOMP
( {root}, ak, l, a0 )
ROT
( {root}, l, a0, an )
SWAPDUP DIVISext
( {root}, l, an, a0, { diviseurs } )
{ BlankDA12 FOUR TWO &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW7
  DUP EDITDECOMP$ #TWO#TWO Disp5x7 }
User1IT
SWAPDROP
( {root}, l, an, { diviseurs } )
SWAPDUP DIVISext
( {root}, l, {diviseurs}, an, {num} )
* Binding des nulllam
ONEONE ( LAM 4 et 3 )
RESOROMP HORNext ( LAM 2 )
'    :: ( LAM1 { root-liste }, P, test  -> { root-liste } , P )
        OVER ( root, P, test, P)
        ( test appui d'une touche )
        kcMenuKey6 GETTOUCH
        ITE #=
            DROPFALSE
        ( test si le poly est de degre <= 2 )
        :: caseTRUE
           DUPLENCOMP FOUR #<
           ;
        case2drop :: ZEROZERO ISTOPSTO JSTOPSTO ;
        SWAP 2GETEVAL
        ( root, P, P', test, test-value )
        num0case :: DROP
                    { DUP DO>STR ELEVEN TWO &$ &$ DISPROW7 } User1IT
                    ROTDROP ROTOVER >TCOMP UNROT 1GETLAM EVAL
                    ;
        3DROP
        ( root, P, P', test )
        ;
4NULLLAM{} BIND
( LAM4=dnominateur ,3= nombre de numrateurs, 2= HORN, 1 =prg test )
* suite du prg
( {root}, l, {diviseurs}, an, {num} )
DUPLENCOMP 3PUTLAM
{ 3PICK LENCOMP #>$ ONE &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW6
  5GETLAM #>$ TWELVE &$ DISPROW3
  DUP EDITDECOMP$ #TWO#FOUR SWAP Disp5x7
  }
User1IT
SWAPDROP
( stack={root},  l, { denominateurs } , { numrateurs } )
"HALT" NULL$ DUPDUP 2DUP MENUext
2SWAP
( { deno}, { num }, { root }, P )
* boucle principale de test
4PICK LENCOMP
#1+_ONE_DO (DO)
           4PICK INDEX@ NTHCOMPDROP 4PUTLAM
           ( lam4 = denominateur )
           3GETLAM ( nombre de numerateurs )
           #1+_ONE_DO (DO)
                      ( { deno}, { num }, { root }, P )
                      3PICK INDEX@ NTHCOMPDROP 4GETLAM RDIVext DUP4UNROLL
                      ( { deno}, { num }, test, { root }, P , test )
                      { TWENTYSIX OVER FXNDext DO>STR SWAP
                        DO>STR "/" &$ SWAP&$ &$ DISPROW6 } User1IT
                      1GETLAM EVAL
                      ROT RNEGext 1GETLAM EVAL
                      LOOP
           LOOP
( { deno}, { num }, { root }, P )
ABND ROTDROP ROTDROP
( { 1er lment, root } , P )
SWAPDUP CARCOMP SWAP CDRCOMP
( P, 1er lment, { root } )
3PICK LENCOMP
FOUR #<case :: ROT DEG2ext &COMP SWAP ONE{}N DispMenu.1 ;
UNROTOVER
( { root }, P, 1er element, P )
CARCOMP QUOText SWAP LOPMext
DispMenu.1
;
**************
NULLNAME DEG2ext ( polynome-liste de degre < 3 -> liste des racines )
* Factorisation d'un polynome de degre 2 (eventuellement formel) ou plus
::
DUPNULL{}? ?SEMI
TRLPGCDext LOPDext
DUPLENCOMP #1-
DUP#0= case2drop NULL{}
DUP#1= casedrop :: INCOMPDROP RNEGext SWAP RDIVext ONE{}N ;
#>2case SOLVext
( list )
RESOROMP RMULText
RESOROMP RSUBext
' NULLLAM DUPTWO DOBIND
( LAM1= x-, LAM2= x* )
DUPINCOMP DROP
( list, a, b, c )
FXNDext ROT FXNDext 5ROLL FXNDext
( list, cn, cd, bn, bd, an, ad )
3PICK 6PICK 2GETEVAL ROT 2GETEVAL %2 2GETEVAL 6UNROLL
( list, A, cn, cd, bn, bd, ad )
4ROLLOVER 2GETEVAL 4ROLL 2GETEVAL RNEGext 4UNROLL
( list, A, B, cn, bd, ad )
2GETEVAL 2GETEVAL %2 2GETEVAL
( list, A, B, C )
OVERDUP 2GETEVAL
( list, A, B, C, B^2 )
SWAP4PICK
( list, A, B, B^2, C, A )
2GETEVAL 1GETLAM EVAL
( list, A, B, delta )
:: complexflag TestUserFlag ?SEMI
   DUPTYPEREAL? NOT?SEMI
   DUP %0< NOT?SEMI 3DROP NULL$ >TAG ONE{}N ABND RDROP
   ;
XSQRext
( list, A, B, D )
2DUP 1GETLAM EVAL
( list, A, B,D, B-D )
4PICK RDIVext
4UNROLL
( list, root1, A, B, D )
RADDext SWAP RDIVext
TWO{}N
SWAPDROP ABND
;
**************
NULLNAME PIext ( liste -> produit des elements de liste )
::
INNERCOMP
DUP#0=csedrp %1
DUP#1= caseDROP
ONE_DO (DO)
       SWAP RMULText
       LOOP
;
******************************
NULLNAME POSITIFext ( obj -> obj, flag )
* essaie de determiner si on est + a l'infini 
::
( obj -> obj, flag )
DUP' ::	CARCOMP
	1GETLAM EVAL
	;
' ::	CK&DISPATCH1
	TWO	C>Re%
	list	2GETEVAL
	symb	2GETEVAL
	EIGHT	2GETEVAL
	any	NOP
	;
' NULLLAM DUPTWO DOBIND
( n/d, n/d )
FXNDext 1GETLAM EVAL
( n/d, n, D )
DUPTYPEREAL? 
ITE ::	%0> ?SEMI 
	DROP FXNDext RNEGext SWAP RNEGext
	( -d, -n )
	DUPROT NDXFext SWAP
	( -n/-d, -n )
	;
	DROP
( n/d, n )
1GETLAM EVAL
( n/d, N )
DUPTYPEREAL? ITE %0> DROPTRUE
ABND
;
*****************************************************************
NULLNAME DENOLCMext
::
( liste -> ppcm des denos ) 
INNERCOMP
DUP#0=csedrp %1
#1-SWAP FXNDext SWAPDROPSWAP
( o1, ..., on-1, res, #n-1 )
DUP#0=csDROP
ZERO_DO (DO)
	( o1, ..., on-1, res )
	SWAP FXNDext SWAPDROP 
	TWO{}N TRLPGCDext SWAP INCOMPDROP RMULText SWAP RDIVext
	LOOP
;
*******************
NULLNAME asopext
::
CK2FPOLY internalflag TestUserFlag ?SEMI
DUP DEPTHext 3PICK DEPTHext 2DUP#= NcaseSIZEERR
#MAX COLA BINEVALext
;
***************
NULLNAME rrefext
::
AXLext DTYPFMAT? NcaseTYPEERR
ONE REDLIBext DUP' NULLLAM SIX NDUPN DOBIND ONE 3GETLAM EVAL ABND
;
********************
NULLNAME LOPAext ( liste, objet, oprateur binaire -> liste )
* List Operation All
::
' :: dLISTcase LISTSECOext
     3GETLAM 2GETEVAL
     ;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME LOPMext ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
::
SWAP
num1=case DROP
RESOROMP RMULText
LOP1ext
;
**************
NULLNAME DIVOBJext ( f, obj  -> f/obj )
::
num1=case DROP RESOROMP RDIVext LOPAext
;
***********************************************************
NULLNAME DIVext ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynomes-listes ou de 2 reels
* calcule le quotient et le reste
* Note: il faudrait aussi faire symb div symb
::
{ %0 } UNROT
CK&DISPATCH1
2REAL :: ROTDROP TEN TestUserFlag
         case :: 2DUP %MOD
                 ( a, b, a mod b )
                 DUP4UNROLL ROTSWAP %- SWAP %/ SWAP
                 ;
         RDIVext %0
         ;
2LIST :: DIV2LISText SWAP TRIMext SWAP ;
EIGHTY ::	( { %0 }, liste, objet )
		FXNDext 
		( { %0 }, liste, obj-n, obj-d )
		DUP 4ROLL RMULText
		( { %0 }, obj-n, obj-d, liste*obj-d )
		ROT
		( { %0 }, obj-d, liste*obj-d, obj-n )
		NOTLISTcase :: DIVOBJext SWAPDROPSWAP ;
		4ROLLDROP DIVext
		( obj-d, liste*obj-d/obj-n, mod )
		ROT DIVOBJext
		;
list :: ( { %0 }, objet, liste )
	SWAP FXNDext
        ( { %0 }, liste, obj-n, obj-d )
	DUP 4ROLL RMULText
        ( { %0 }, obj-n, obj-d, liste )
	3PICK TYPELIST? 
	case :: ( { %0 }, obj-n, obj-d, liste )
		4ROLLDROP ROTSWAP 
		( obj-d, obj-n, liste )
		DIVext ROT DIVOBJext
		;
        ( { %0 }, obj-n, obj-d, liste )
	DUPLENCOMP #1= NOTcasedrop :: NDXFext ONE{}N ;
	SWAPDROP
        TRIMOBJext
        NDXFext
        ( le probleme vient de 0 sur liste -> recursion avec SIMPNDXFext )
        SWAP
        ;
any :: ROTDROP RDIVext DUP %0 RMULText ;
;
**************
NULLNAME LOPDext ( liste, objet -> { elements de liste / objet } )
* List Operation Division,
* attention les elements de liste doivent etre divisibles par objet
::
num1=case DROP
RESOROMP QUOText
( liste, obj, prg )
LOP1ext
;
**************
NULLNAME DERext ( polynome-liste -> derivee )
::
INNERDUP
#1=case :: DROP %0 RESOROMP RMULText LOPAext ONE{}N ;
DUP #2= case2drop ONE{}N
UNROTDROP OVER UNROLL DUPTWO
    DO
    SWAPINDEX@ UNCOERCE RESOROMP RMULText LOPAext OVER UNROLL
    LOOP
#1-{}N
;
*************
NULLNAME INTEGRext ( polynome-liste -> primitive )
* calcule la primitive s'annulant en 0
::
INNERCOMP #1+DUP
ONE_DO (DO)
       SWAPINDEX@ UNCOERCE RESOROMP RDIVext LOPAext OVER UNROLL
       LOOP
%0 SWAP {}N
;
**************
NULLNAME LRDMext ( liste #entier -> liste )
* Left ReDiMension
* Rajoute des 0  gauche pour obtenir un polynome "de degre" egal a
* l'entier specifie
::
#1+ OVER LENCOMP 2DUP#<
( liste, entier+1, longueur de liste , ?entier+1<longueur de liste)
case :: ( liste trop longue: on supprime a gauche )
        DUPROT #-+1 SWAP SUBCOMP
        ;
#-OVER CARCOMP %0 RMULText SWAP NDUPN {}N SWAP &COMP
;
**************
NULLNAME RRDMext ( liste entier -> liste )
* Right ReDiMension: comme LRDM mais cree des zeros a droite
::
#1+ OVER LENCOMP 2DUP#<
( liste, entier+1, longueur de liste , ?entier+1<longueur de liste)
casedrop :: ( liste trop longue: on supprime a droite )
            ONESWAP SUBCOMP
            ;
#-OVER CARCOMP %0 RMULText SWAP NDUPN {}N &COMP
;
**************
NULLNAME TRIMext ( liste -> liste )
* Enleve les zeros en tete de liste
::
:: CK&DISPATCH1
   list TWO
   seco ONE
   symb ONE
   any ZERO
   ;
DUP#0=csDROP
SWAP
TRIMOBJext
SWAP#1- #0=?SEMI
NOTLISTcase ONE{}N
;
************************
NULLNAME DEGREext ( objet -> degre )
* renvoie le degre d'un polynome-liste
::
CK&DISPATCH1
list :: TRIMext LENCOMP #1-
        ;
real %ABSCOERCE
TWO :: C%ABS COERCE ;
any DROPZERO
;
**************
NULLNAME COMPRIMext ( liste -> liste comprimee au sens ensembliste )
::
DUPNULL{}? ?SEMI INNERCOMP reversym NULL{} SWAP
ZERO_DO (DO)
        SWAP apndvarlst
        LOOP
;
**************
NULLNAME NEXTPext ( liste -> liste1, liste2 )
* liste=liste1+liste2, liste2 est formee d'elements identiques
( { o1 o2 ... } -> { liste1 }, { o1 ... o1 } )
( liste1=liste-{o1 ... o1 } )
::
NULL{} SWAPDUP LENCOMP #>1 NOT?SEMI
SWAPDROP
( liste )
INNERDUP
( o1, ..., on, #n, #n )
get1 ONE
( o2, ..., on, #n, #n, o1, #1 )
ROT #1-
ZERO_DO (DO)
	( o2, ..., on, #n, o1, #m )
	ROT
	( o2, ..., on, o1, #m, #n )
	get1
	( o3, ..., on, o1, #m, #n, o2 )
	4PICKOVER
	( o3, ..., on, o1, #m, #n, o2, o1, o2 )
	::	EQUALcasedrp #1-UNROT ( o3, ..., on, #n-1,o1,#m)
		( o3, ..., on, o1, #m, #n, o2 )
		4UNROLL 
		( o3, ..., on, o2, o1, #m, #n )
		UNROT #1-
		( o3, ..., on, o2, #n, o1, #m-1 )
		;
	( o3, ..., on, o2, #n, o1, #m )
	#1+
	LOOP
( o2, ..., on, #n, o1, #m )
NDUPN {}N SWAP#1-SWAP OVER#2+UNROL {}N SWAP
;
**************
NULLNAME QOBJext ( objet [ runstream: programme ] -> objet )
* Exexute programme sur les elements de objet (pour des objets
* de type liste, algebrique ou array en les decomposant)
::
'R
CK1TONOext
' :: CK&DISPATCH1
     real 2GETEVAL
     TWO 2GETEVAL
     sym 2GETEVAL
     ELEVEN 2GETEVAL
     list LISTSECOext
     TAGGED :: xOBJ\-> SWAP 1GETLAM EVAL SWAP x\->TAG ;
     arry :: AXLext 1GETLAM EVAL ;
     seco ::	QXNDext THREE 
		ZERO_DO (DO) 
			1GETLAM EVAL UNROT 
			LOOP 
		NDXQext 
		;
     any NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME FXNDext ( objet -> numerateur, denominateur )
* Decompose une fraction
::
( o -> num, deno )
DUPTYPESYMB? NOTcase %1
%1 OVER
( symb, 1, symb )
INNERCOMP
OVER EQ: xNEG
( symb, 1, meta, flag )
:: NOTcaseFALSE
   SWAPDROP
   #1- TRUE
   ;
OVER#2+UNROL
( symb, 1, flag, meta )
OVER EQ: x/
NOTcase #1+NDROP
SWAPDROP
( symb, 1, flag, meta_sans_x/ )
#1- pshzerpsharg
SYMBNext
OVER#2+UNROL
SYMBNext
( symb, 1, flag, num, deno )
2SWAP SWAPDROP
( symb, num, deno, flag )
4ROLLDROP
NOT?SEMI
SWAP QOBJext xNEG SWAP
;
**************
NULLNAME NDXFext ( numerateur, denominateur -> algebrique )
* inverse de FXND
::
( o2, o1 )
num1=case DROP
OVER num0=case 2DROP
DROP
%-1 EQUALcasedro RNEGext
CK&DISPATCH1
SYMSYM :: ' x/ EvalNoCK ;
# 90 :: SWAPINCOMP get1 ' x/ ROT #2+ SYMBN ;
symb :: INNERCOMP ' x/ SWAP #2+ SYMBN ;
any :: ' x/ THREE SYMBN ;
;
**************
NULLNAME DEPTHext ( objet -> # )
* renvoie la profondeur maximale d'un objet
::
ZEROSWAP 
DUPTYPEREAL? caseDROP
DUPTYPECMP? caseDROP
idntlamcase DROP
SWAP#1+ DEPTHOBJext
;
**********************
NULLNAME LVARext ( objet -> objet, liste des idnt globaux )
::
LLVARDext ROTDROP
;
**************
NULLNAME VXXLext ( algebrique ID -> polynome-liste par rapport a ID )
* si le polynome-liste depend encore de ID, le flag 11 est mis a 0
::
( objet, idnt/symb/lvar -> lvar, liste )
vxxlflag SetUserFlag
* etait a la fin precedemment
internalflag SetUserFlag
* 
DUPTYPELIST? ?SKIP ONE{}N
( o, lvar )
DUPUNROT
( lvar, objet, lvar )
' :: ( LAM21 )
     ROTDROP SWAP#1-SWAP OVER#2+UNROL
     ( oper, o1, ..., on-1, #n-1 )
     pshzerpsharg
     ( oper, meta2, meta1 )
     2GETEVAL EVAL
     ( oper, meta2, liste1 )
     OVER#2+UNROL 2GETEVAL EVAL
     ( oper, list1, list2 )
     ROT EVAL
     ;
' :: ( LAM20 )
     DUP CARCOMP
     EQ: x<<
     case :: INNERCOMP #5= NcaseTYPEERR
             4UNROLL THREE
             ZERO_DO (DO) 1GETLAM EVAL UNROT LOOP
             4ROLL FIVE ::N
             ;
     EVAL 5GETLAM EVAL ?SEMI
     cmp_i EQUALcasedro C% 0 1
     ;
( LAM19 ) RESOROMP RADDext
( LAM18 ) RESOROMP RSUBext
( LAM17 ) RESOROMP RMULText
( LAM16 ) RESOROMP RDIVext
( LAM15 ) RESOROMP RCONJext
( LAM14 ) RESOROMP RNEGext
( LAM13 ) RESOROMP RIMext
( LAM12 ) RESOROMP RREext
( LAM11 inutilise RESOROMP NDXFext ) 'NOP
( LAM10 ) RESOROMP FXNDext
' :: ( LAM9 x\v/ )
     real_intflag UserITE
     :: SIMPEVALext XSQRext ;
     :: ' x\v/ TWO SYMBN ;
     ;
' :: ( LAM8 x= )
     18GETLAM EVAL
     ZEROSWAP 22GETLAM VAL2ext
     %0 ' x= EvalNoCK
     vxxlflag ClrUserFlag 4GETLAM EVAL
     ;
' :: ( LAM7 xINV ) 10GETLAM EVAL SWAP 16GETLAM EVAL ;
' :: ( LAM6 xSQ ) DUP 17GETLAM EVAL ;
' :: ( LAM5 objet -> objet, false ou liste, true )
     22GETLAM OVER EQUALPOSCOMP
     DUP#0=csedrp FALSE
     SWAPDROP
     ( #pos )
     { %1 %0 } SWAP
     DUP#1= casedrop TRUE
     ONE_DO (DO) ONE{}N LOOP TRUE
     ;
' :: ( LAM4 : objet -> objet dans des listes )
     22GETLAM LENCOMP
     DUP#0=csDROP
     ZERO_DO (DO) ONE{}N LOOP
     ;
' :: ( LAM3 o1,..., on-1, x^, #n -> liste ou objet )
     3PICK DUPTYPEREAL?
     NOTcasedrop :: vxxlflag ClrUserFlag SYMBN 4GETLAM EVAL ;
     DUPDUP %FLOOR %=
     ( o1, ..., on-1, x^, #n, on-1, ?on-1=bint )
     NOTcasedrop :: vxxlflag ClrUserFlag SYMBN 4GETLAM EVAL ;
     ( o1, ..., on-1, x^, #n, on-1 )
     %0< OVER#2+UNROL SWAPDROPSWAP %ABSCOERCE
     ( ?negatif, o1, ..., on-2, #n, #exposant )
     OVER UNROLL
     ( ?negatif, #exposant, o1, ..., on-2, #n )
     #2-
     ( stk=?negatif, #exposant, meta )
     DUP#1+ NDUP DUP#1= ITE_DROP SYMBN
     ( stk= ?negatif, #exposant, meta, symb )
     22GETLAM NTHOF
     ( ?negatif, #exposant, o1, ..., on-2, #n-2, #pos )
     :: DUP#0=csedrp :: 2GETEVAL EVAL SWAP 17GETLAM MPext ;
        ( ?negatif, #exp, meta, #pos )
        OVER#2+UNROL NDROP
        ( ?negatif, #exp, #pos )
        %1 %0 4ROLL NDUPN #1+ {}N
        ( #pos, {} )
        SWAPDUP #1= caseDROP
        ONE_DO (DO) ONE{}N LOOP
        ;
     SWAP NOT?SEMI 10GETLAM EVAL SWAP 16GETLAM EVAL
     ;
' :: ( LAM2 de VXXL meta -> liste ou objet )
     DUP#1=
     casedrop 1GETLAM
     DUP#1+ NDUP SYMBN 5GETLAM EVAL
     case :: OVER#2+UNROL NDROP ;
     ( teste l'oprateur x^ )
     ( o1, ..., on, #n, symb )
     DROP
     AEQ1stcase x^ 3GETLAM
     :: AEQ1stcase x+ 19GETLAM
        AEQ1stcase x* 17GETLAM
        AEQ1stcase x- 18GETLAM
        AEQ1stcase x/ 16GETLAM
        AEQ1stcase x= 8GETLAM
        ;
     ( o1, ..., on, #n, lam | o1,...,on,#n )
     DUPTYPEBINT?
     NOTcase 21GETLAM
     ( o1, ..., on, #n )
     :: AEQ1stcase x\v/ 9GETLAM
        AEQ1stcase xNEG 14GETLAM
        AEQ1stcase xSQ 6GETLAM
        AEQ1stcase xINV 7GETLAM
        complexflag TestUserFlag ?SEMI
        AEQ1stcase xRE 12GETLAM
        AEQ1stcase xIM 13GETLAM
        AEQ1stcase xCONJ 15GETLAM
        ;
     DUPTYPEBINT?
     NOTcase :: ( o1, ..., on, #n, prg )
                ROTDROP SWAP#1-SWAP OVER#2+UNROL
                ( oper, meta2, #0 )
                2GETEVAL EVAL
                ( oper unaire, liste1 )
                SWAP
                ;
     ( operateur non reconnu )
     SYMBN
     ( symb )
     ( teste si symb est dans la liste LAM22 )
     5GETLAM EVAL
     ( symb, false ou liste, true )
     ?SEMI
     vxxlflag ClrUserFlag
     4GETLAM
     ;
( LAM1 objet -> liste ou objet )
' :: CK&DISPATCH1
     real NOP
     list LISTSECOext
     symb :: INNERCOMP 2GETEVAL EVAL
             ;
     sym :: 5GETLAM EVAL ?SEMI
            4GETLAM EVAL
            ;
     seco :: 20GETLAM EVAL
             ;
     any NOP
     ;
' NULLLAM TWENTYTWO NDUPN DOBIND
( lvar, o )
1GETLAM NOSIMPEVALext EVAL ABND
( elimination des zeros et simplification eventuelle )
;
**************
NULLNAME VALext ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )
* appelle VALOBJext apres avoir devine la profondeur
::
( P, lvar )
internalflag ClrUserFlag
DUPTYPELIST? ?SKIP ONE{}N
( P, lvar )
DUPLENCOMP 3PICK DEPTHext
( P, lvar, #lvar, #profondeur de P )
2DUP#> IT 2DROP00
SWAP#-
( P , lvar, #- )
UNROT VALOBJext
;
******************
NULLNAME %PGCDext  ( r1, r2 -> pgcd )
* PGCD de 2 rels
( r, r' -> pgcd )
CODE
* entree non supportee mais stable
	GOSBVL	=POP2%SPLITAC
loop	GOSBVL	=STCD2	( sauvegarde de y )
	GOSBVL	=aMODF	( x= x mod y )
	GOSBVL	=RCCD2	( restaure y )
	GOSBVL	=XYEX	( donc y est le reste, x est le precedent )
	?D#0 W		( le reste est-il nul ? )
	GOYES	loop
	A=0	S	( pour prendre la valeur absolue )
	GOSBVL	=XYEX	( le pgcd est le dernier reste non nul: x, x -> y )
	LA(5)	=%1	( comparaison avec %1 )
	D1=A
	D1=D1+	5
	A=DAT1	W
	GOSBVL	=SPLITA	( x=%1, y=pgcd )
	P=	1
	GOSBVL	=TST15
	P=	0
	SETHEX
	GONC	%pgcdf
	A=C	W
	C=D	W
	B=C	W
%pgcdf	GOSBVL	=PACK 
	GOVLNG	=PUSH%LOOP
ENDCODE
( pgcd )
************************
NULLNAME TRLPGCDext
::
TRIMext LPGCDext
;
**************
NULLNAME LPGCDext ( liste -> liste, PGCD de la liste )
::
NOTLISTcase DUP
pgcdflag TestUserFlag NOTcase %1
' ::	( LAM10 C%PGCD, C%, C% -> C% )
	( a, b )
	[BEGIN]
		DUP C%0=
	NOT_WHILE
		::	DUPUNROT ' x/ EvalNoCK
			( b, q )
			DUP C%>% 
			( b, q, re, im )
			%0 RNDXY SWAP %0 RNDXY SWAP%>C%
			( b, q, int[q] )
			' x- EvalNoCK OVER 'x* EvalNoCK
			( b, r )
			C%>% %0 RNDXY SWAP %0 RNDXY SWAP%>C%
			( b, r )
			;
	[REPEAT]
	DROPDUP C%0= casedrop %1
	( pgcd )
	C%>%
	( re, im )
	DUP%0= casedrop %ABS
	SWAPDUP DUP%0= case2drop %ABS
	( im, re, re )
	%ABS SWAP %0< ROTDUP 
	( re, re<0, im, im )
	%ABS UNROT %0<
	( re, im, re<0?, im<0? )
	XOR IT SWAP %>C%
	;
' :: ( LAM 9 )
     QXNDext DROPROT QXNDext DROP 2GETEVAL EVAL 2GETEVAL EVAL 2GETEVAL EVAL
     ;
' :: ( LAM 8 TCOMPLPGCD )
     num0=case DROP >TCOMP
     1GETLAM EVAL SWAPDROP
     ;
( LAM 7 ) RESOROMP RMULText
( LAM 6 ) RESOROMP %PGCDext
' :: ( LAM5 %C%PGCDext %, C% -> pgcd )
     C%>% ROT 6GETLAM EVAL 6GETLAM EVAL
     ;
' ::	( LAM4 o2, o1 -> pgcd pour des non listes )
	2DROP %1
*	TWO{}N LVARext
*	( { o2 o1 }, lvar )
*	DUPLENCOMP
*	#0= case2drop %1
*	( { o2 o1 }, lvar )
*	VXXLext
*	( lvar, { l1 l2 } )
*	1GETLAM EVAL SWAPDROP
*	( lvar, pgcd )
*	ZERO UNROTSWAP VALOBJext
*	internalflag ClrUserFlag
*	( pgcd )
	;
' :: ( LAM3: list1, list2 -> pgcd )
     ( l1, l2 )
     DUPLENCOMP
     ( l1, l2, #l2 )
     3PICK LENCOMP
     ( l1, l2, #l2, #l1 )
     2DUP #MIN 5UNROLL
     ( #min, l1, l2, #l2, #l1 )
     #>ITE SWAPROT ROT
     ( l1, l2 avec l1 plus long que l2, #min )
     #1=case :: &COMP 1GETLAM EVAL SWAPDROP ONE{}N TRIMOBJext ;
     ( l1, l2 )
     1GETLAM EVAL DUP4UNROLL LOPDext
     ( pgcd[l2] / autres var, l1, l2' )
     SWAP 1GETLAM EVAL
     ( pgcd[l2] / autres var, l2', l1, pgcd[l1] )
     DUP4UNROLL LOPDext
     ( pgcd[l2], pgcd[l1], l2', l1' )
     2SWAP 2GETEVAL EVAL ONE{}N UNROTSWAP
     ( rmult,  pgcd[l1,l2] par rapport aux autres var, l1', l2' )
     BEGIN
          ( lpgcd, l1, l2 )
          DUPLENCOMP #1<>
     WHILE
          ( multiplication du numrateur par un inversible )
          DUPDUP CARCOMP DUPROT LENCOMP
          ( lpgcd, l1, l2, a2.1, a2.1, #l2 )
          5PICK LENCOMP SWAP#-
          ( lpgcd, l1, l2, a2.1, a2.1, #l1-#l2 )
          DUP#1= ITE_DROP :: 7GETLAM MPext ;
          ( lpgcd,  l1, l2, a2.1, coef )
          SWAP4PICK CARCOMP
          ( lpgcd,  l1, l2, coef, a2.1, a1.1 )
          OVER 2GETEVAL EVAL
          ( lpgcd,  l1, l2, coef, a2.1, pgcd )
          QUOText
          ( lpgcd,  l1, l2, coef, a2.1/pgcd )
          7GETLAM EVAL
          ( lpgcd,  l1, l2, coef )
          ROT LOPMext
          ( lpgcd,  l2, l1' )
          ( division de l1' par l2 )
          { %0 } SWAP3PICK DIV2LISText
          ( lpgcd,  l2, l1 div l2, l1 mod l2 )
          SWAPDROP
          ( lpgcd,  l2, l1 mod l2 )
          TRIMext 1GETLAM EVAL LOPDext
          ( lpgcd,  l1'=l2, l2'=l1 mod l2 )
     REPEAT
     ( lpgcd,  l1, l2 avec degre=0 )
     CARCOMP
     :: num0=case DROP
        2DROP %1
        ;
     7GETLAM EVAL
     ;
' :: ( LAM2: PGCDext obj1, obj2 -> pgcd )
     CK&DISPATCH1
     2REAL 6GETLAM
     2LIST 3GETLAM
     EIGHTY 8GETLAM
     list :: SWAP 8GETLAM ;
     seco 9GETLAM
     BINT80h 9GETLAM
     EIGHTEEN 5GETLAM
     THIRTYFOUR 10GETLAM
     THIRTYTHREE :: SWAP 5GETLAM ;
     any 4GETLAM
     ;
' :: ( LAM1: liste -> liste, lpgcd )
     DUPINCOMP
     DUP#0=csedrp %1
     DUP#1=
     ITE_DROP
        :: ( o1, ..., on, #n )
           MINUSONE
           ( o1, .., on, #n, length )
           SWAPDUP
           ZERO_DO (DO)
                   ( o1, ..., on, length, #n )
                   :: get1
                      num0=case DROP#1-
                      NOTLISTcase :: UNROT ExitAtLOOP ;
                      ( o2, ..., on, length, #n, o1 )
                      DUPLENCOMP 4ROLL
                      ( o2, ..., on, #n, o1, #l1, length )
                      2DUP #MIN 5UNROLL
                      #<case UNROT 4UNROLL
                      ;
                   LOOP
           ( o1, ..., on, length, #n )
           SWAPDROP
           DUP#0=csedrp %1
           DUP#1= caseDROP
           ONE_DO (DO)
                  DUP %1
                  :: EQUALNOTcase 2GETEVAL
                     ISTOP-INDEX #1+NDROP ExitAtLOOP %1
                     ;
                  EVAL
                  LOOP
           ;
     %0 EQUALcasedro %1
     ;
' NULLLAM TEN NDUPN DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME SIMPext ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
::
pgcdflag TestUserFlag NOT?SEMI
:: CK&DISPATCH1
   real :: DUP %0> ?SEMI %CHS SWAP RNEGext SWAP ;
   TWO :: DUP C%CONJ DUPUNROT 'x* EvalNoCK C>Re% UNROT RMULText SWAP ;
   any NOP
   ;
CK&DISPATCH1
2REAL :: 2DUP %PGCDext
         ( r1, r2, pgcd )
         ROTOVER %/ UNROT %/
         ( r1, r2 simplifies )
         ;
THIRTYTHREE :: 2DUPSWAP C%>% %PGCDext %PGCDext ROTOVER ' x/ EvalNoCK UNROT %/ ;
list SIMPLISText
EIGHTY SIMPLISText
seco :: QCONJext DUP QNORMext UNROT QMULText SWAP SIMPLISText ;
BINT80h SIMPLISText
* any :: symbolicflag TestUserFlag NOT?SEMI
*       NDXFext SIMP1ext FXNDext
*       ;
any NOP
;
**************
NULLNAME SIMP1ext ( symb -> symb simplifie )
::
internalflag TestUserFlag SWAP
LLVARDext VXXLext TRIMext SWAP
( retransforme en symbolique )
internalflag ClrUserFlag VALOBJext
SWAP NOT?SEMI internalflag SetUserFlag
;
***********************************************************
NULLNAME SIMPLISText ( list, list -> list ou %0, list )
* Simplification par division par le PGCD de deux polynome-listes
::
( o2, o1 )
TWO{}N TRLPGCDext LOPDext INNER#1= IT :: %0 SWAP ;
{ %1 } EQUALcasedro %1
;
**************
NULLNAME NUMEVALext
* evalue l'objet suivant du runstream en mode num
::
'R real_intflag TestUserFlag
2Ob>Seco real_intflag ClrUserFlag EVAL
NOT?SEMI real_intflag SetUserFlag
;
*****************************************************************
NULLNAME NOSIMPEVALext
* evalue l'objet suivant du runstream sans faire de simplifications
::
'R pgcdflag TestUserFlag 2Ob>Seco pgcdflag ClrUserFlag EVAL
NOT?SEMI pgcdflag SetUserFlag
;
*****************************************************************
NULLNAME SQFFext ( liste -> liste des facteurs )
::
( obj )
DUPNULL{}? ?SEMI
TRIMext
' ::	( LAM3: objet -> liste facteurs )
	NOTLISTcase 
	::	dREALNcase ONE{}N
		DUP %0< ITE { %-1 } NULL{}
		( reel, liste )
		SWAP %ABS DUP %FP %0= NOTcase >TCOMP
		%2
		BEGIN
			2DUP DUP %* %>=
		WHILE
			2DUP %MOD %0=
			NOTcase %1+
			ROTOVER >TCOMP UNROTSWAP OVER %/ SWAP
		REPEAT
		DROP >TCOMP
		;
	( p )
	LPGCDext %1 EQUALcasedro ( liste ) 2GETEVAL
	( p, lpgcd )
	DUP 3GETLAM EVAL
	( p, lpgcd, liste facteurs du lpgcd )
	LISTSECOext
	( affectue ONE{}N sur les facteurs du LPGCD )
	( p, lpgcd, liste facteurs de p )
	UNROT LOPDext
	( liste facteurs, p/lpgcd )
	2GETEVAL
	&COMP
	;
' :: ( LAM2 polynome-liste -> liste de facteurs )
     DUPDUP DERext TWO{}N LPGCDext SWAPDROP
     ( p, pgcd )
     DUPTYPELIST? NOTcasedrop ONE{}N
     ( p, pgcd[p,p'] )
     ( le terme de degre n est-il positif?)
     POSITIFext
     ( p, pgcd[p,p'], ?terme principal positif )
     ?SKIP RNEGext
     ( fin du test de positivite )
     DUPLENCOMP #1=
     ( p, pgcd[p,p'], degre=0? )
     casedrop ONE{}N
     DUP 2GETEVAL
     ( p, pgcd[p,p'], { facteurs du pgcd } )
     DUP COMPRIMext
     ( p, pgcd[p,p'], { facteurs du pgcd }, { facteurs comprimes du pgcd } )
     DUP PIext
     ( p, pgcd[p,p'], { fact_pgcd }, { fact_comp pgcd }, produit )
     4ROLL RMULText
     ( p, { fact_pgcd }, { fact_comp pgcd }, produit )
     4ROLLSWAP QUOText
     ( {fact_pgcd }, { fact_comprime pgcd }, quotient )
     DUPLENCOMP #1= IT CARCOMP
     %1 EQUALcasedro &COMP >TCOMP &COMP
     ;
' ONE{}N
' NULLLAM DUPDUP THREE DOBIND
( p )
3GETLAM EVAL TRIMext
ABND
;
**************
NULLNAME XSQRext ( objet -> racine carree de l'objet )
::
( obj -> sqrt[obj] )
TRIMOBJext
CK&DISPATCH1
real :: DUP %0< SWAP %ABS
        ( RACext  reel positif -> racine carree )
        :: real_intflag TestUserFlag NOTcase %SQRT
           DUPDUP %FLOOR %<> case %SQRT
           DUP %SQRT DUPDUP %FLOOR %=
           case SWAPDROP
           DROP SQFFext
           INNERCOMP %1 DUPDUP 4ROLL
           ZERO_DO (DO)
                   ( facteurs, liste_simples, liste_doubles, dernier facteur )
                   :: 4ROLL 2DUP
                      EQUALcasedrp :: %* %1 ;
                      SWAPDROP ROTOVER %* UNROT
                      ;
                   LOOP
           DROP 2DUP %/
           %1=case 2DROP
           ROTDROP internalflag TestUserFlag
           case :: %0 UNROT NDXQext ;
           ' x\v/ TWO SYMBN 'x* EvalNoCK
           ;
        ( fin de RACext )
        SWAP NOT?SEMI
        C% 0 1 RMULText
        ;
TWO :: DUP C>Re% DUPDUP %FLOOR %= NOTcasedrop C%SQRT
       OVER C%>%% DUP %%* SWAPDUP %%* %%+ %%>% XSQRext
       2DUP RADDext %2 RDIVext XSQRext UNROTSWAP
       RSUBext %2 RDIVext XSQRext ROT C>Im%
       %0< ITE C% 0 -1 C% 0 1 RMULText 
	num0=case DROP RADDext
       ;
seco :: DUP QNORMext 
        ( x, |x| )
        DUP XSQRext
        ( x, |x|, sqrt[|x|] )
	:: ( teste si |x| est un carre parfait )
           ( si sqrt|x| est un seco, alors il doit avoir le meme radical que x)
           CK&DISPATCH1
           real TRUE
           list TRUE
           seco :: OVER DUPTYPECOL? NOTcase DROPFALSE
                   FOUR NTHCOMPDROP OVER FOUR NTHCOMPDROP EQUAL
                   ;
	   any FALSE
           ;
        ROTDROP
        NOTcasedrop :: %0 %1 ROT NDXQext ; 
        ( x, sqrt[|x|] )
        SWAP QXNDext 
        ( sqrt, d, e, c )
        2SWAP
        ( e, c, sqrt, d )
        2DUPSWAP RSUBext %2 RDIVext XSQRext
        ( e, c, sqrt, d, a )
        :: ( le test n'est probablement le meilleur! )
           NOTSECOcase UNROT2DROP
           DROP RADDext %2 RDIVext XSQRext
           ;
        ( e, c, a )
        ROTSWAP DUP4UNROLL
        ( a, c, e, a )
        %2 RMULText RDIVext 
        ( a, c, b )
	SWAP
	( a, b, c )
        ( teste la positivit\'e pour des r\'eels ) 
	CK&DISPATCH1
	# 111 :: 2DUP 5PICK UNROT NDXQext 4UNROLL %SQRT %* %+ %0< IT RNEGext ;
        any NDXQext
        ;
list :: SQFFext
        NULL{} DUPROT
        ( liste_rac_s, liste_rac_d, liste_rac )
        [BEGIN]
             DUPNULL{}?
        NOT_WHILE
             :: ( liste_rac_s, liste_rac_d, liste_rac )
                NEXTPext
                ( liste_rac_s, liste_rac_d, reste_rac, racine_act )
                DUPLENCOMP TWO #/ ROT CARCOMP
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, mult_d, rac )
                DUPROT NDUPN {}N
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, rac, rac_d )
                5ROLL &COMP 4UNROLL
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, rac )
                SWAP #0=case DROP
                ( liste_rac_s, liste_rac_d, reste_rac, rac )
                4ROLLSWAP >HCOMP UNROT
                ;
        [REPEAT]
        ( liste_rac_s, liste_rac_d, null{} )
        DROP
        PIext
	( change le signe si n\'ecessaire ) 
	POSITIFext
	?SKIP RNEGext
	( fin du changement de signe )
        SWAP PIext
        ( sym=doubles, simples )
        ' :: ( obj -> symf = sqrt[objet] )
             TRIMOBJext NOTLISTcase XSQRext
             internalflag TestUserFlag
             case :: %0 %1 ROT NDXQext ;
             ' x\v/ TWO SYMBN
             ;
        UNROT LPGCDext DUPUNROT LOPDext
        ( prg, doubles, lpgcd[simples], simples/lpgcd[simples] )
        4PICK EVAL 4UNROLL ONE{}N ROT EVAL
        ( symf_simples, doubles, symf_lpgcd )
        ROT NOSIMPEVALext 
	::	RMULText SWAP
	        ( symf, doubles )
		RMULText
		;
        ;
sym ::  FXNDext 
        %1 EQUALcasedro x\v/
*        :: 
*	   internalflag TestUserFlag SWAP 
*           LLVARDext
*           ( flag17, #prof, symb, lvar )
*           VXXLext FXNDext DUPUNROT RMULText
*           ( #prof, lvar, deno, num*deno )
*           XSQRext SWAP NDXFext SWAP
*           VALOBJext 
*           SWAP ?SEMI internalflag ClrUserFlag
*           ;
        DUPUNROT RMULText XSQRext SWAP RDIVext
        ;
; 
**************
NULLNAME idnext ( cre la matrice identite)
* liste, arry, real ou # -> identite
::
DUPTYPELIST? IT LENCOMP
DUPTYPEBINT? IT UNCOERCE
' xIDN EvalNoCK AXLext
;
**************
