* -*- mode:Mail -*-
        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h

* Rpertoire ARIT

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )

*******************************************************************
***************   LIFC
            CON(2) ((LIFCfin)-(LIFCdeb))/2
LIFCdeb   NIBASC /LIFC/
LIFCfin   CON(2) ((LIFCfin)-(LIFCdeb))/2
RPL
::
CK1NOLASTWD DTYPELIST? NcaseTYPEERR
' :: DUP CARCOMP SWAP CDRCOMP DUPNULL{}?
     casedrop %1
     1GETLAM EVAL SWAP DUP4UNROLL ROT RMULText RADDext SWAP
     ;
DUP1LAMBIND EVAL ABND
;
ASSEMBLE
LIFC      CON(5) (LIFC)-(LIFCdeb)+2
*******************  LIFC
*******************************************************************

*******************************************************************
***************     FCLI
            CON(2) ((FCLIfin)-(FCLIdeb))/2
FCLIdeb   NIBASC /FCLI/
FCLIfin   CON(2) ((FCLIfin)-(FCLIdeb))/2
RPL
::
CK1NOLASTWD DTYPEREAL? NcaseTYPEERR
ID EPS %>%%
DUP %%1/
ROTDUP
%>%%
2DUPSWAP %FLOOR ONE{}N SWAP
BEGIN
     ( %%1/eps, %x, %%error, liste, %%x-[x]-... )
     DUP %%FLOOR %%- DUP 7PICK %%<
     ITE FALSE
         :: ( %%1/eps, %x, %%error, liste, %%x-[x] )
            %%1/ ROTOVER
            ( ..., %x, liste, %%1/x-[x], %%error,  %%1/x-[x] )
            DUP %%* %%1 %%+ %%* UNROT
            ( ..., %x, %%error, liste, %%1/x-[x] )
            5PICK 4PICK %%>
            ;
WHILE
     DUPUNROT %%FLOOR %%>%
     >TCOMP SWAP
REPEAT
( %%eps, %%1/eps, %x, %%error, liste, %%x-[x] )
6ROLL  %%<
( %x, %%error, liste, infrieur  epsilon? [-> rationel] )
ITE :: UNROT2DROP ID LIFC DUP %1
       %= ITE DROP :: ' U/ THREE SYMBN ;
       ( p/q )
       ;
    :: SWAPDROP DUP ID LIFC  DUP %1
       %= ITE DROP :: ' U/ THREE SYMBN ;
       ( %x, 'p/q' )
       DUP UEVAL 4ROLL %- %ABS ID EPS %< IT SWAP
       DROP ;
SWAPDROP
;
ASSEMBLE
FCLI      CON(5) (FCLI)-(FCLIdeb)+2
***************    FCLI
*******************************************************************

*******************************************************************
***************     ORND  ( algbrique, entier -> algbrique )
* Arrondit les scalaires de l'algbrique s'il sont proches
* d'un rationnel de dnominateur l'entier au niveau 1
            CON(2) ((ORNDfin)-(ORNDdeb))/2
ORNDdeb   NIBASC /ORND/
ORNDfin   CON(2) ((ORNDfin)-(ORNDdeb))/2
RPL
::
CK2NOLASTWD
xABS DTYPEREAL? ?SKIP :: DROP %1 ;
ID EPS
' :: CK&DISPATCH1
     real :: 3GETLAM 2DUP %* %0 URND SWAP %/ 2DUP %- %ABS
             2GETLAM %< IT SWAP DROP
             ;
     TWO :: C%>% 1GETLAM EVAL SWAP 1GETLAM EVAL SWAP
            DUP%0= ITE_DROP %>C%
            ;
     symb :: LISTSECOext ELMGext
             ;
     list LISTSECOext
     arry :: xARRY\-> DUPINCOMP #2= IT %*
             COERCEDUP
             ZERO_DO (DO)
                     ( a1,..., an, size, #n )
                     ROT 1GETLAM EVAL OVER#2+UNROL
                     LOOP
             DROP XEQ>ARRAY
             ;
     ZERO NOP
     ;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL ABND
;
ASSEMBLE
ORND      CON(5) (ORND)-(ORNDdeb)+2
***************    ORND
*******************************************************************

*******************************************************************
***************     EULER
            CON(2) ((EULERfin)-(EULERdeb))/2
EULERdeb   NIBASC /EULER/
EULERfin   CON(2) ((EULERfin)-(EULERdeb))/2
RPL
::
CK1NOLASTWD
DTYPEREAL? NcaseTYPEERR
%ABS %FLOOR DUP SQFFext COMPRIMext INNERCOMP get1 SWAP
ZERO_DO (DO)
        ( a1,...,ap,n )
        DUPROT %/ %-
        LOOP
;
ASSEMBLE
EULER      CON(5) (EULER)-(EULERdeb)+2
***************    EULER
*******************************************************************

*******************************************************************
***************     CAB
            CON(2) ((CABfin)-(CABdeb))/2
CABdeb   NIBASC /CAB/
CABfin   CON(2) ((CABfin)-(CABdeb))/2
RPL
::
CK3NOLASTWD
( c, a, b )
EGCDext
( c, d, u, v )
2SWAP DIVext
( u, v, c div d, c mod d )
num0case :: DROP ROTOVER RMULText UNROT RMULText ;
SETSIZEERR
;
ASSEMBLE
CAB      CON(5) (CAB)-(CABdeb)+2
***************    CAB
*******************************************************************


*********************************************************************
*************     XFRC
dernier     CON(2) ((XFRCfin)-(XFRCdeb))/2
XFRCdeb     NIBASC /XFRC/
XFRCfin     CON(2) ((XFRCfin)-(XFRCdeb))/2
RPL
::
CK1NOLASTWD
real_intflag SetUserFlag
' ::	DUP %ABS DUP ID FCLI DTYPELIST?
	ITE ::	INNERCOMP reversym {}N THREE
		BEGIN
			DUP#0<>
		WHILE
			2DUP ONESWAP SUBCOMP OVER 4PICK SWAPDUP 
			#1+SWAP #2* SUBCOMP OVER EQUAL DUP
			IT ::	DROPOVER 4PICK SWAPDUP #2* #1+SWAP 
				THREE #* SUBCOMP OVER EQUAL
				;
			DUP
			IT ::	DROPOVER #1= NOTcase TRUE 3PICK 
				FOUR NTHCOMPDROP OVER INCOMPDROP %=
				;
			NOTcase DROP#1-
			UNROTDUP FOUR #* 3PICK
			LENCOMP #1+
			BEGIN
				2DUP#< DUP
				IT ::	DROP 4PICK 3PICK DUP 6PICK 
					#-+1 SWAP SUBCOMP 6PICK 
					EQUAL
					;
			WHILE
				SWAP3PICK #+SWAP
			REPEAT
			DROPSWAP #-+1 MINUSONE SUBCOMP
			INNERCOMP reversym {}N SWAP
			real_intflag DUP TestUserFlag 4UNROLL
			SetUserFlag
( ID QU )
DUPLENCOMP
::	ONE OVER#=case 
	::	DROP INCOMPDROP %CHS %1 SWAP % -1 
		;
	TWO OVER#=case 
	::	DROP INCOMPDROP 2DUP %* %CHS SWAP %CHS 
		;
	THREE OVER#=case 
	::	DROP INCOMPDROP 2DUP %* DUP %1+ %CHS
		5UNROLL 4PICK DUPROT %* %CHS SWAP %-
		OVER %- 3PICK %+ 5UNROLL DROP %* %1+ UNROT
		;
;
THREE {}N  
internalflag SetUserFlag
DEG2ext CDRCOMP CARCOMP
( Fin de QU )
			>TCOMP ID LIFC RDIVext
			SWAP ?SKIP :: real_intflag ClrUserFlag ;
			ZERO
		REPEAT
		DROP DTYPELIST? ?SKIP SWAP DROP
		;
	SWAPDROP SWAP %0< IT RNEGext
	ZEROSWAP NULL{} VAL2ext
	;
' ::	CK&DISPATCH1
	real 2GETEVAL
	TWO :: C%>% 2GETEVAL SWAP 2GETEVAL SWAP C% 0 1 x* x+ ;
	list LISTSECOext
	symb LISTSECOext
	any NOP
	;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
real_intflag ClrUserFlag
ABND
;
*ASSEMBLE
*XFRC        CON(5) (XFRC)-(XFRCdeb)+2
****************  XFRC
*********************************************************************
