* -*- mode:Mail -*-
        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h
		
* Rpertoire FUNC

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )

*******************************************************************
***************   COSN
            CON(2) ((COSNfin)-(COSNdeb))/2
COSNdeb   NIBASC /COSN/
COSNfin   CON(2) ((COSNfin)-(COSNdeb))/2
RPL
::
CK1NOLASTWD
DUPTYPEREAL? NcaseTYPEERR
DUP %0> SWAP %ABSCOERCE DUPONE #> NcaseSIZEERR
{ %1 { %1 %0 } } SWAP
' :: { %1 %0 %-1 } UNROT INCOMPDROP ROT INNERCOMP
     #1=case :: DROP TWO{}N SWAPDROP ;
     OVER5PICK RMULText
     6PICK RMULText OVER5PICK RMULText RADDext 5UNROLL 4ROLL
     RMULText 3UNROLL RMULText RADDext SWAP TWO{}N SWAPDROP
     ;
MPext
INCOMPDROP ROT NOT?SEMI
ID c VALext
SWAP
ID c VALext ID s x*
SWAP
;
ASSEMBLE
COSN      CON(5) (COSN)-(COSNdeb)+2
*******************  COSN
*******************************************************************

*******************************************************************
***************     LEGENDRE
            CON(2) ((LEGENDREfin)-(LEGENDREdeb))/2
LEGENDREdeb   NIBASC /LEGENDRE/
LEGENDREfin   CON(2) ((LEGENDREfin)-(LEGENDREdeb))/2
RPL
::
( % -> liste des polynomes de Legendre de 0 a % )
CK1NOLASTWD
dREALNcase SETTYPEERR
%ABSCOERCE
DUP#0=csedrp { %1 }
DUP#1= casedrop { %1 ID X }
SEVENTEEN SetUserFlag
HXS 2 10 { HXS 2 20 HXS 1 0 } 
ROT DUP1LAMBIND
ONE_DO (DO)
	( T_k-1 T_k )
	INDEX@ #>HXS
	2DUP HXS 2 40 RMULText HXS 2 20 RADDext RMULText  HXS 1 0 >TCOMP
	( T_k-1 T_k k P )
	4PICK 3PICK
	HXS 2 40 RMULText RMULText RSUBext SWAP HXS 2 10 RADDext RDIVext
	LOOP
1GETABND
( T0 ... TN #N )
DUP#1+
ZERO_DO 
	get1 SYMBOL HXS 2 20 ; INDEX@ UNCOERCE ' x^ EvalNoCK NDXFext
	SWAPLOOP
#1+ {}N ONESWAP { ID X } VAL2ext
;
ASSEMBLE
LEGENDRE      CON(5) (LEGENDRE)-(LEGENDREdeb)+2
***************    LEGENDRE
*******************************************************************

*******************************************************************
***************     TCHEB
            CON(2) ((TCHEBfin)-(TCHEBdeb))/2
TCHEBdeb   NIBASC /TCHEB/
TCHEBfin   CON(2) ((TCHEBfin)-(TCHEBdeb))/2
RPL
::
( % -> liste des polynomes de Tchebycheff de 0 a % T_n[x]=cos[n*arcos[x]] )
( -% -> U_n[x]=sin[n*arccos[x]]/sin[arccos[x]] )
CK1NOLASTWD
dREALNcase SETTYPEERR
DUP %0< SWAP %ABSCOERCE
DUP#0=csedrp :: ITE { %0 } { %1 } ;
DUP#1= casedrop :: ITE { %0 %1 } { %1 ID X } ;
SEVENTEEN SetUserFlag
SWAP ITE
:: HXS 1 0 { HXS 2 10 } ;
:: HXS 2 10 { HXS 2 10 HXS 1 0 } ;
ROT DUP1LAMBIND
ONE_DO (DO)
	( ... T_k-1 T_k )
	DUP HXS 2 20 
	RMULText
	HXS 1 0 >TCOMP 3PICK RSUBext
	LOOP
1GETABND #1+ {}N ONESWAP { ID X } VAL2ext
;
ASSEMBLE
TCHEB      CON(5) (TCHEB)-(TCHEBdeb)+2
***************    TCHEB
*******************************************************************


*******************************************************************
***************     DER
            CON(2) ((DERfin)-(DERdeb))/2
DERdeb   NIBASC /DER/
DERfin   CON(2) ((DERfin)-(DERdeb))/2
RPL
::
CK2NOLASTWD
internalflag SetUserFlag
' ::	( LAM5/8 objet, idnt/lam/sym/list -> derivee )
	CK&DISPATCH1
	idnt :: 3PUTLAM 4GETLAM EVAL ;
	symb :: DUP' TYPEIDNT? Find1stTrue
		( obj, f[t], [ t, true | false ] )
		NcaseTYPEERR
		3PUTLAM
		( obj, f[t] )
		4GETLAM EVAL SWAP 4GETLAM EVAL SWAP RDIVext
		;
	list ::	INNERCOMP DUP#0=csedrp SETTYPEERR get1 SWAPDUP
		ZERO_DO (DO)
			( v1, ..., vn, obj, #n )
			get1 3PICKSWAP 5GETLAM EVAL
			( v2, ..., vn, obj, #n, obj' )
			UNROT
			LOOP
		SWAPDROP {}N
		;
	;
' ::	( LAM4/7: objet -> derivee par rapport a LAM3/6 qui doit etre un idnt )
	QOBJext
	::	( LAM2: symb -> symb: derive symb par rapport a LAM5 )
		idntlamcase :: 6GETLAM EQUALcase %1 %0 ;
		DUPTYPESYMB? 
		NOTcase ::	XEQTYPE %18 %= NOTcasedrop %0
				5GETLAM EQLookup ?SEMI 
				DO>STR "Can't handle " SWAP &$
				EXITMSGSTO # 70000 ERRORSTO
				ERRJMP
				;
		DUPLENCOMP #1=case :: CARCOMP 2GETEVAL ;
		' xOBJ\-> EvalNoCK
		( objets, %nbre, oper )
		SWAP DUP%0= case2drop %0
		COERCEDUP
		( objets, oper, #, # )
		#2+ NDUP
		( objets, oper, #, obj, oper, # )
		DUP#1+
		ZERO_DO 
			get1 2GETEVAL
			SWAPLOOP
		( objets, oper, #, derivees, der oper, # )
		DUP#1= casedrop ::	( obj, oper, #1, der, der oper )
					%0 
					EQUALcasedro :: ( fonction utilisateur )
							4UNROLL SWAP 
							( der, obj, #1, fonction )
							ID>$ "_1" SWAP&$ $>ID  
							ONE SYMBN
							SWAP' xFCNAPPLY FOUR SYMBN
							RMULText
							;
					5ROLL SYMCOMPext SWAP 
					XEQTYPE %18 EQ ITE EvalNoCK EVAL
					RMULText UNROT2DROP 
					;
		( objets, oper, #, derivees, der oper, # )
		SWAPDROP get1 #1+ get1 
		( objets, derivees, der oper, #, #+1, oper )
		SWAPDROP
		( objets, derivees, #, oper )
		4GETLAM EQLookup 
		NOTcase ::	( arg1...argk, der1...derk, #k , fnct utilisateur )
				ID>$ SWAPDUP SWAP#1+SWAP OVER#2+UNROL psh SYMBN
				( der1, ..., derk, id, #k+1, symbol arg1 ... argk ; )
				%0 ROT #1-
				ZERO_DO	(DO)
					( der1, .., derl, id, argl, res )
					OVER
						( der1..derl, id, argl, res, argl )
					"_"  ISTOP-INDEX UNCOERCE DO>STR &$ 
					( der1..derl, id, argl, res, argl, "der_l" )
					5PICK &$ $>ID ONE SYMBN  
					( der1..derl, id, argl, res, argl, der_lfnct )
					ISTOP@ ' xFCNAPPLY THREE SYMBN &COMP
					( der1..derl, id, argl, res, der_lfnct[argl] )
					5ROLL SWAP RMULText RADDext
					LOOP
				UNROT2DROP
				;
		SWAPDROP XEQTYPE %18 EQ ITE EvalNoCK EVAL
		;
	;
%0      ( LAM3/6 )
{
	( LAM2/5 liste de fonction, derivee )
	x+ %0 x- %0 x* %0 x/ %0 x^ %0
	x\v/	::	' x\v/ EvalNoCK %2 SWAP RMULText %1 SWAP RDIVext ;
	xEXP	xEXP
	xLN	xINV
	xINV	::	' xSQ EvalNoCK ' xINV EvalNoCK ;
	xSQ	::	%2 SWAP RMULText ;
	xSIN	xCOS
	xCOS	::	' xSIN EvalNoCK RNEGext ;
	xTAN	::	' xTAN EvalNoCK ' xSQ EvalNoCK %1 RADDext ;
	xSINH	xCOSH
	xCOSH	xSINH
	xTANH	::	' xTANH EvalNoCK ' xSQ EvalNoCK %1 SWAP RSUBext ;
	xASIN	::	' xSQ EvalNoCK %1 SWAP RSUBext 
			' x\v/ EvalNoCK ' xINV EvalNoCK 
			;
	xACOS	::	' xSQ EvalNoCK %1 SWAP RSUBext 
			' x\v/ EvalNoCK ' xINV EvalNoCK RNEGext
			;
	xATAN	::	' xSQ EvalNoCK %1 RADDext ' xINV EvalNoCK ;
	x\.S_ALGEBRAIC %0 
}
{
	( LAM1/4 liste d'operateur, action [ objets, derivees -> derivee ] )
	x+ ::	RADDext UNROT2DROP ;
	x- ::	RSUBext UNROT2DROP ;
	x* ::	4ROLL RMULText UNROT RMULText RADDext ;
	x^ ::	( x, y, x', 0 )
		DROP UNROT
		( x', x, y )
		DUP4UNROLL %1 RSUBext ' x^ EvalNoCK
		( y, x', x^[y-1] )
		RMULText RMULText
		;
	x/ ::	( n, d, n', d' ) 
		4ROLL RMULText
		( d, n', n*d' )
		3PICK RDIVext
		( d, n', n*d'/d )
		RSUBext
		( d,n'-n*d'/d )
		SWAP RDIVext
		;
	x\.S
	 ::	( inf, sup, fnct, var muette, inf', sup', fnct', %0 )
		DROP 5UNROLL
		( inf, sup, fnct', fnct, var muette, inf', sup' )
		2OVER 8PICK MEVALext RMULText
		( inf, sup, fnct', fnct, var muette, inf', sup'*fnct[sup] )
		2SWAP DUP 5UNROLL
		( inf, sup, fnct', var muette, inf', sup'*fnct, fnct, muette )
		8PICK MEVALext ROTSWAP RMULText RSUBext 5UNROLL 
		' x\.S_ALGEBRAIC FIVE SYMBN RADDext
		;
}
' NULLLAM FIVE NDUPN DOBIND
( obj, lvar )
5GETLAM EVAL
ABND
internalflag ClrUserFlag
;
ASSEMBLE
DER      CON(5) (DER)-(DERdeb)+2
***************    DER
*******************************************************************


*******************************************************************
***************     NABLA
*            CON(2) ((NABLAfin)-(NABLAdeb))/2
*NABLAdeb   NIBASC /NABLA/
*NABLAfin   CON(2) ((NABLAfin)-(NABLAdeb))/2
*RPL
*::
*CK2NOLASTWD
*CK&DISPATCH1
*#A5 :: INNERCOMP get1 NULL{} ROT
*       ZERO_DO (DO)
*               OVER 4ROLL U\.d >HCOMP
*               LOOP
*       SWAPDROP
*       ;
*list :: LENCOMP %0 ROTDROPSWAP NDUPN {}N
*	;
*;
*ASSEMBLE
*NABLA      CON(5) (NABLA)-(NABLAdeb)+2
***************    NABLA
*******************************************************************


*********************************************************************
*************     TAYLR
dernier     CON(2) ((TAYLRfin)-(TAYLRdeb))/2
TAYLRdeb     NIBASC /TAYLR/
TAYLRfin     CON(2) ((TAYLRfin)-(TAYLRdeb))/2
RPL
::
CK3NOLASTWD
OVER TYPEIDNT?
IT :: SWAP %0 x= SWAP ;
CK&DISPATCH1
#991 :: { BlankDA12 NINE 3PICK DO>STR &$ DISPROW1
          3PICK DO>STR DISPROW2
          }
        User1IT
        COERCE SWAP
        ( alg, ordre, 'X=a' )
        xOBJ\-> ' x= EQUAL SWAP %2 EQUAL AND NcaseTYPEERR

        ( alg, ordre, 'X', a )
	
	( LAM15: val, dl -> %0, exp[dl] )
        ' :: 11GETLAM EVAL
             7GETLAM EVAL ( %0, dl, a )
             xe SWAP x^ SWAPDUP %1 ONE{}N
             4GETLAM RRDMext OVER RADDext
             ( val=0, x, x, sigma )
             ' :: INDEX@ #1+ UNCOERCE %1 SWAP RDIVext ;
             4GETLAM 6GETLAM EVAL LOPMext			
	     ; 
        ( LAM14: val, dl -> %0, ln[dl] )
        ' :: 7GETLAM EVAL ( %0, dl, a )
             DUPUNROT DIVext DROPSWAP
             xLN ONE{}N 4GETLAM RRDMext OVER RADDext
             OVERSWAP
             ' :: INDEX@ UNCOERCE DUP %1+ %CHS RDIVext  ;
             4GETLAM 6GETLAM EVAL		
	     ;
        ( LAM13 : op\'erateurs binaires )
        ( dl1, val1, dl2, val2 -> dl, val )
        ( attention l'ordre de stk est invers\'e )        
	{ x+
          :: ROT 2DUP %MIN 5UNROLL
             ( min, dl1, dl2, val2, val1 )
             %- DUP %ABSCOERCE
             ( min, dl1, dl2, val2-val1, #deltaval )
             %0 SWAP NDUPN {}N
             ( min, dl1, dl2, val2-val1, { %0 ... %0 } )
             SWAP %0>
             ( si val2 > val1 modifier dl2 )
             ( val, dl1, dl2, { zros }, test )
             ITE SWAP ROT &COMP
             ( ajoute les 0 )
             4GETLAM RRDMext RADDext SWAP
             ;
          x-
          :: ROT 2DUP %MIN 5UNROLL %- DUP %ABSCOERCE
             %0 SWAP NDUPN {}N SWAP %0>
             ( si val1 > val2 modifier dl1 )
             ( val, dl1, dl2, deltaval, test )
             DUP 5UNROLL
             ITE SWAP ROT &COMP
             ( ajoute les 0 )
             4GETLAM RRDMext ROT IT SWAP RSUBext SWAP
             ;
          x*
          :: ROT %+ UNROT RMULText SWAP ;
          x/
          :: ( division ) 9GETLAM EVAL ;
          x^
          :: ( puissance )
             ( dl1, val1, dl2, val2 -> dl, val = dl2^dl1 )
             %0= NcaseSIZEERR
	     ( la valuation du terme doit etre nulle pour calcul du DL )
	     ( dl1, val1, dl2 )
	     ( test de l'exposant: reel, entier ou dl )
	     3PICK 3PICK %0=
	     ( dl1, val1, dl2, dl1, val1=0? )
	     ITE :: INNERCOMP reversym {}N TRIMOBJext DUPTYPELIST? ;
	         TRUE
	     ( dl1, val1, dl2, [ reel1 ,false ] | [ dl1, true ] )
	     NOTcase :: 4ROLLDROP
	                ( 0, dl2, reel1 )
	                DUP xFLOOR OVER
                        EQUALcase :: COERCE
                                     :: DUP#0= case2drop { %1 }
                                        DUP#1= caseDROP
                                        OVERSWAP
                                        ONE_DO (DO)
                                               OVER RMULText 4GETLAM RRDMext
                                               LOOP
                                        SWAPDROP
                                        ;
                                     SWAP
                                     ;
                        5GETLAM EVAL
                        ;
	     ( dl1, val1, dl2, obj )
	     DROP
	     %0 SWAP 14GETLAM EVAL
	     ( dl1, val1, %0, dl2 )
	     SWAP DROPROT RMULText
	     ( val1, dl )
	     4GETLAM RRDMext
	     15GETLAM EVAL SWAP
	     ;
             }

        ( LAM12 oprateurs unaires )
        { xINV
          :: ( ajuste valuation et ordre )
             SWAP %1 ONE{}N 4GETLAM RRDMext %0 9GETLAM EVAL
             ;
          xNEG
          :: QOBJext xNEG SWAP ;
          xSQ
          :: DUP RMULText SWAP %2 %* ;
          xRE
          :: QOBJext xRE SWAP ;
          xIM
          :: QOBJext xIM  SWAP ;
          xCONJ
          :: QOBJext xCONJ  SWAP ;
          x\v/
          :: SYMBOL %1 %2 x/ ; 5GETLAM EVAL ;
          xSIN
          :: ( val dl -> sin[dl] val )
             %-1 8GETLAM EVAL xSIN xCOS
             ;
          xCOS
          :: %-1 8GETLAM EVAL xCOS :: xSIN xNEG ;
             ;
          xTAN
          :: 2DUP %-1 8GETLAM EVAL xCOS :: xSIN xNEG ;
             4UNROLL 4UNROLL
             %-1 8GETLAM EVAL xSIN xCOS
             9GETLAM EVAL
             ;
          xLN
          :: 14GETLAM EVAL SWAP
             ;
          xEXP
          :: ( val, dl -> exp[dl] val )
             15GETLAM EVAL SWAP
             ;
          xSINH
          :: %1 8GETLAM EVAL xSINH xCOSH ;
          xCOSH
          :: %1 8GETLAM EVAL xCOSH xSINH ;
          xTANH
          :: 2DUP %1 8GETLAM EVAL xCOSH xSINH
             4UNROLL 4UNROLL %1 8GETLAM EVAL xSINH xCOSH
             9GETLAM EVAL
             ;
          xASIN
          :: SYMBOL %-1 %2 x/ ;
             TWO 10GETLAM EVAL xASIN
             ;
          xACOS
          :: SYMBOL %-1 %2 x/ ;
             TWO 10GETLAM EVAL xACOS
             SWAPDUP CARCOMP SWAP CDRCOMP
             QOBJext xNEG SWAP >HCOMP SWAP
             ;
          xATAN
          :: %-1 ZERO 10GETLAM EVAL xATAN ;
          xASINH
          :: SYMBOL %-1 %2 x/ ;
             ZERO 10GETLAM EVAL xASINH
             ;
          xACOSH
          :: SYMBOL %-1 %2 x/ ;
             ONE 10GETLAM EVAL xACOSH
             ;
          xATANH
          :: xATANH %-1 ONE 10GETLAM EVAL xATANH ;
          }

        ' :: ( LAM 11 val, dl -> 0, dl ou error )
             DUPLENCOMP OVER DEGREext #- #1- UNCOERCE
             ( val, dl, valdl )
             3PICK %+ %0< caseSIZEERR
             ( val, dl )
             DUPLENCOMP UNCOERCE ROT %+ COERCE #1-
             DUP 4PUTLAM LRDMext
             %0 SWAP
             ;

        ' :: ( LAM 10 val, dl, puissance, #0 #1 #2, [runstream operateur] )
             ( -> asin acos atan asinh acosh ou atanh[dl], val )
             4ROLL 4ROLL 11GETLAM EVAL SWAPDROP
             ( puis, #, dl )
             DUP CDRCOMP %0 >HCOMP SWAP CARCOMP DUP 'REVAL
             (  puis, #, dl tronque, a, op[a] )
             SWAP %1 TWO{}N DUP RMULText { %1 %0 %0 }
             (  puis, #, dl tronque, op[a], [a+x]^2 , dl de %1 )
             { RADDext RSUBext :: SWAP RSUBext ; }
             6ROLL #1+ NTHCOMPDROP EVAL
             ( puis, dl tronque, op[a], "1-x^2" )
             4GETLAM RRDMext %0 SWAP 5ROLL
             ( dl tronque, op[a], %0, "1-x^2", puis )
             5GETLAM EVAL UNROT
             ( dl tronque, val, op[a], "1-x^2"^puis )
             INNERCOMP reversym {}N INTEGRext
             ( dl tronque, val, op[a], int["1-x^2"^puis] a l'envers )
             INNERCOMP get1 ROTDROPSWAP {}N 4GETLAM LRDMext
             ( dl tronque, val, int["1-x^2"^puis]+op[a] a l'envers )
             ROT INNERCOMP reversym {}N TRIMext
             ( P, r -> P[r] )
             ( HORNext modifie pour listes, resultat seulement )
             SWAPINCOMP  ( stack= r, a0, .., an, #n+1)
             get1
             ( a0, ..., an, #n+1, r )
             SWAP get1 ONE{}N
             ( a1, ..., an, r, #n+1, a0)
             UNROTDUP
             ONE_DO (DO)
			( ak,...,an, b0, b1, ..., bk-1, r, #n+1 )
			get1 2OVER RMULText 4GETLAM LRDMext TRIMext 
			SWAP ONE{}N RADDext
			UNROT
			LOOP
             ( b0, b1, ..., bn, r, #n+1)
             UNROTDROP
             ( b0, ..., bn-1, #n+1, bn )
             OVER #1+UNROLL #1-{}N
             ( bn , {b0 ... bn-1 } )
             DROP
             ( bn )
             ( fin de HORNext modifie pour listes )
             INNERCOMP reversym {}N
             SWAP
             ;

        ' :: ( LAM 9 division dl1, val1, dl2, val2 -> dl2/dl1, val )
             ( ajuste valuation et ordre )
             ROT %- 3PICK LENCOMP 4PICK DEGREext #1+ #-
             ( dl1, dl2, val1-val2, #valdl2 )
             SWAPOVER UNCOERCE %-
             ( dl1, dl2, #valdl2, val )
             3PICK LENCOMP 4PICK DEGREext #1+ #- UNCOERCE
             ( dl1, dl2, #valdl2, val, #valdl1, valdl1 )
             %+ 4UNROLL
             ( val, dl1, dl2, #maxvaldl )
             4GETLAM SWAP#- 4PUTLAM SWAP
             ( effectue la division puissance croiss )
             ( val, dl2, dl1 )
             TRIMext DUPLENCOMP %0 SWAP#1- NDUPN {}N
             ( ajoute #length[dl1] zeros a dl2 -> length[quot]=length[dl2] )
             ROTSWAP &COMP SWAP DIVext DROPSWAP
             ( dl, val )
             DUP %0> NOT?SEMI SWAP 11GETLAM EVAL SWAP
             ;

        ' :: ( LAM 8 val, dl, signe [runstream op1 op2] -> sin cos sinh cosh[dl], val )
             UNROT 11GETLAM EVAL
             ( signe, val, dl [runstream op1 op2] )
             7GETLAM EVAL DUP
             ( signe, %0, dl, a, a [runstream op1 op2] )
             'REVAL SWAP 'REVAL 3PICK
             ( signe, %0, y, sin[a], cos[a], y )
             DUPDUP RMULText 4GETLAM RRDMext
             ( signe, %0, y, sin[a], cos[a], y, y^2 )
             :: ROT
                ( signe, %0, y, sin[a], y, y^2, cos[a] )
                num0=case :: ROTDROP UNROTSWAP ;
                UNROTDUP 5UNROLL SWAPDUP
                ( signe, %0, y, y^2, sin[a], cos[a], y^2, y, y )
                ' :: INDEX@ #2* DUP#1+ #* UNCOERCE ELEVEN PICK SWAP RDIVext ;
                4GETLAM #1+ #2/ 6GETLAM EVAL LOPMext
                ( signe, %0, y, y^2, sin[a], cos[a]*sin[y] )
                UNROT
                ;
             ( signe, %0, y, cos[a]*sin[y], y^2, sin[a] )
             :: num0=case 2DROP
                SWAP
                ( signe, %0, y, cos[a]*sin[y], sin[a], y^2 )
                %1 7PICK %* %2 NDXFext OVER LOPMext
                ( signe, %0, y, cos[a]*sin[y], sin[a], y^2, -1/2*y^2 )
                %1 ONE{}N 4GETLAM RRDMext OVER RADDext
                ( signe, %0, y, cos[a]*sin[y], sin[a], y^2, -1/2*y^2, 1-1/2*y^2 )
                ' :: INDEX@ #2* #1+ DUP#1+ #* UNCOERCE TEN PICK SWAP RDIVext ;
                4GETLAM #1+ #2/ 6GETLAM EVAL LOPMext RADDext
                ;
             ( signe, %0, y, cos[a]*sin[y]+sin[a]*cos[y] )
             SWAPDROP ROTDROPSWAP
             ;

        ' :: ( LAM 7 val, dl -> val=0, x, a)
             OVERDUP %0< SWAPDUP %FLOOR %<>
             OR IT :: #206 DO#EXIT ;
             OVER %0=
             case :: DUP CDRCOMP %0 >HCOMP SWAP CARCOMP ;
             HALT SWAP 4GETLAM #+ LRDMext
             4GETLAM RRDMext %0 DUPUNROT
             ( val=0, x, a )
             ;

        ' :: ( LAM 6 x, c_0*x, sigma, programme, ordre -> sigma )
             DUP#1= case2drop UNROT2DROP
             SWAP 5UNROLL
             ONE_DO (DO)
                    UNROTOVER RMULText 4GETLAM RRDMext
                    ( prg, sigma, x, c_n*x^n+1 )
                    4PICK EVAL SWAP LOPMext
                    ROTOVER RADDext
                    LOOP
             UNROT2DROP SWAPDROP
             ;

        ' :: ( LAM 5 val dl-liste rel -> val dl^rel )
             UNROT 7GETLAM EVAL 4ROLLSWAP ( val y r a )
             DUP3PICK x^
             ( val y r a a^r )
             4UNROLL ROTSWAP  ( val, a^r, r, y, a ) DIVext
             ( val, a^r, r, y/a+... )
             DROPDUP 3PICK ONE{}N RMULText DUP CDRCOMP %1 >HCOMP
             ( val, a^r, r, x, c_n*x^n, sigma )
             ' :: INDEX@ UNCOERCE 6PICK OVER RSUBext SWAP %1 RADDext RDIVext ;
             4GETLAM 6GETLAM EVAL
             ( val, a^r, r, sigma )
             ROTSWAP LOPMext UNROT x* CRUNCH
             ;

        ( alg, ordre, 'X', a, LAM15, ..., LAM5 )
        FOURTEEN ROLL
        FOURTEEN ROLL
        ( alg, a, LAM15, ..., LAM5, ordre, 'X' )

        ' :: ( LAM 2 ) DUPTYPESYMB? NOT?SEMI
             INNERCOMP DUPUNROT #1+UNROLL #1-
             pZpargSWAPUn DUP#1=
             ( op, meta2, meta1 )
             ITE :: DROPDUP 3GETLAM EQUAL
                    ITE :: DROP 1GETLAM %1 TWO{}N ;
                        ONE{}N
                    4GETLAM RRDMext %0
                    ;
                 :: SYMBN 2GETEVAL ;
             ( op, meta2, dl1, val1 )
             3PICK #3+ UNROLL OVER#2+UNROL
             ( op, val1, dl1, meta2 )
             DUP#0=ITE :: DROP
                          ( op, val1, dl1 )
                          { BlankDA2 3PICK DO>STR OVER EDITDECOMP$ &$
                            :: THREE SEVEN ; Disp5x7
                             }
                          User1IT
                          ROT 12GETLAM
                          EQLookup case EVAL
                          ( dl, val, op )
                          DO>STR "Can't handle " SWAP &$ DO$EXIT
                          ;
                       :: DUP#1=
                          ITE :: DROPDUP 3GETLAM EQUAL
                                 ITE :: DROP 1GETLAM %1 TWO{}N ;
                                     ONE{}N
                                 4GETLAM RRDMext %0
                                 ;
                              :: SYMBN 2GETEVAL ;
                          ROT 4UNROLL
                          ( op, dl1, val1, dl2, val2 )
                          ( attention l'ordre de stk est invers\'e )
                          { BlankDA2 4PICK EDITDECOMP$ :: FIVE SIX ; Disp5x7
                            OVER EDITDECOMP$ :: THREE FOUR ; Disp5x7
                            5PICK DO>STR DISPROW7
                            }
                          User1IT
                          5ROLL 13GETLAM
                          EQLookup case EVAL
                          ( dl, op )
                          DO>STR "Can't handle " SWAP &$ DO$EXIT
                          ;
             SWAP 4GETLAM RRDMext SWAP
             ;
        ( alg, a, LAM15, ..., LAM5, ordre, 'X', LAM2 )
        FIFTEEN ROLL
        ( alg, LAM15, ...,LAM5, ordre, 'X', LAM2, a )
        ' NULLLAM FIFTEEN NDUPN DOBIND
        ( alg )
        2GETEVAL SWAPDUP
        ( valuation, DL-liste, DL-liste )
        3GETLAM 1GETLAM ABND
        x- SWAPINCOMP reversym get1 %0 ROT
        ZERO_DO (DO)
                ( en-1, ..., e0, x-a, %0 )
                OVERINDEX@ UNCOERCE x^ 4ROLLSWAP x* x+
                LOOP
        ( valuation, DL-liste, x-a, DL-alg)
        SWAP4PICK x^ x*
        ;
;
*ASSEMBLE
*TAYLR        CON(5) (TAYLR)-(TAYLRdeb)+2
****************  TAYLR
*********************************************************************
