* -*- mode:Mail -*-
        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h

* Rpertoire MATR

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )


*******************************************************************
***************     cross
            CON(2) ((crossfin)-(crossdeb))/2
crossdeb   NIBASC /cross/
crossfin   CON(2) ((crossfin)-(crossdeb))/2
RPL
::
CK2NOLASTWD
AXLext SWAP AXLext
CK&DISPATCH1
2LIST :: DUPLENCOMP #3= 3PICK LENCOMP #3= AND NcaseSIZEERR
         INCOMPDROP 4ROLL INCOMPDROP
         ( a,b,c,d,e,f )
         2DUP 7PICK RMULText SWAP 6PICK RMULText RSUBext
         ( a,b,c,d,e,f fb-ec )
         7UNROLL 4ROLL 4PICK RMULText SWAP 6PICK RMULText RSUBext
         ( bf-ce,a,b,d,e cd-fa )
         5UNROLL 4ROLL RMULText UNROT RMULText RSUBext
         ( bf-ce, cd-fa, ae-bd )
         THREE{}N
         ;
;
ASSEMBLE
cross      CON(5) (cross)-(crossdeb)+2
***************    cross
*******************************************************************

*******************************************************************
***************     STUDMULT
            CON(2) ((STUDMULTfin)-(STUDMULTdeb))/2
STUDMULTdeb   NIBASC /STUDMULT/
STUDMULTfin   CON(2) ((STUDMULTfin)-(STUDMULTdeb))/2
RPL
::
CK2NOLASTWD 
RESOROMP RMULText
( { poly2 } { poly1 } oprateur binaire --> { poly3 } )

' :: ( LAM 4 list, o -> )
     DUPTYPESYMB? case 2GETEVAL
     SWAPINCOMP DUP#0= caseDROP
     get1 ROTSWAP 1GETLAM EVAL EVAL SWAP {}N
     ;
' :: ( LAM 3 list A, list B -> listA peut etre un objet non liste )
     OVER TYPESYMB? case 2GETEVAL
     SWAP DUPTYPELIST? ITE INNERCOMP ONE
     DUP#0= caseDROP
     get1
     INNERCOMP
     DUP#0= casedrop {}N
     get1
     ( a1, ..., aa, b1,...,bb, #b, #a )
     SWAP2DUP #MIN SWAP#1+SWAP
     ( a1, ..., aa, b1, ..., bb, #a, #b+1, #min )
     ZERO_DO (DO)
             ( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+1 )
             get1 4ROLL 1GETLAM EVAL EVAL OVER #1+UNROLL
             LOOP
     ( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b+1 )
     ( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b+1 )
     ( si #a<#b, il faut continuer avec %0 comme oprande )
     #1- 2DUP#< NOTcasedrop ( #b=#a ) {}N
     ( #a < #b : c[b-a]+1,...,ca, b1,...,b[b-a],#a, #b )
     DUPROT #-
     ( c[b-a]+1,...,ca, b1,...,b[b-a], #b, #b-a )
     ZERO_DO (DO)
             ( ck+1,...,ca, b1,...,bk, #b )
             %0 ROT 1GETLAM EVAL EVAL OVER #1+UNROLL
             LOOP
     {}N
     ;
' :: ( LAM1 prg principal o, o -> )
     CK&DISPATCH1
     FIVE 3GETLAM
     EIGHTY 4GETLAM
     ZERO 2GETLAM
     ;
4ROLLSWAP ( LAM2: oprateur binaire )
4NULLLAM{} BIND 1GETLAM EVAL EVAL ABND
;
ASSEMBLE
STUDMULT      CON(5) (STUDMULT)-(STUDMULTdeb)+2
***************    STUDMULT
*******************************************************************


*******************************************************************
***************     MATRIX
            CON(2) ((MATRIXfin)-(MATRIXdeb))/2
MATRIXdeb   NIBASC /MATRIX/
MATRIXfin   CON(2) ((MATRIXfin)-(MATRIXdeb))/2
RPL
{ { %1 %1 ID A } { %1 ID A %1 } { ID A %1 %1 } }
ASSEMBLE
MATRIX      CON(5) (MATRIX)-(MATRIXdeb)+2
***************    MATRIX
*******************************************************************

*******************************************************************
***************     LCXM
            CON(2) ((LCXMfin)-(LCXMdeb))/2
LCXMdeb   NIBASC /LCXM/
LCXMfin   CON(2) ((LCXMfin)-(LCXMdeb))/2
RPL
::
( L,C, prg -> matrice )
CK3NOLASTWD
CK&DISPATCH1
# 118	::	UNROT %ABSCOERCE 
		DUP#0=case SETTYPEERR
		SWAP %ABSCOERCE
		DUP#0=case SETTYPEERR
		UNROT ' NULLLAM DUPTWO DOBIND
		DUP#0_DO
			1GETLAM 
			DUP#0_DO
				DEPTH JINDEX@ #1+ UNCOERCE INDEX@ #1+
				UNCOERCE 2GETEVAL DEPTH ROT #2+
				#<>case SETTYPEERR
			SWAPLOOP
			{}N 
		SWAPLOOP
		{}N
		ABND
		;
;
ASSEMBLE
LCXM      CON(5) (LCXM)-(LCXMdeb)+2
***************    LCXM
*******************************************************************

*******************************************************************
***************     VAND
            CON(2) ((VANDfin)-(VANDdeb))/2
VANDdeb   NIBASC /VAND/
VANDfin   CON(2) ((VANDfin)-(VANDdeb))/2
RPL
::
CK1NOLASTWD
( liste -> matrice de Vandermonde )
NOTLISTcase SETTYPEERR
DUPLENCOMP UNCOERCE DUP
' :: SWAP xGET SWAP %1- x^ ;
4ROLL >HCOMP ID LCXM
;
ASSEMBLE
VAND      CON(5) (VAND)-(VANDdeb)+2
***************    VAND
*******************************************************************

*******************************************************************
***************     HILB
            CON(2) ((HILBfin)-(HILBdeb))/2
HILBdeb   NIBASC /HILB/
HILBfin   CON(2) ((HILBfin)-(HILBdeb))/2
RPL
::
( % -> matrice de Hilbert )
CK1NOLASTWD
DUP
' :: %1- %+ %1 SWAP NDXFext ;
ID LCXM 
;
ASSEMBLE
HILB      CON(5) (HILB)-(HILBdeb)+2
***************    HILB
*******************************************************************

*********************************************************************
*************     PCAR
            CON(2) ((PCARfin)-(PCARdeb))/2
PCARdeb     NIBASC /PCAR/
PCARfin     CON(2) ((PCARfin)-(PCARdeb))/2
RPL
::
CK1NOLASTWD
AXLext DTYPENDO? NcaseSIZEERR
DUPLENCOMP idnext
' ID  MPMULText RSUBext
ID DET
;
ASSEMBLE
PCAR        CON(5) (PCAR)-(PCARdeb)+2
*****************  PCAR
*********************************************************************

*******************************************************************
***************     DET
            CON(2) ((DETfin)-(DETdeb))/2
DETdeb   NIBASC /DET/
DETfin   CON(2) ((DETfin)-(DETdeb))/2
RPL
::
CK1NOLASTWD
CK&DISPATCH1
list :: DTYPENDO? ( ALGB XLIB call: false if not endomorphism )
        NcaseSIZEERR
        ONE TOLISText ( ALGB XLIB call )
        ( [lvar], matr, flag )
        RESOROMP RMULText
        ' :: ( recursive part of the program : matrix -> determinant )
             DUPLENCOMP
             #>2case :: DUP TRANext ( transpose matrix )
                        CARCOMP INNERCOMP get1
                        ( a11,...,a1n, #n, A )
                        ( strip 1st column of A )
                        INNERDUP
                        ZERO_DO
                               DUP #1+ROLL CDRCOMP
                               SWAPLOOP
                        ( a11,...,a1n, #n, A reduced )
                        {}N %0 ROT
                        ZERO_DO (DO)
                                ( a11,...,a1n, A reduced, 0 )
                                OVER INNERCOMP INDEX@ #2+ROLL DROP#1- {}N
                                2GETEVAL ( recursive call of det )
                                4ROLL 3GETLAM ( x* )
                                EVAL SWAP ( x- ) 1GETLAM EVAL
                                LOOP
                        SWAPDROP
                        ;
             INNERCOMP
             #1=case CARCOMP  ( 1x1 matrix )
             ( 2x2 matrix )
             INCOMPDROP ROT INCOMPDROP
             ( c, d, a, b)
             UNROT 3GETLAM ( x* ) EVAL UNROT
             3GETLAM ( x* ) EVAL ( x- ) 1GETLAM EVAL
             ;
        RESOROMP RSUBext
        ' NULLLAM DUPDUP THREE DOBIND
        2GETEVAL ABND
        ( [lvar,], det )
        ZERO ONE{}N
        FROMLISText
        ;
arry xDET
;
ASSEMBLE
DET      CON(5) (DET)-(DETdeb)+2
***************    DET
*******************************************************************

*********************************************************************
*************     RED
*( entre programme: )
*( - endo, #0, kcMenuKey1[RED] ou kcMenuKey2 [DET] )
*(             ou kcMenuKey3[INVL] ou kcMenuKey6[RANG] )
*( - matr, #1, kcMenuKey1[RED] ou kcMenuKey6[RANG] )
*( - syst, #3, kcMenuKey1[SYST] ou kcMenuKey6[SOLGEN] )
*( ici kcMenuKeyn=#n )
*( entre interactive: endo ou matr ou syst )
           CON(2) ((REDfin)-(REDdeb))/2
REDdeb     NIBASC /RED/
REDfin     CON(2) ((REDfin)-(REDdeb))/2
RPL
::
CK1NOLASTWD
DUPTYPEBINT? ( teste une entree demandee par un programme )
?SKIP
:: ( entre interactive, teste s'il s'agit d'une matrice ou d'un systeme )
   AXLext DTYPELIST? NcaseTYPEERR
   DTYPFMAT?
   ITE :: DTYPENDO? ITE ZERO ONE ;
       :: CK2NOLASTWD OVER DTYPFMAT? NcaseTYPEERR DROP THREE ;
   ( calcul du menu a afficher )
   DUP #3= ITE "SOLG" "RED" ( # $6 )
   NULL$ DUP ( # $6 $5 $4 )
   4PICK #0=ITE :: "INVL" "DET" ; :: NULL$ NULL$ ; ( # $6 $5 $4 $3 $2 )
   6PICK #3= ITE "SYST" "RANG" ( # $6 $5 $4 $3 $2 $1 )
   MENUext
   % 300 % .2 DOBEEP WaitForKey DROP
   ( list, 0,1 ou 2, key )
   OVER #3= ITE :: 2OVER TWO{}N ;
                3PICK
   ( list, #0--#3, key,  sauver )
   DUP 4PICK #3= IT CARCOMP TRANext DUPLENCOMP #1- ONESWAP
   DUP#0=ITE 2DROP SUBCOMP LVARext SWAPDROP DUPNULL{}?
   case2DROP
   DROP' ID MATRIX STO
   ;
( rappelle les routines de rduction )
ONE REDLIBext  
' ( SYST matrice, lvar -> )
::
( matrice, linconnues )
SWAPONE
TOLISText 
( linconnues, [lvar], matrice )
ROTSWAP
( [lvar], linconnues, matrice )
ONE 3GETLAM EVAL ( XRED )
( linconnues, lpivot, matrice )
DUP
INNERDUP #1-SWAP
#1+_ONE_DO
           get1 INDEX@ NTHCOMPDROP
           SWAPLOOP
#1+ {}N
( linconnues, lpivot, matrice, lcoefdiag )
ROT STRIPTAGS &COMP "Specific" >TAG
( linconnues, matrice, caspart )
UNROT
( lpivot, linconnues, matrice rduite )
( supprime les lignes nulles )
INNERCOMP
BEGIN
     OVER TRIMOBJext %0 EQUAL
WHILE
     SWAPDROP #1-
REPEAT
{}N
( lpivot, linconnues,, matrice rduite )
OVER >TCOMP
( lpivot, linconnues, matrice rduite )
DUPLENCOMP 3PICK LENCOMP SWAPROT
( lpivot, linconnues, #col, #lig, mat )
( effectue des rotations de colonnes si ncessaire )
ONEONE
BEGIN
     ( lpivot, linconnues, #col, #lig, mat , #actcol , #actlig )
     OVER 6PICK #< OVER 6PICK #< AND
WHILE
     ( lpivot, linconnues, #col, #lig, mat , #actcol , #actlig )
     3PICKOVER NTHCOMPDROP 3PICK NTHCOMPDROP
     TRIMOBJext
     :: CK&DISPATCH1
        real %0=
        TWO C%0=
        any DROPFALSE
        ;
     ( teste si le coef #actcol, #actlign de matr est nul )
     ( s'il est nul, change la colonne avec la dernire )
     ( colonne de la matrice )
     IT :: OVER 4ROLLSWAP ( EXC )
           SWAPINCOMP get1 3PICK LENCOMP SWAP#- #2+
           1LAMBIND
           ( l1, ..., ln, #n )
           DUP#1+ SWAP
           ZERO_DO
                   ( lk, ..., ln, l1, ..., lk-1, #n+1 )
                   DUPROLL INNERCOMP 1GETLAM ROLLSWAP {}N
                   SWAPLOOP
           #1-{}N ABND ( end of EXC )
           UNROT
           ;
     #1+SWAP #1+SWAP
     REPEAT
2DROP UNROT2DROP
( caspart, linconnues, matr rduite arrange )
INNERCOMP NULL{} SWAP
ONE_DO (DO)
       ( ..., m1, ..., mk, linconnues, { quations }  )
       OVER 4ROLL  ( LXE )
       TRIMext DUP CDRCOMP DUPNULL{}?
       ITE :: ROT2DROP CARCOMP %0 ;
           :: SWAP CARCOMP RESOROMP RDIVext LOP1ext
              ( stk = liste var, coefficients )
              SWAP DUPLENCOMP DUP 4PICK LENCOMP #-SWAP SUBCOMP
              ( stk = coeff. ,liste var tronque )
              DUP CARCOMP UNROT CDRCOMP RNEGext
              ( var principale, coeff, var aux )
              XYext
              ;
       SWAP DO>STR >TAG ( end of LXE )
       >TCOMP
       LOOP
INNERCOMP reversym {}N
( caspart, linconnues, lvar arrange, liste de rsultats taggus )
4ROLL
( [lvar], linconnues, lvar arrange, liste de rsultats taggus, cas particuliers )
ONEONE 2DUP FOUR {}N FROMLISText
;
( fin de SYST ) 

NULLLAM SIX NDUPN DOBIND
kcMenuKey2
#=casedrop
 :: ( DET )
    #0<> ?SEMI
    ' 5PICK 3GETLAM EVAL ( rang )
    ( lpivot, matr )
    2DUP
    NUMEVALext
    :: INNERCOMP reversym SWAP CARCOMP SWAP
       #1+DUP #2=
       caseDROP
       TWO DO
           SWAPINDEX@ NTHCOMPDROP RMULText
           LOOP
       ;
    ( lpivot, matr, lpivot, numerateur )
    SWAP STRIPTAGS
    NUMEVALext PIext
    NDXFext ABND
    ( lpivot, matr reduite, determinant )
    ;
kcMenuKey3
#=casedrop
 :: ( INVL )
    #0<> ?SEMI
    ONE TOLISText
    DUPINCOMP UNCOERCE xIDN AXLext INNERDUP #1+SWAP
    ( stack= l1,...,ln,i1, ...,in, #n+1, #n )
    ZERO_DO (DO)
            ( l1, ..., lk, mk+1,...,mn, i1,...,ik, #n+1 )
            DUP#1+ ROLL ROT &COMP
            ( l1, ..., lk-1, mk+1, ...,mn, i1,...,ik-1, #n+1, mk )
            OVER UNROLL
            LOOP
    #1-{}N
    ( matrice complte cre )
    ONE 3GETLAM EVAL ( rduction )
    ( rduction de chaque ligne et division par le pivot )
    INNERDUP DUP#1+ DUPROT #2* SWAPDUP #3+ SWAP
    ( l1, ..., ln, #n, #n+1, #2n , #n+4, #n+1 )
    ONE_DO (DO)
           ( l1, ..., ln, #n, #n+1, #2n, #n+1 )
           DUPROLL DUPINDEX@ NTHCOMPDROP SWAP 5PICK 5PICK SUBCOMP
           SWAP RESOROMP RDIVext LOP1ext 5UNROLL
           LOOP
    3DROP {}N ROTDROP ABND
    ONE TWO TWO{}N FROMLISText
    ;
kcMenuKey1
#=casedrop :: #>2case :: 1GETLAM EVAL ( syst ) ABND SWAP ;
              ' 5PICK 3GETLAM EVAL ( rang ) ABND
              ;
kcMenuKey6
#=casedrop ::
#>2case :: ( solg )
           1GETLAM EVAL ( appel de syst )
           ( lvar, lvar arrange, liste de rsultats taggus, cas part )
           4UNROLL
           ( supprime la partie constante de la liste de variables )
           3PICK DUPLENCOMP #1- ONESWAP SUBCOMP
           ( caspart, lvar, lvar arrange, { var taggus }, lvar tronque )
           ( dans chaque quation, lire si le tag est dans la liste des variables )
           ( si oui, remplacer dans lvar le tag par son quation )
           ( si non, ajouter aux quations de compatibilit )
           NULL{} 3PICK DUPLENCOMP
           ( stk= ..., lvar tr, { compatibilit }, { var taggus } ,#eq )
           4PICK SWAP#1+
           ONE_DO  (DO)
                   ( lvar tr, { compatibilit } { var taggus }, lvar mod )
                   OVERINDEX@ NTHCOMPDROP xOBJ\-> xSTR\->
                   ( lvar tr, {comp}, {eq}, lvar mod, valeur, variable )
                   3PICKOVER EQUALPOSCOMP ( ..., position ou #0 si non trouv )
                   DUP#0=ITE :: DROP x= 4ROLLSWAP >TCOMP UNROT ;
                             :: ( ..., lvar tr, valeur, variable, position )
                                SWAPDROP ROT PUTLIST ;
                   LOOP
           SWAPDROP
           ( caspart, lvar, lvar arrange, { var }, lvar tr, {comp}, lvar mod )
           SWAP DO>STR "If " SWAP &$  ", " &$ ROT DO>STR &$ "=" &$ >TAG
           ABND
           ( lpivot, lvar, lvar arrange, { var }, lvar tr, {comp}, lvar mod )
           ;
ONE 3GETLAM EVAL ( rduction ) ABND
;

2DROP ABND
;
ASSEMBLE
RED        CON(5) (RED)-(REDdeb)+2
***************** RED
********************************************************************

*********************************************************************
*************     DIAG
dernier     CON(2) ((DIAGfin)-(DIAGdeb))/2
DIAGdeb     NIBASC /DIAG/
DIAGfin     CON(2) ((DIAGfin)-(DIAGdeb))/2
RPL
::
( endomorphisme  ou 
  poly-madj, poly carac -> )
CK1NOLASTWD
complexflag SetUserFlag
DTYPEARRY? ITE TRUE DTYPENDO?
IT ::	DUP' ID MATRIX STO
	xMAD
	;
CK2NOLASTWD FACT1ext 
( poly-madj-ext, lvar, poly carac, lfac )
4UNROLL FXNDext DIVOBJext 4UNROLL
( poly car, lfac, poly-madj-ext, lvar )
CDRCOMP VXXLext 2SWAP
( lvar, poly-madj, poly car, lfac )
CK&DISPATCH1
#5555
:: ZERO REDLIBext
   ( rappelle LAM8: PIVOT, LAM7: EXL et LAM6: ELEM )
   ( stk= poly matr, poly car, roots, PIVOT, EXL, ELEM, prg )
   ' :: ( LAM5: vecteur-liste -> vecteur propre simplifie )
        symbolicflag TestUserFlag NOT?SEMI
        INNERDUP #1+SWAP
        ZERO_DO
                ( o1, ..., on, #n-1 )
                DUPROLL TRIMOBJext
                SWAPLOOP
        #1-{}N
        LPGCDext LOPDext
        ;
   ZEROZERO 2DUP
   ( initialisation des 8 variables locales )
   ' NULLLAM EIGHT NDUPN DOBIND
   { BlankDA12 EIGHTEEN DISPROW1 DUP EDITDECOMP$
     :: TWO FIVE ; Disp5x7
     NINETEEN DISPROW6
     } User1IT
   displayflag TestUserFlag 4UNROLL displayflag ClrUserFlag
   ( stack = flag1, polynome matriciel, polynome carac., liste racines )
   SWAPDUP 4UNROLL
   ( flag1, pcar ,polynome matriciel, liste racines, pcar )
   4UNROLLDUP
   ( flag1, pcar, pcar, polynome matriciel, liste rac, liste rac )
   5UNROLL NULL{} 3UNROLL
   ( flag1, liste rac, pcar, pmin, null{}, polynome matriciel, liste rac )
   BEGIN
        DUPLENCOMP #0<>
   WHILE
	( ..., pmin, null{}, polynome matriciel, liste rac )
        INNERCOMP #2- {}N
	( ..., pmin, null{}, polynome matriciel, rac, mul, liste rac )
	4UNROLL COERCE 1PUTLAM
        ( , pmin, {vectp}, liste autres rac, poly mat, racine )
        8PICK 
	IT :: DUP DO>STR APPEND_SPACE 1GETLAM DO>STR &$ DISPROW7 ;
	1GETLAM
        ( , pmin, {vectp}, autres rac, poly mat, racine, multiplicite )
        #1=case
        :: ( , pmin, {vectp}, autres rac, poly mat, racine )
           2DUP mpmultflag SetUserFlag HORNext 
	   UNROT2DROP
           ( , pmin, {vectp}, autres rac, poly mat, racine, matrice-col )
           TRANext AXLext INNERCOMP
           [BEGIN]
                  #1-SWAP DUP TRIMext { %0 } EQUAL
                  ( recherche 1 ligne non nulle )
           [WHILE]
                  DROP
           [REPEAT]
           5GETLAM EVAL
           OVER#2+UNROL NDROP
           ( , pmin, {vectp}, autres rac, poly mat, racine, vectp )
           SWAP DO>STR >TAG 4ROLL SWAP >TCOMP UNROTSWAP
           ( , pmin, {vectp}, poly mat, autres rac )
           ;
        ( pile = det[A], A^-1, flag1, valp, pcar, pmin, {vectp}, autres rac, poly mat, r )
        ( LAM4= taille de la pile des P[] )
        ( LAM3= nombre de vecteurs caract\'eristiques trouv\'es )
        ( LAM2= nombre de vecteurs propres trouv\'es )
        ( LAM1= dimension de l'espace caract\'eristique )
        2DUP 1GETLAM
        ZERO_DO (DO)
                mpmultflag SetUserFlag HORNext TRANext AXLext UNROT
                LOOP
        ( P[r], ..., P|k-1|[r], P|k|, r )
        2DROP 1GETLAM ROLL
        1GETLAM 4PUTLAM ( taille de la pile des P )
        ZEROZERO 2PUTLAM 3PUTLAM NULL{} 1GETLAM #1+UNROLL
        ( nombre de vecteurs propres, de vecteurs caract. )
        ONEONE
        ( pile = null{}, P'[r], ..., P|k-1|[r], P[r], #1, #1 )
        ( algorithme de recherche des cycles de Jordan )
        ( null{}, matrices de la pile, matrice, l, c -> {vectcarac} )
        BEGIN
             ( vectc, matrices de la pile, matrice, l, c )
             3GETLAM 1GETLAM #<
        WHILE
             8GETLAM EVAL
             ( PIVOT )
             ( #0= pas de pivot trouv\'e, #1= ELEM, #2= EXL )
**** BUG dans pivot, si il est dans la dernier colonne, il peut manquer
**** des inversions
             DUP#0=csedrp
             :: ( rechercher les cycles )
                ( ajuster 2,3,4PUTLAM )
                ( recr\'eer la matrice du niveau 1 de la pile )
                ( stack=vectc, pile, matrice )
                ( \'elimine les lignes nulles de la matrice )
                DUPINCOMP
                BEGIN
                     SWAP ELMGext DUP TRIMext { %0 } EQUAL
                     ROTDUP 2GETLAM #> ROTAND
                WHILE
                     SWAP DROP#1-
                REPEAT
                DUPDUP #2+UNROLL {}N SWAP
                ( vectc, pile, vecteurs propres, #vect )
                DUP#0=IT ::	( matrice nulle -> diviser le polynome minimal )
				4GETLAM #8+ ROLL 4GETLAM #5+ PICK
				mpmultflag ClrUserFlag HORNext 
				2DROP 4GETLAM #8+ UNROLL
				;
                2GETLAM
                2DUP#>
                ITE :: 	( vectc, pile, vecteurs propres, #vectp, #old_vectp )
			OVERSWAP #- 4GETLAM #* 3GETLAM #+ 3PUTLAM
			( vectc, pile, vecteurs propres, #vect )
			2PUTLAM
			4GETLAM #2+ROLL 2GETLAM
			#1+_ONE_DO (DO)
				( \'ecrire cycles de Jordan trouv\'es )
				4GETLAM
				( pile, vect propres, vectc, #vect )
				DUP#1= ITE_DROP
				:: ONE_DO (DO)
					( pile, vect propres, vectc )
					INDEX@ #3+PICK
					JINDEX@ NTHCOMPDROP
					5GETLAM EVAL ( simplification )
					", Char: " >TAG apndvarlst
				   LOOP
				   ;
				( pile, vect propres, vectc )
				OVER INDEX@ NTHCOMPDROP ", Eigen:" >TAG apndvarlst
				( pile, vecteurs propres, vectc )
			LOOP
			4GETLAM #2+UNROLL
			( vectc, pile, vecteurs propres )
			;
                     2DROP
                ( vectc, pile, [vecteurs propres] )
                ( recr\'eer la pile de matrices en d\'ecalant )
                SWAPDROP 4GETLAM #1- DUPDUP 4PUTLAM 
		( vectc, P'[r], ..., P|k-1|[r], vectp, #k-1, #k-1 )
		DUP#0=case ROTDROP
		ZERO_DO (DO)
			get1
			( vectc, P|2|[r], ..., P|k-1|[r], vectp, #k-1, P'[r] )
			DUPONE 2GETLAM SUBCOMP 4UNROLL
			( vectc, P|2|[r], ..., P|k-1|[r], antecedents, vectp, #k-1, P'[r] )
			DUPLENCOMP 2GETLAM #1+SWAP SUBCOMP ROTSWAP &COMP
			( vectc, P|2|[r], ..., P|k-1|[r], antecedents, #k-1, P'[r] )
			UNROT
			LOOP
		( vectc, P'[r], ..., P|k-1|[r], antecedents, #k-1 )
		get1 UNROT2DROP
                ( vectc, P|2|[r],..., P|k-1|[r], P'[r] )
		ONEONE
                ;
             #2= IT :: ( changes de lignes sur 4GETLAM matrices )
                       ( vectc, pile, mat, l, c, l1, l2 )
                       4GETLAM DUP #5+ SWAP
                       ZERO_DO (DO)
                               ( vectc, pile, l, c, l1, l2, # )
                               6ROLL 2OVER NULL{} 7GETLAM EVAL
                               DROPOVER UNROLL
                               LOOP
                       3DROP
                       ;
             ( manipulations lmentaires de lignes )
             ( vectc, pile, l, c )
             3PICK 3PICK NTHCOMPDROP OVER NTHCOMPDROP RNEGext
             ( vectc, pile, l, c, pivot )
             4PICK LENCOMP #1+ 4PICK #1+
                   DO
                   DUP 5PICK INDEX@ NTHCOMPDROP 4PICK NTHCOMPDROP
                   ( vectc, pile, l, c, pivot, pivot, element )
                   INDEX@ SWAP 6PICK FOUR {}N
                   ( vectc, pile, l, c, pivot, ELEM )
                   4GETLAM DUP #5+ SWAP
                   ZERO_DO (DO)
                           ( vectc, pile, l, c, pivot, ELEM , # )
                           6ROLL 3PICK ' DROP NULL{} 6GETLAM EVAL
                           DROPOVER UNROLL
                           LOOP
                   2DROP
                   ( vectc, pile, l, c, pivot )
                   LOOP
             DROP #1+SWAP #1+SWAP
             ( vectc, pile, l, c )
        REPEAT
        ( fin de la recherche des cycles de Jordan )
        2DROP 4GETLAM NDROP
        ( , pmin, {vectp}, autres rac, poly mat, racine, {vectc} )
        SWAP DO>STR
        ( ..., { vectc }, tag )
        SWAPINCOMP get1 SWAPDUP
        ( ..., vectc1,..., vectck, tag, #k, #k )
        ZERO_DO (DO)
                ( vectc1,..., vectck, tag, #k )
                get1 xOBJ> 4PICK SWAP&$ >TAG UNROT
                LOOP
        SWAPDROP {}N
        ( , pmin, {vectp}, autres rac, poly mat, {vectc} )
        4ROLLSWAP &COMP UNROTSWAP
        ( , pmin, {vectp}, poly mat, autres rac )
   REPEAT
   ( [det[A], A^-1], flag1, valp, pcar, pmin, {vectp}, poly mat, null{} )
   DROP 5UNROLL 4ROLL
   ( [det[A], A^-1], flag1, poly mat, pcar, pmin, {vectp}, valp )
   ABND
   mpmultflag ClrUserFlag
   displayflag 7ROLL ITE SetUserFlag DROP
   { THREE ONE ONE TWO ONE }
   FROMLISText
   ;
;
*ASSEMBLE
*DIAG        CON(5) (DIAG)-(DIAGdeb)+2
