* -*- mode:Mail -*-
        TITLE Essai utilisant la librairie ALGB
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h
INCLUDE alhash.h
	
* Rpertoire QUADR

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )

*******************************************************************
***************     QXA
            CON(2) ((QXAfin)-(QXAdeb))/2
QXAdeb   NIBASC /QXA/
QXAfin   CON(2) ((QXAfin)-(QXAdeb))/2
RPL
:: ( symb -> matrice )
CK1NOLASTWD
DUPTYPESYMB? 
ITE :: LVARext INNERCOMP reversym {}N VXXLext ; 
    :: CK2NOLASTWD OVER TYPESYMB? NcaseSIZEERR VXXLext internalflag ClrUserFlag ; 
TRIMext OVER LENCOMP
( lvar, quadr-list, #lvar=LAM4 )
       ' :: ( LAM3 objet -> objet dlist )
            BEGIN
                 DUPTYPELIST?
            WHILE
                 DUPLENCOMP #1= NcaseSIZEERR CARCOMP
            REPEAT
            ;
       ' :: ( LAM2 liste, # -> liste )
            SWAP DUPTYPELIST? ?SKIP ONE{}N
            DUPUNROT LENCOMP 2DUP#<
            ( liste, #, longueur de liste , ?#<longueur de liste)
            caseSIZEERR
            #- %0 SWAP NDUPN {}N SWAP &COMP
            ;
       ' :: ( LAM1 algebrique quadratique -> matrice )
            ( { A, 'BY+CZ', reste } )
            THREE 2GETEVAL
            INCOMPDROP
            (  A, 'BY+CZ', reste )
            4GETLAM DUP#1- 4PUTLAM
            #1=case :: %0 EQUAL NcaseSIZEERR
                       %0 EQUAL NcaseSIZEERR
                       %2 RMULText ONE{}N ONE{}N
                       ;
            1GETLAM EVAL
            DUPUNROT LENCOMP
            ( A, matrice, 'BY+CZ', longueur )
            DUPUNROT
            ZERO_DO (DO)
                    ( coef1,..., coefk, #n, lineaire )
                    DUPTYPELIST? ?SKIP ONE{}N TWO 2GETEVAL
                    INCOMPDROP
                    ( coef1,..., coefk, #n, coefk+1, lineaire )
                    SWAP 3GETLAM EVAL UNROT
                    LOOP
            %0 EQUAL NcaseSIZEERR {}N
            ( A, matrice, liste )
            DUPROT
            ( A, liste, liste, matrice )
            TRANext SWAP >HCOMP
            ( A, liste, matrice )
            TRANext UNROTSWAP 3GETLAM EVAL %2 RMULText >HCOMP >HCOMP
            ;
( lvar, quadr-list, prg )
4NULLLAM{} BIND 1GETLAM EVAL ABND
( lvar, matrice-list )
%2 DIVext DROPSWAP
( matrice, lvar )       
;
ASSEMBLE
QXA      CON(5) (QXA)-(QXAdeb)+2
***************    QXA
*******************************************************************

*********************************************************************
*************     AXQ
            CON(2) ((AXQfin)-(AXQdeb))/2
AXQdeb     NIBASC /AXQ/
AXQfin     CON(2) ((AXQfin)-(AXQdeb))/2
RPL
::
CK1NOLASTWD
DTYPENDO?
ITE :: DUPLENCOMP DUP
       #1+_ONE_DO
                 ( x1, ..., xr, #n )
                 "x" INDEX@ UNCOERCE DO>STR &$ $>ID
                 SWAPLOOP
       {}N
       ;
     :: CK2NOLASTWD
        ( endo, lvar )
        SWAP DTYPENDO? NcaseTYPEERR
        ( lvar, endo )
        DUPLENCOMP ROT DUPLENCOMP
        ROT #= NcaseTYPEERR
        ;
( endo, lvar )
SWAP %2 MPMULText
INNERCOMP DUP1LAMBIND NULL{} SWAP
ZERO_DO (DO)
        ( ln, ..., lk, {lk-1, ..., l1} )
        SWAPINCOMP DROP INDEX@ NDROP %2 RDIVext %0 INDEX@ NDUPN DROP
        1GETLAM {}N >HCOMP
        LOOP
ABND
OVER NOSIMPEVALext :: MVMULText XYext ; SIMP1ext
internalflag ClrUserFlag
;
ASSEMBLE
AXQ        CON(5) (AXQ)-(AXQdeb)+2
*****************  AXQ
*********************************************************************


*********************************************************************
*************     GAUSS
dernier     CON(2) ((GAUSSfin)-(GAUSSdeb))/2
GAUSSdeb     NIBASC /GAUSS/
GAUSSfin     CON(2) ((GAUSSfin)-(GAUSSdeb))/2
RPL
::
CK1NOLASTWD
DTYPENDO?
ITE TRUE
    :: DUPTYPESYMB? IT :: LVARext INNERCOMP reversym {}N ;
       CK2NOLASTWD
       ID QXA
       ( matr-liste, lvar )
       OVER
       ( matr-liste, lvar, matr-liste )
       FALSE
       ;
SWAPONE
( flag, matr-liste, #1 )
TOLISText '
 :: DUPLENCOMP #1=case :: INCOMPDROP { { %1 } } ;
     DUP %0 MPMULText OVER EQUALcase :: DUP CARCOMP SWAP ;
     DUPINCOMP reversym DUP#1+ TRUE SWAP
     ( A, l1,...,ln,#n,true, #n+1 )
     ONE_DO (DO)
            ROT INDEX@ NTHCOMPDROP TRIMOBJext %0 EQUAL AND
            ( A, l1, ..., lk, #n, boolean )
            ITE TRUE
                :: INDEX@#- NDROP INDEX@ ExitAtLOOP FALSE ;
            LOOP
     ( A, #k, false ou A, #n, true )
     case :: ( aucun carr trouv )
             UNCOERCE UIDN AXLext DUPUNROT
             ( I, A, I )
             { { %1 } { %-1 %0 } }
             RADDext
             DUPUNROT TRANext MMULText MMULText
             1GETLAM EVAL
             ( I, D, P )
             ROT
             real_intflag UserITE
             { { SYMBOL %-1 %2 U/ ; SYMBOL %1 %2 U/ ; }
               { SYMBOL %-1 %2 U/ ; SYMBOL %-1 %2 U/ ; } }
             { { % -.5 %.5 } { % -.5 % -.5 } }
             RADDext MMULText
             ;
     ( A, #k )
     2DUP NTHCOMPDROP
     ( A, #k, lk )
     DUP3PICK NTHCOMPDROP 4PICK LENCOMP
     ( A, #k, lk, akk, #n )
     ( LAM 4  3    2   1  )
     4NULLLAM{} BIND
     INNERCOMP reversym DROP 4GETLAM ROLLDROP NULL{}
     ( ln, ..., lk+1, lk-1, ..., l1 , {} )
     1GETLAM
     ONE_DO (DO)
            ( ln, ..., lk+1,lk-1,...,lr , {l1,...} )
            SWAPINCOMP reversym 4GETLAM #1+ ROLLDROP
            ( ,{l1,...}, anr,...,ak+1r,ak-1r,...,a1r,#n )
            3GETLAM INDEX@ DUP#1+ 4GETLAM #> IT #1+
            NTHCOMPDROP NULL{} ROT
            ( , anr,...,ak+1r,ak-1r,...,a1r,arr,{},#n )
            ONE_DO (DO)
                   ROT 3PICK 3GETLAM
                   INDEX@ DUP#1+ 4GETLAM #> IT #1+
                   NTHCOMPDROP RMULText
                   2GETLAM RDIVext RSUBext
                   >TCOMP
                   LOOP
            SWAPDROP >TCOMP
            LOOP
     4GETLAM 3GETLAM OVER %1 2GETLAM RDIVext
     ABND
     5ROLL 1GETLAM EVAL
     ( #k, lk, #k, 1/akk , D, P)
     4UNROLL
     ( rajoute stk2 en stk3-ime position de stk1 )
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N
     ( fin de routine )
     4UNROLL
     ( D, #k, lk, P )
     TRANext DUPLENCOMP 4PICK %0 ROT NDUPN {}N ROT
     ( D, #k, lk, #k, {%0}, P )
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N TRANext
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N
     ;
DUP1LAMBIND EVAL ABND
( [matr-liste, lvar], flag_list_input, lvar, D, P )
{ ONE TWO } FROMLISText
ROT ?SEMI
( matr-liste, lvar, D, P )
2DUP 5PICK
( matr-liste, lvar, D, P, D, P, lvar )
SWAPINCOMP get1 NULL{} ROT
ZERO_DO (DO)
        OVER 4ROLL
        ( XYext )
        INNERCOMP #1+ROLL INNERCOMP
        DUP#1= casedrop x*
        get1
        ( y1, ..., yn-1, x1, ..., xn, #n, yn )
        ROT x*
        ( y1, ..., yn-1, x1, ..., xn-1, #n, xn*yn )
        SWAPDUP
        ONE_DO (DO)
               ( y1, ..., yn-k, x1, ..., xn-k, x.y, #n-k+1 )
               get1
               ( y1, ..., yn-k-1, x1, ..., xn-k, x.y, #n-k+1, yn-k )
               ROTSWAP
               ( y1, ..., yn-k-1, x1, ..., xn-k, #n-k+1, x.y, yn-k )
               4ROLL
               ( y1, ..., yn-k-1, x1, ..., #n-k+1, x.y, yn-k, xn-k )
               x* x+ SWAP#1-
               LOOP
               ( X.Y, # )
        DROP
        ( end of XYext )
        >HCOMP
        LOOP
SWAPDROP
( matr-liste, lvar, D, P, D, Dxyz )
INNERCOMP #1+ROLL INNERCOMP DUP #3+ %0 ROT
ZERO_DO (DO)
        ROT 3PICK PICK %2 x^ x* x+
        LOOP
OVER #1- UNROLL #3- NDROP
( matr-liste, lvar, D, P, symb )
5UNROLL 2SWAP 5ROLL
( D, P, matr-liste, lvar, symb )
;
*ASSEMBLE
*GAUSS        CON(5) (GAUSS)-(GAUSSdeb)+2
****************  GAUSS
*********************************************************************
